'===============================================================================
'
'                    Visual Basic API Procedures for PB/DLL
'          Copyright (c) 1996 PowerBASIC, Inc.  All Rights Reserved.
'
' Requires WINAPI.INC to be included in your program as well.
'
'===============================================================================

%VB100_VERSION = &H0100
%VB200_VERSION = &H0200
%VB300_VERSION = &H0300
%VB_VERSION    = %VB300_VERSION

''---------------------------------------------------------------------------
'' Standard control event list
''---------------------------------------------------------------------------

%IEVENT_STD_CLICK             = &H0000
%IEVENT_STD_DBLCLICK          = &H0001
%IEVENT_STD_DRAGDROP          = &H0002
%IEVENT_STD_DRAGOVER          = &H0003
%IEVENT_STD_GOTFOCUS          = &H0004
%IEVENT_STD_KEYDOWN           = &H0005
%IEVENT_STD_KEYPRESS          = &H0006
%IEVENT_STD_KEYUP             = &H0007
%IEVENT_STD_LOSTFOCUS         = &H0008
%IEVENT_STD_MOUSEDOWN         = &H0009
%IEVENT_STD_MOUSEMOVE         = &H000A
%IEVENT_STD_MOUSEUP           = &H000B
%IEVENT_STD_LINKERROR         = &H000C
%IEVENT_STD_LINKOPEN          = &H000D
%IEVENT_STD_LINKCLOSE         = &H000E
%IEVENT_STD_LINKNOTIFY        = &H000F
%IEVENT_STD_LINKCHANGE        = &H0010
%IEVENT_STD_NONE              = &H0FFF
%IEVENT_STD_LAST              = &H0FFF


%PEVENTINFO_STD_CLICK         = NOT %IEVENT_STD_CLICK
%PEVENTINFO_STD_DBLCLICK      = NOT %IEVENT_STD_DBLCLICK
%PEVENTINFO_STD_DRAGDROP      = NOT %IEVENT_STD_DRAGDROP
%PEVENTINFO_STD_DRAGOVER      = NOT %IEVENT_STD_DRAGOVER
%PEVENTINFO_STD_GOTFOCUS      = NOT %IEVENT_STD_GOTFOCUS
%PEVENTINFO_STD_KEYDOWN       = NOT %IEVENT_STD_KEYDOWN
%PEVENTINFO_STD_KEYPRESS      = NOT %IEVENT_STD_KEYPRESS
%PEVENTINFO_STD_KEYUP         = NOT %IEVENT_STD_KEYUP
%PEVENTINFO_STD_LOSTFOCUS     = NOT %IEVENT_STD_LOSTFOCUS
%PEVENTINFO_STD_MOUSEDOWN     = NOT %IEVENT_STD_MOUSEDOWN
%PEVENTINFO_STD_MOUSEMOVE     = NOT %IEVENT_STD_MOUSEMOVE
%PEVENTINFO_STD_MOUSEUP       = NOT %IEVENT_STD_MOUSEUP
%PEVENTINFO_STD_LINKERROR     = NOT %IEVENT_STD_LINKERROR
%PEVENTINFO_STD_LINKOPEN      = NOT %IEVENT_STD_LINKOPEN
%PEVENTINFO_STD_LINKCLOSE     = NOT %IEVENT_STD_LINKCLOSE
%PEVENTINFO_STD_LINKNOTIFY    = NOT %IEVENT_STD_LINKNOTIFY
%PEVENTINFO_STD_LINKCHANGE    = NOT %IEVENT_STD_LINKCHANGE
%PEVENTINFO_STD_NONE          = NOT %IEVENT_STD_NONE
%PEVENTINFO_STD_LAST          = NOT %IEVENT_STD_LAST

'------------------------------------------------------------------------------
' Standard control properties
'------------------------------------------------------------------------------

%IPROP_STD_NAME               = &H0000??
%IPROP_STD_CTLNAME            = %iprop_Std_NAME
%IPROP_STD_INDEX              = &H0001??
%IPROP_STD_HWND               = &H0002??
%IPROP_STD_BACKCOLOR          = &H0003??
%IPROP_STD_FORECOLOR          = &H0004??
%IPROP_STD_LEFT               = &H0005??
%IPROP_STD_TOP                = &H0006??
%IPROP_STD_WIDTH              = &H0007??
%IPROP_STD_HEIGHT             = &H0008??
%IPROP_STD_ENABLED            = &H0009??
%IPROP_STD_VISIBLE            = &H000A??
%IPROP_STD_MOUSEPOINTER       = &H000B??
%IPROP_STD_CAPTION            = &H000C??
%IPROP_STD_FONTNAME           = &H000D??
%IPROP_STD_FONTBOLD           = &H000E??
%IPROP_STD_FONTITALIC         = &H000F??
%IPROP_STD_FONTSTRIKE         = &H0010??
%IPROP_STD_FONTUNDER          = &H0011??
%IPROP_STD_FONTSIZE           = &H0012??
%IPROP_STD_TABINDEX           = &H0013??
%IPROP_STD_PARENT             = &H0014??
%IPROP_STD_DRAGMODE           = &H0015??
%IPROP_STD_DRAGICON           = &H0016??
%IPROP_STD_BORDERSTYLEOFF     = &H0017??
%IPROP_STD_TABSTOP            = &H0018??
%IPROP_STD_TAG                = &H0019??
%IPROP_STD_TEXT               = &H001B??
%IPROP_STD_BORDERSTYLEON      = &H001C??
%IPROP_STD_CLIPCONTROLS       = &H001D??
%IPROP_STD_NONE               = &H001E??
%IPROP_STD_HELPCONTEXTID      = &H001F??
%IPROP_STD_LINKMODE           = &H0020??
%IPROP_STD_LINKITEM           = &H0021??
%IPROP_STD_LINKTOPIC          = &H0022??
%IPROP_STD_LINKTIMEOUT        = &H0023??
%IPROP_STD_LEFTNORUN          = &H0024??
%IPROP_STD_TOPNORUN           = &H0025??
%IPROP_STD_ALIGN              = &H0026??
%IPROP_STD_IMEMODE            = &H0027??
%IPROP_STD_DATASOURCE         = &H0028??
%IPROP_STD_DATAFIELD          = &H0029??
%IPROP_STD_DATACHANGED        = &H002A??
%IPROP_STD_LAST               = &H0FFF??

'------------------------------------------------------------------------------

%PPROPINFO_STD_NAME           = NOT %IPROP_STD_NAME
%PPROPINFO_STD_CTLNAME        = NOT %IPROP_STD_NAME
%PPROPINFO_STD_INDEX          = NOT %IPROP_STD_INDEX
%PPROPINFO_STD_HWND           = NOT %IPROP_STD_HWND
%PPROPINFO_STD_BACKCOLOR      = NOT %IPROP_STD_BACKCOLOR
%PPROPINFO_STD_FORECOLOR      = NOT %IPROP_STD_FORECOLOR
%PPROPINFO_STD_LEFT           = NOT %IPROP_STD_LEFT
%PPROPINFO_STD_TOP            = NOT %IPROP_STD_TOP
%PPROPINFO_STD_WIDTH          = NOT %IPROP_STD_WIDTH
%PPROPINFO_STD_HEIGHT         = NOT %IPROP_STD_HEIGHT
%PPROPINFO_STD_ENABLED        = NOT %IPROP_STD_ENABLED
%PPROPINFO_STD_VISIBLE        = NOT %IPROP_STD_VISIBLE
%PPROPINFO_STD_MOUSEPOINTER   = NOT %IPROP_STD_MOUSEPOINTER
%PPROPINFO_STD_CAPTION        = NOT %IPROP_STD_CAPTION
%PPROPINFO_STD_FONTNAME       = NOT %IPROP_STD_FONTNAME
%PPROPINFO_STD_FONTBOLD       = NOT %IPROP_STD_FONTBOLD
%PPROPINFO_STD_FONTITALIC     = NOT %IPROP_STD_FONTITALIC
%PPROPINFO_STD_FONTSTRIKE     = NOT %IPROP_STD_FONTSTRIKE
%PPROPINFO_STD_FONTUNDER      = NOT %IPROP_STD_FONTUNDER
%PPROPINFO_STD_FONTSIZE       = NOT %IPROP_STD_FONTSIZE
%PPROPINFO_STD_TABINDEX       = NOT %IPROP_STD_TABINDEX
%PPROPINFO_STD_PARENT         = NOT %IPROP_STD_PARENT
%PPROPINFO_STD_DRAGMODE       = NOT %IPROP_STD_DRAGMODE
%PPROPINFO_STD_DRAGICON       = NOT %IPROP_STD_DRAGICON
%PPROPINFO_STD_BORDERSTYLEOFF = NOT %IPROP_STD_BORDERSTYLEOFF
%PPROPINFO_STD_TABSTOP        = NOT %IPROP_STD_TABSTOP
%PPROPINFO_STD_TAG            = NOT %IPROP_STD_TAG
%PPROPINFO_STD_TEXT           = NOT %IPROP_STD_TEXT
%PPROPINFO_STD_BORDERSTYLEON  = NOT %IPROP_STD_BORDERSTYLEON
%PPROPINFO_STD_CLIPCONTROLS   = NOT %IPROP_STD_CLIPCONTROLS
%PPROPINFO_STD_NONE           = NOT %IPROP_STD_NONE
%PPROPINFO_STD_HELPCONTEXTID  = NOT %IPROP_STD_HELPCONTEXTID
%PPROPINFO_STD_LINKMODE       = NOT %IPROP_STD_LINKMODE
%PPROPINFO_STD_LINKITEM       = NOT %IPROP_STD_LINKITEM
%PPROPINFO_STD_LINKTOPIC      = NOT %IPROP_STD_LINKTOPIC
%PPROPINFO_STD_LINKTIMEOUT    = NOT %IPROP_STD_LINKTIMEOUT
%PPROPINFO_STD_LEFTNORUN      = NOT %IPROP_STD_LEFTNORUN
%PPROPINFO_STD_TOPNORUN       = NOT %IPROP_STD_TOPNORUN
%PPROPINFO_STD_ALIGN          = NOT %IPROP_STD_ALIGN
%PPROPINFO_STD_IMEMODE        = NOT %IPROP_STD_IMEMODE
%PPROPINFO_STD_DATASOURCE     = NOT %IPROP_STD_DATASOURCE
%PPROPINFO_STD_DATAFIELD      = NOT %IPROP_STD_DATAFIELD
%PPROPINFO_STD_DATACHANGED    = NOT %IPROP_STD_DATACHANGED
%PPROPINFO_STD_RLAST          = NOT %IPROP_STD_LAST

'------------------------------------------------------------------------------

%pf_fPropArray     = &H00000100
%pf_fSetData       = &H00000200
%pf_fSetMsg        = &H00000400
%pf_fNoShow        = &H00000800
%pf_fNoRuntimeW    = &H00001000
%pf_fGetData       = &H00002000
%pf_fGetMsg        = &H00004000
%pf_fSetCheck      = &H00008000
%pf_fSaveData      = &H00010000
%pf_fSaveMsg       = &H00020000
%pf_fLoadDataOnly  = &H20010000
%pf_fLoadMsgOnly   = &H20020000
%pf_fGetHszMsg     = &H00040000
%pf_fUpdateOnEdit  = &H00080000
%pf_fEditable      = &H00100000
%pf_fPreHwnd       = &H00200000
%pf_fDefVal        = &H00400000
%pf_fNoInitDef     = &H00800000
%pf_fNoRuntimeR    = &H02000000
%pf_fNoMultiSelect = &H04000000

'-- Values for PROPINFO pf_datatype -------------

%dt_HSZ     = &H01??
%dt_SHORT   = &H02??
%dt_Integer = %dt_SHORT
%dt_LONG    = &H03??
%dt_BOOL    = &H04??
%dt_COLOR   = &H05??
%dt_ENUM    = &H06??
%dt_REAL    = &H07??
%dt_XPOS    = &H08??
%dt_XSIZE   = &H09??
%dt_YPOS    = &H0A??
%dt_YSIZE   = &H0B??
%dt_PICTURE = &H0C??
%dt_HLSTR   = &H0D??
%dt_OBJECT  = &H20??

'------------------------------------------------------------------------------
'-- Control Property definitions and structures.

TYPE TEventInfo
  npszName        AS WORD   '
  cParms          AS WORD   '# of parameters
  cwParms         AS WORD   '# words of parameters
  npParmTypes     AS WORD   'list of parameter types
  npszParmProf    AS WORD   'event parameter profile string
  fl              AS LONG   'ef_ flags
END TYPE

'-- PropInfo structure -------------------------

TYPE TPropInfo
  npszName     AS WORD   '
  fl           AS LONG   ' pf_ flags
  offsetData   AS BYTE   ' Offset into static structure
  infoData     AS BYTE   ' 0 or _INFO value for bitfield
  dataDefault  AS LONG   ' 0 or _INFO value for bitfield
  npszEnumList AS WORD   ' For TYPE == dt_ENUM, this is
                         ' a near ptr to a string containing
                         ' all the values to be displayed
                         ' in the popup enumeration listbox.
                         ' Each value is an sz, with an
                         ' empty sz indicated the end of list.
  enumMax      AS BYTE   ' Maximum legal value for enum.
END TYPE

'------------------------------------------------------------------------------

TYPE TModel
  usVersion       AS WORD   'VB version used by control
  fl              AS LONG   'Bitfield structure
  ctlProc         AS DWORD  'the control proc.
  fsClassStyle    AS WORD   'window class style
  flWndStyle      AS LONG   'default window style
  cbCtlExtra      AS WORD   '# bytes alloc'd for HCtl structure
  idBmpPalette    AS WORD   'BITMAP id for tool palette
  DefCtlName      AS WORD   'PSTR;  'default control name prefix
  ClassName       AS WORD   'PSTR;    'Visual Basic class name
  ParentClassName AS WORD   'PSTR;  'Parent window class if subclassed
  propList        AS WORD   'Property list
  eventList       AS WORD   'Event list
  nDefProp        AS BYTE   'index of default property
  nDefEvent       AS BYTE   'index of default event
  nValueProp      AS BYTE   'Index of control value property
END TYPE

%MODEL_fArrows      = &H00000001&
%MODEL_fFocusOk     = &H00000002&
%MODEL_fMnemonic    = &H00000004&
%MODEL_fChildrenOk  = &H00000008&
%MODEL_fInitMsg     = &H00000010&
%MODEL_fLoadMsg     = &H00000020&
%MODEL_fDesInteract = &H00000040&
%MODEL_fInvisAtRun  = &H00000080&
%MODEL_fGraphical   = &H00000100&

'==============================================================================
' Visual Basic messages
'==============================================================================

%VBM__BASE          =  %WM_USER + &H0C00

'' All properties have been loaded.
'' Must set MODEL_fLoadMsg to receive.

%VBM_CREATED        = %VBM__BASE + &H00

'' Form load is complete or dynamic control is fully loaded.
'' Must set MODEL_fLoadMsg to receive.

%VBM_LOADED         = %VBM__BASE + &H01

'' Pre-hwnd properties are not yet loaded=no hwnd exists for control yet.
'' Must set MODEL_fInitMsg to receive.

%VBM_INITIALIZE     = %VBM__BASE + &H02

'' Get a property value.
'' [wp=iprop, lp=pdata], RetVal=ERR

%VBM_GETPROPERTY    = %VBM__BASE + &H03

'' Verify a property value.
'' [wp=iprop, lp=data], RetVal=ERR

%VBM_CHECKPROPERTY  = %VBM__BASE + &H04

'' Set a property value.
'' [wp=iprop, lp=data], RetVal=ERR

%VBM_SETPROPERTY    = %VBM__BASE + &H05

'' Write a property.
'' [wp=iprop, lp=pfileref], RetVal=ERR

%VBM_SAVEPROPERTY   = %VBM__BASE + &H06

'' Read a property.
'' [wp=iprop, lp=pfileref], RetVal=ERR

%VBM_LOADPROPERTY   = %VBM__BASE + &H07

'' Get the string representation of a property.
'' [wp=iprop, lp=HSZ FAR *], RetVal=ERR

%VBM_GETPROPERTYHSZ = %VBM__BASE + &H08

'' Create popup window used to change a property.
'' [wp=iprop, lp=listbox hwnd], RetVal=popup hwnd

%VBM_INITPROPPOPUP  = %VBM__BASE + &H09

'' Determine if Paste/PasteLink is allowed.
'' [wp=PASTETYPE], RetVal=BOOL

%VBM_QPASTEOK       = %VBM__BASE + &H0A

%PT_PASTE           = 0
%PT_PASTELINK       = 1

'' Paste control-specific data from the clipboard.
'' [wp=PASTETYPE], RetVal=ERR

%VBM_PASTE          = %VBM__BASE + &H0B

'' Copy control specific data to the clipboard.

%VBM_COPY           = %VBM__BASE + &H0C

'' Control activated upon receipt of a unique mnemonic key.

%VBM_MNEMONIC       = %VBM__BASE + &H0D

'' Posted to fire a deferred event.
'' [wp=event]

%VBM_FIREEVENT      = %VBM__BASE + &H0E

'' Another control in drag mode drug over the control.
'' [lp=pdraginfo]

%VBM_DRAGOVER       = %VBM__BASE + &H0F

'' This message is sent to a control that has just had another control
'' in drag mode dropped on it.
'' [lp=pdraginfo]

%VBM_DRAGDROP       = %VBM__BASE + &H10

'' This message is sent when certain methods are invoked on controls
'' [wp=METH_, lp=far *alParams], RetVal=ERR

%VBM_METHOD         = %VBM__BASE + &H11

%METH_ADDITEM       = &H0001  '' args are: cArgs, hszItem, [index]
%METH_REMOVEITEM    = &H0002  '' args are: cArgs, index
%METH_REFRESH       = &H0003  '' no args=lp == NULL
%METH_MOVE          = &H0004  '' args are: cArgs, left, [top, [width, [height]]]
%METH_DRAG          = &H0005  '' args are: cArgs, [cmd]
%METH_LINKSEND      = &H0006  '' no args=lp == NULL
%METH_ZORDER        = &H0007  '' args are: cArgs, pos
%METH_CLEAR         = &H000A  '' no args=lp == NULL

'' Clear capture and internal state.

%VBM_CANCELMODE     = %VBM__BASE + &H12

'' Paint notification for graphical controls.
'' [wp=hdc, lp=lprect]

%VBM_PAINT          = %VBM__BASE + &H14

'' Hit test for graphical controls.
'' [lp=lphittest], RetVal = HT_

%VBM_HITTEST        = %VBM__BASE + &H15

%HT_ON              = 7
%HT_SOLID_NEAR      = 6
%HT_PATTERN_NEAR    = 5
%HT_HOLLOW_NEAR     = 4
%HT_SOLID           = 3
%HT_PATTERN         = 2
%HT_HOLLOW          = 1
%HT_MISS            = 0

TYPE tagHITTEST
  pt   AS PointApi   '' Point to test=in parent's coordinates
  rect AS Rect       '' Rect of self=in parent's coordinates
END TYPE

'typedef HITTEST FAR *LPHITTEST;

'' Paint the multi-select handles
'' [wp=hdc, lp=rect(in hdc coords]

%VBM_PAINTMULTISEL  = %VBM__BASE + &H16

'' Paint the "gray rect" or ctl outline while moving/sizing ctl.
'' [wp=hdc, lp=rect(in hdc coords]

%VBM_PAINTOUTLINE   = %VBM__BASE + &H17

'' Palette change notification.
'' [wp=fPalBack(for SelectPalette], RetVal = return from RealizePalette

%VBM_PALETTECHANGED = %VBM__BASE + &H1B

'' Get control palette.
'' RetVal = HPALETTE.

%VBM_GETPALETTE     = %VBM__BASE + &H1C

'' Enumerate available formats.
'' [wp=SUPPLIESDATAFORMAT | ACCEPTSDATAFORMAT]
'' [LOWORD(lp=ennumeration(0-x]

%VBM_LINKENUMFORMATS= %VBM__BASE + &H1E

'' Ask a control for it's LINK item name.  Return item name as lpsz in lp.
'' [wp=LINKSRCASK | LINKSRCTELL]
'' [lp=lpszItemName]

%VBM_LINKGETITEMNAME= %VBM__BASE + &H1F

'' For Server items and client pokes.
'' [wp=wFormat lp=LPLINKDATA]

%VBM_LINKGETDATA    = %VBM__BASE + &H20

'' Used in client requests, advises, and server pokes.
'' [wp=wFormat lp=LPLINKDATA]

%VBM_LINKSETDATA    = %VBM__BASE + &H21

'' Get help on property or event name.
'' [LOBYTE(wp=VBHELP_, HIBYTE(wp=iprop/ievent, lp=lpmodel]

%VBM_HELP           = %VBM__BASE + &H22

%VBHELP_PROP        = &H0001
%VBHELP_EVT         = &H0002
%VBHELP_CTL         = &H0003

'' Get default size of control
'' LOWORD(RetVal=cx, HIWORD(RetVal=cy

%VBM_GETDEFSIZE   = %VBM__BASE + &H23

'' Just like VBM_SAVE(LOADPROPERTY, but saves=loads as text.

%VBM_SAVETEXTPROPERTY = %VBM__BASE + &H24
%VBM_LOADTEXTPROPERTY = %VBM__BASE + &H25

'' Is char a mnemonic for this control?
'' [wp=char] RetVal=TRUE/FALSE

%VBM_ISMNEMONIC   = %VBM__BASE + &H26

'' Does control want to see WM_KEYUP/WM_KEYDOWN for vk?  Sent only
'' for keys which are normally trapped by VB.  E.g. Tab, Enter, etc.
'' [wp=vk] RetVal=TRUE/FALSE

%VBM_WANTSPECIALKEY = %VBM__BASE + &H27

''Notifies a control that it has been selected in the property window.
''[wp=multiselect ON=TRUE or OFF=FALSE]
''[LOWORD(lp=multiselect count=0 first, n last]

%VBM_SELECTED       = %VBM__BASE + &H28

'' Bound control interface

%VBM_DATA_INITIATE  = %VBM__BASE + &H29
%VBM_DATA_TERMINATE = %VBM__BASE + &H2A

%VBM_DATA_AVAILABLE = %VBM__BASE + &H2B
%VBM_DATA_GET       = %VBM__BASE + &H2C
%VBM_DATA_REQUEST   = %VBM__BASE + &H2D
%VBM_DATA_SET       = %VBM__BASE + &H2E
%VBM_DATA_METHOD    = %VBM__BASE + &H2F


'' Notifications reflected back to control from parent.

%VBN__BASE          = %VBM__BASE + &H1000

%VBN_COMMAND        = %VBN__BASE + %WM_COMMAND
%VBN_CTLCOLOR       = %VBN__BASE + %WM_CTLCOLOR
%VBN_DRAWITEM       = %VBN__BASE + %WM_DRAWITEM
%VBN_MEASUREITEM    = %VBN__BASE + %WM_MEASUREITEM
%VBN_DELETEITEM     = %VBN__BASE + %WM_DELETEITEM
%VBN_VKEYTOITEM     = %VBN__BASE + %WM_VKEYTOITEM
%VBN_CHARTOITEM     = %VBN__BASE + %WM_CHARTOITEM
%VBN_COMPAREITEM    = %VBN__BASE + %WM_COMPAREITEM
%VBN_HSCROLL        = %VBN__BASE + %WM_HSCROLL
%VBN_VSCROLL        = %VBN__BASE + %WM_VSCROLL
%VBN_PARENTNOTIFY   = %VBN__BASE + %WM_PARENTNOTIFY

'==============================================================================

%color_DefBitOn = &H80000000???

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' rgbColor
'
FUNCTION rgbColor(BYVAL Color AS LONG) AS LONG

  IF (Color AND %color_DefBitOn) <> 0 THEN
    FUNCTION = GetSysColor(Color and &H0FFFF)
  ELSE
    FUNCTION = Color AND &H0FFFFFF???
  END IF

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Return the version of the Visual Basic runtime library.
'
FUNCTION vbGetVersion() AS INTEGER

  DIM VbPTR AS GLOBAL DWORD

  ! cmp     WORD PTR SS:[&H020], &H0BC
  ! jne     GetVbVersion
  ! mov     AX, &H0100
  ! jmp     Short Version1
GetVbVersion:
  ! mov     BX, &H0BC
  ! call    DWORD PTR SS:[&H020]
Version1:
  ! mov     FUNCTION, AX

END FUNCTION


'==============================================================================
'                        Control management functions
'==============================================================================

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Returns far pointer to Control's "programmer defined structure".
'
FUNCTION vbDerefControl(BYVAL hCtl AS DWORD) AS DWORD

  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]

  ! mov     BX, &H04
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Performs default message processing for VB application.
'
FUNCTION vbDefControlProc(BYVAL hCtl AS DWORD, BYVAL hWnd AS INTEGER, _
                          BYVAL Msg AS WORD, BYVAL wp AS WORD, _
                          BYVAL lp AS DWORD) AS DWORD

  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]
  ! push    WORD PTR hWnd
  ! push    WORD PTR Msg
  ! push    WORD PTR wp
  ! push    WORD PTR lp[2]
  ! push    WORD PTR lp[0]

  ! mov     BX, &H08
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Registers a new control type.
'
FUNCTION vbRegisterModel(BYVAL hMod AS INTEGER, lpModel AS TModel) AS WORD

  ! push    WORD PTR hMod
  ! push    WORD PTR lpModel[2]
  ! push    WORD PTR lpModel[0]

  ! mov     BX, &H0
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbGetControlHwnd
'
FUNCTION vbGetControlHwnd(BYVAL hCtl AS DWORD) AS INTEGER

  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]

  ! mov     BX, &H02C
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbGetHInstance
'
FUNCTION vbGetHInstance() AS INTEGER

  ! mov     BX, &H030
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbGetControlModel
'
FUNCTION vbGetControlModel(BYVAL hCtl AS DWORD) AS DWORD

  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]

  ! mov     BX, &H034
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbGetControlName
'
FUNCTION vbGetControlName(BYVAL hCtl AS DWORD, lpszName AS ASCIIZ) AS DWORD

  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]
  ! push    WORD PTR lpszName[2]
  ! push    WORD PTR lpszName[0]

  ! mov     BX, &H0A8
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbGetHwndControl
'
FUNCTION vbGetHwndControl(BYVAL Wnd AS INTEGER) AS DWORD

  ! push    WORD PTR Wnd

  ! mov     BX, &H064
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbSendControlMsg
'
FUNCTION vbSendControlMsg(BYVAL hCtl AS DWORD, BYVAL Msg AS WORD, _
                          BYVAL wParam AS WORD, BYVAL lParam AS DWORD) AS DWORD

  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]
  ! push    WORD PTR Msg
  ! push    WORD PTR wParam
  ! push    WORD PTR lParam[2]
  ! push    WORD PTR lParam[0]

  ! mov     BX, &H038
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbSuperControlProc
'
FUNCTION vbSuperControlProc(BYVAL hCtl AS DWORD, BYVAL Msg AS WORD, _
                            BYVAL wParam AS WORD, BYVAL lParam AS DWORD) AS DWORD

  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]
  ! push    WORD PTR Msg
  ! push    WORD PTR wParam
  ! push    WORD PTR lParam[2]
  ! push    WORD PTR lParam[0]

  ! mov     BX, &H044
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbRecreateControlHwnd
'
FUNCTION vbRecreateControlHwnd(BYVAL hCtl AS DWORD) AS WORD

  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]

  ! mov     BX, &H030
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'
SUB vbDirtyForm(BYVAL hCtl AS DWORD)

  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]

  ! mov     BX, &H0C8
  ! call    DWORD PTR SS:[&H020]

END SUB


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbSetErrorMessage
'
FUNCTION vbSetErrorMessage(BYVAL zError AS WORD, BYVAL zStr AS DWORD) AS WORD

  ! push    WORD PTR zError
  ! push    WORD PTR zStr[2]
  ! push    WORD PTR zStr[0]

  ! mov     BX, &H094
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbGetAppTitle
'
SUB vbGetAppTitle(BYVAL zStr AS DWORD, cbMax AS WORD)

  ! push    WORD PTR zStr[2]
  ! push    WORD PTR zStr[0]
  ! push    WORD PTR cbMax

  ! mov     BX, &H098
  ! call    DWORD PTR SS:[&H020]

END SUB


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' VBDialogBoxParam
'
FUNCTION vbDialogBoxParam(BYVAL hInst        AS INTEGER, _
                          szTemplateName     AS ASCIIZ, _
                          BYVAL lpDialogFunc AS DWORD, _
                          BYVAL lParm        AS LONG) AS INTEGER

  ! push    WORD PTR hInst
  ! push    WORD PTR szTemplateName[2]
  ! push    WORD PTR szTemplateName[0]
  ! push    WORD PTR lpDialogFunc[2]
  ! push    WORD PTR lpDialogFunc[0]
  ! push    WORD PTR lParm[2]
  ! push    WORD PTR lParm[0]

  ! mov     BX, &H09C
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' VBSetControlFlags
'
FUNCTION vbSetControlFlags(BYVAL hCtl AS DWORD, BYVAL Mask AS DWORD, _
                           BYVAL Value AS DWORD) AS DWORD


  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]
  ! push    WORD PTR Mask[2]
  ! push    WORD PTR Mask[0]
  ! push    WORD PTR Value[2]
  ! push    WORD PTR Value[0]

  ! mov     BX, &H0CC
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' VBGetCapture
'
FUNCTION vbGetCapture() AS DWORD

  ! mov     BX, &H0E0
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' VBSetCapture
'
SUB vbSetCapture(BYVAL hCtl AS DWORD)

  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]

  ! mov     BX, &H0E0
  ! call    DWORD PTR SS:[&H020]

END SUB


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' VBReleaseCapture
'
SUB vbReleaseCapture()

  ! mov     BX, &H0E8
  ! call    DWORD PTR SS:[&H020]

END SUB


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' VBMoveControl
'
SUB vbMoveControl(BYVAL hCtl AS DWORD, lpRect AS RECT, BYVAL fRepaint AS INTEGER)

  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]
  ! push    WORD PTR lpRect[2]
  ! push    WORD PTR lpRect[0]
  ! push    WORD PTR fRepaint

  ! mov     BX, &H0F4
  ! call    DWORD PTR SS:[&H020]

END SUB


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' VBGetControlRect
'
SUB vbGetControlRect(BYVAL hCtl AS DWORD, lpRect AS RECT)

  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]
  ! push    WORD PTR lpRect[2]
  ! push    WORD PTR lpRect[0]

  ! mov     BX, &H0F8
  ! call    DWORD PTR SS:[&H020]

END SUB


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' VBGetRectInContainer
'
SUB vbGetRectInContainer(BYVAL hCtl AS DWORD, lpRect AS RECT)

  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]
  ! push    WORD PTR lpRect[2]
  ! push    WORD PTR lpRect[0]

  ! mov     BX, &H0FC
  ! call    DWORD PTR SS:[&H020]

END SUB

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' VBGetClientRect
'
SUB vbGetClientRect(BYVAL hCtl AS DWORD, lpRect AS RECT)

  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]
  ! push    WORD PTR lpRect[2]
  ! push    WORD PTR lpRect[0]

  ! mov     BX, &H100
  ! call    DWORD PTR SS:[&H020]

END SUB

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' VBClientToScreen
'
SUB vbClientToScreen(BYVAL hCtl AS DWORD, lpPt AS POINTAPI)

  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]
  ! push    WORD PTR lpPt[2]
  ! push    WORD PTR lpPt[0]

  ! mov     BX, &H104
  ! call    DWORD PTR SS:[&H020]

END SUB


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' VBScreenToClient
'
SUB vbScreenToClient(BYVAL hCtl AS DWORD, lpPt AS POINTAPI)

  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]
  ! push    WORD PTR lpPt[2]
  ! push    WORD PTR lpPt[0]

  ! mov     BX, &H108
  ! call    DWORD PTR SS:[&H020]

END SUB


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' VBIsControlVisible
'
FUNCTION vbIsControlVisible(BYVAL hCtl AS DWORD) AS INTEGER

  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]

  ! mov     BX, &H10C
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' VBIsControlEnabled
'
FUNCTION vbIsControlEnabled(BYVAL hCtl AS DWORD) AS INTEGER

  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]

  ! mov     BX, &H110
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' VBInvalidateRect
'
SUB vbInvalidateRect(BYVAL hCtl AS DWORD, lpRect AS RECT, _
                     BYVAL fEraseBkGnd AS INTEGER)

  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]
  ! push    WORD PTR lpRect[2]
  ! push    WORD PTR lpRect[0]
  ! push    WORD PTR fErasebkGnd

  ! mov     BX, &H114
  ! call    DWORD PTR SS:[&H020]

END SUB


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' VBUpdateControl
'
SUB vbUpdateControl(BYVAL hCtl AS DWORD)

  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]

  ! mov     BX, &H118
  ! call    DWORD PTR SS:[&H020]

END SUB


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' VBGetControl
'
FUNCTION vbGetControl(BYVAL hCtl AS DWORD, BYVAL gc AS WORD) AS DWORD

  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]
  ! push    WORD PTR gc

  ! mov     BX, &H0EC
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' VBSetControlProperty
'
FUNCTION vbSetControlProperty (BYVAL hCtl AS DWORD, BYVAL idProp AS WORD, _
                               BYVAL lpData AS LONG) AS WORD
  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]
  ! push    WORD ptr idProp
  ! push    WORD PTR lpData[2]
  ! push    WORD PTR lpData[0]

  ! mov     BX, &H010
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbGetControlProperty
'
FUNCTION vbGetControlProperty(BYVAL hCtl AS DWORD, BYVAL IdProp AS WORD, _
                              BYVAL pData AS DWORD) AS WORD

  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]
  ! push    WORD PTR IdProp
  ! push    WORD PTR pData[2]
  ! push    WORD PTR pData[0]

  ! mov     BX, &H014
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbFireEvent
'
FUNCTION vbFireEvent(BYVAL hCtl AS DWORD, BYVAL ldEvent AS WORD, _
                     BYVAL lpParams AS DWORD) AS WORD


  ! push    WORD PTR hCtl[2]
  ! push    WORD PTR hCtl[0]
  ! push    WORD PTR ldEvent
  ! push    WORD PTR lpParams[2]
  ! push    WORD PTR lpParams[0]

  ! mov     BX, &H0C
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION


'==============================================================================
'         Management of dynamically allocated C-style strings (HSZ)
'==============================================================================

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'
FUNCTION vbCreateHsz(BYVAL Control AS DWORD, BYVAL hStr AS DWORD) AS DWORD 'Params changed

  ! push    WORD PTR Control[2]
  ! push    WORD PTR Control
  ! push    WORD PTR hStr[2]
  ! push    WORD PTR hStr

  ! mov     BX, &H018
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'
FUNCTION vbDestroyHsz(BYVAL hszStr AS DWORD) AS DWORD

  ! push    WORD PTR hszStr[2]
  ! push    WORD PTR hszStr

  ! mov     BX, &H01C
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'
FUNCTION vbDerefHsz(BYVAL hszStr AS DWORD) AS DWORD

  ! push    WORD PTR hszStr[2]
  ! push    WORD PTR hszStr

  ! mov     BX, &H020
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'
FUNCTION vbLockHsz(BYVAL hszStr AS DWORD) AS DWORD

  ! push    WORD PTR hszStr[2]
  ! push    WORD PTR hszStr

  ! mov     BX, &H024
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'
SUB vbUnlockHsz(BYVAL hszStr AS DWORD)

  ! push    WORD PTR hszStr[2]
  ! push    WORD PTR hszStr

  ! mov     BX, &H028
  ! call    DWORD PTR SS:[&H020]

END SUB

'==============================================================================
'                   Management of language strings (HLSTR)
'==============================================================================

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Create a Visual Basic string and return a handle.
'
FUNCTION vbCreateHlStr(BYVAL buffer AS DWORD, BYVAL length AS WORD) AS DWORD

  ! push    WORD PTR buffer[2]
  ! push    WORD PTR buffer
  ! push    WORD PTR length

  ! mov     BX, &H050
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbCreateTempHlStr
'
FUNCTION vbCreateTempHlStr(BYVAL buffer AS DWORD, BYVAL length AS WORD) AS DWORD

  ! push    WORD PTR Buffer[2]
  ! push    WORD PTR Buffer
  ! push    WORD PTR Length

  ! mov     BX, &H013C
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbDestroyHlStr
'
FUNCTION vbDestroyHlStr(BYVAL buffer AS DWORD) AS WORD

  ! push    WORD PTR buffer[2]
  ! push    WORD PTR buffer

  ! mov     BX, &H01C
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[0], AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Return a 32-bit pointer to a Visual Basic string's buffer.
'
FUNCTION vbDerefHlStr(BYVAL HlStr AS DWORD) AS DWORD

  ! push    WORD PTR HlStr[2]
  ! push    WORD PTR HlStr

  ! mov     BX, &H05C
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Return a 32-bit pointer to a Visual Basic string's buffer and its length.
'
FUNCTION vbDerefHlStrLen(BYVAL HlStr AS DWORD, Length AS INTEGER) AS DWORD

  ! push    WORD PTR HlStr[2]
  ! push    WORD PTR HlStr
  ! push    WORD PTR Length[2]
  ! push    WORD PTR Length

  ! mov     BX, &H0134
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbDerefZeroTermHlStr
'
FUNCTION vbDerefZeroTermHlStr(BYVAL HlStr AS DWORD) AS DWORD

  ! push    WORD PTR HlStr[2]
  ! push    WORD PTR HlStr

  ! mov     BX, &H0138
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'
FUNCTION vbGetHlStr(BYVAL HlStr AS DWORD, BYVAL pb AS DWORD, BYVAL cbLen AS WORD ) AS WORD

  ! push    WORD PTR HlStr[2]
  ! push    WORD PTR HlStr
  ! push    WORD PTR pb[2]
  ! push    WORD PTR pb
  ! push    WORD PTR cbLen

  ! mov     BX, &H012C
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Return the length a Visual Basic string's as a word
'
FUNCTION vbGetHlStrLen(BYVAL HlStr AS DWORD) AS WORD

  ! push    WORD PTR HlStr[2]
  ! push    WORD PTR HlStr

  ! mov     BX, &H060
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Assigns a new string value to an existing VB string
'
FUNCTION vbSetHlstr(BYVAL HlStr AS DWORD, BYVAL pBuff AS DWORD, BYVAL cbLen AS WORD) AS WORD

  DIM lpHlStr AS DWORD

  lpHlStr = VARPTR(HlStr)

  ! push    WORD PTR lpHlStr[2]
  ! push    WORD PTR lpHlStr
  ! push    WORD PTR pBuff[2]
  ! push    WORD PTR pBuff
  ! push    WORD PTR cbLen

  ! mov     BX, &H054
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'
FUNCTION vbResizeHlstr(BYVAL HlStr AS DWORD, BYVAL newCbLen AS WORD) AS WORD

  ! push    WORD PTR HlStr[2]
  ! push    WORD PTR HlStr
  ! push    WORD PTR NewCbLen

  ! mov     BX, &H130
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION

'==============================================================================
'                  Management of language Variant data TYPE
'==============================================================================

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbCoerceVariant
'
FUNCTION vbCoerceVariant(BYVAL pVariant AS DWORD, BYVAL vType AS INTEGER, lpData AS DWORD) AS WORD

  ! push    WORD PTR pVariant[2]
  ! push    WORD PTR pVariant
  ! push    WORD PTR vType
  ! push    WORD PTR lpData[2]
  ! push    WORD PTR lpData

  ! mov     BX, &H11C
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbGetVariantType
'
FUNCTION vbGetVariantType(BYVAL pVariant AS DWORD) AS INTEGER

  ! push    WORD PTR pVariant[2]
  ! push    WORD PTR pVariant

  ! mov     BX, &H120
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbGetVariantValue
'
FUNCTION vbGetVariantValue(BYVAL pVariant AS DWORD, pValue AS DWORD) AS INTEGER

  ! push    WORD PTR pVariant[2]
  ! push    WORD PTR pVariant
  ! push    WORD PTR pValue[2]
  ! push    WORD PTR pValue

  ! mov     BX, &H124
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbSetVariantValue
'
FUNCTION vbSetVariantValue(BYVAL pVariant AS DWORD, BYVAL vType AS INTEGER, _
                           lpData AS DWORD) AS WORD

  ! push    WORD PTR pVariant[2]
  ! push    WORD PTR pVariant
  ! push    WORD PTR vType
  ! push    WORD PTR lpData[2]
  ! push    WORD PTR lpData

  ! mov     BX, &H128
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION

'==============================================================================
'                       Management of language arrays
'==============================================================================

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Returns: Array bounds in a DWORD
'          LowWord  is the lower bound
'          HighWord is the upper bound
'
FUNCTION vbArrayBounds(BYVAL VBArray AS DWORD, BYVAL cIndex AS INTEGER ) AS DWORD

  %AB_INVALIDINDEX = 1  ' VbArray OR cIndex is bad

  ! push    WORD PTR VbArray[2]
  ! push    WORD PTR VbArray[0]
  ! push    WORD PTR cIndex

  ! mov     BX, &H0144
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'Returns: a pointer to the value of the specified element
'
FUNCTION vbArrayElement(BYVAL VbArray AS DWORD, BYVAL cIndex AS INTEGER, _
                        lpi AS INTEGER) AS DWORD

  ! push    WORD PTR VbArray[2]
  ! push    WORD PTR VbArray[0]
  ! push    WORD PTR cIndex
  ! push    WORD PTR lpi[2]
  ! push    WORD PTR lpi[0]

  ! mov     BX, &H0140
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Returns the size of an array element
'
FUNCTION vbArrayElemSize(BYVAL VBArray AS DWORD) AS WORD

  ! push    WORD PTR VbArray[2]
  ! push    WORD PTR VbArray[0]

  ! mov     BX, &H0148
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Returns a pointer to the first element of an array
'
FUNCTION vbArrayFirstElem(BYVAL VBArray AS DWORD) AS DWORD

  ! push    WORD PTR VbArray[2]
  ! push    WORD PTR VbArray[0]

  ! mov     BX, &H014C
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Returns the number of indexes for a VB array
'
FUNCTION vbArrayIndexCount(BYVAL VBArray AS DWORD) AS INTEGER


  ! push    WORD PTR VbArray[2]
  ! push    WORD PTR VbArray[0]

  ! mov     BX, &H0150
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION

'==============================================================================
'                             File I/O functions
'==============================================================================

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbReadFormFile
'
FUNCTION vbReadFormFile(BYVAL HFormFile AS DWORD, BYVAL pb AS DWORD, _
                        BYVAL cb AS WORD) AS WORD

  ! push    WORD PTR hFormFile[2]
  ! push    WORD PTR hFormFile[0]
  ! push    WORD PTR pb[2]
  ! push    WORD PTR pb[0]
  ! push    WORD PTR cb

  ! mov     BX, &H03C
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbWriteFormFile
'
FUNCTION vbWriteFormFile(BYVAL HFormFile AS DWORD, BYVAL pb AS DWORD, _
                         BYVAL cb AS WORD) AS WORD

  ! push    WORD PTR hFormFile[2]
  ! push    WORD PTR hFormFile[0]
  ! push    WORD PTR pb[2]
  ! push    WORD PTR pb[0]
  ! push    WORD PTR cb

  ! mov     BX, &H040
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbSeekFormFile
'
FUNCTION vbSeekFormFile(BYVAL FormFile AS DWORD, BYVAL OffSet AS LONG) AS LONG

  ! push    WORD PTR FormFile[2]
  ! push    WORD PTR FormFile[0]
  ! push    WORD PTR Offset[2]
  ! push    WORD PTR Offset[0]

  ! mov     BX, &H0A0
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbRelSeekFormFile
'
FUNCTION vbRelSeekFormFile(BYVAL FormFile AS DWORD, BYVAL OffSet AS LONG) AS LONG

  ! push    WORD PTR FormFile[2]
  ! push    WORD PTR FormFile[0]
  ! push    WORD PTR Offset[2]
  ! push    WORD PTR Offset[0]

  ! mov     BX, &H0A4
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbReadBasicFile
'
FUNCTION vbReadBasicFile(BYVAL UsFileNo AS WORD, BYVAL pb AS DWORD, _
                         BYVAL cb AS WORD) AS WORD

  ! push    WORD PTR UsFileNo
  ! push    WORD PTR pb[2]
  ! push    WORD PTR pb[0]
  ! push    WORD PTR cb

  ! mov     BX, &H078
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbWriteBasicFile
'
FUNCTION vbWriteBasicFile(BYVAL UsFileNo AS WORD, BYVAL pb AS DWORD, _
                         BYVAL cb AS WORD) AS WORD

  ! push    WORD PTR UsFileNo
  ! push    WORD PTR pb[2]
  ! push    WORD PTR pb[0]
  ! push    WORD PTR cb

  ! mov     BX, &H07C
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION

'==============================================================================
'                            Conversion functions
'==============================================================================

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbXPixelsToTwips
'
FUNCTION vbXPixelsToTwips(BYVAL Pixels AS INTEGER) AS LONG

  ! push    WORD PTR Pixels

  ! mov     BX, &H068
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbYPixelsToTwips
'
FUNCTION vbYPixelsToTwips(BYVAL Pixels AS INTEGER) AS LONG

  ! push    WORD PTR Pixels

  ! mov     BX, &H06C
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION[2], DX
  ! mov     FUNCTION[0], AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbXTwipsToPixels
'
FUNCTION vbXTwipsToPixels(BYVAL Twips AS LONG) AS INTEGER

  ! push    WORD PTR Twips[2]
  ! push    WORD PTR Twips[0]

  ! mov     BX, &H070
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' vbYTwipsToPixels
'
FUNCTION vbYTwipsToPixels(BYVAL Twips AS LONG) AS INTEGER

  ! push    WORD PTR Twips[2]
  ! push    WORD PTR Twips[0]

  ! mov     BX, &H070
  ! call    DWORD PTR SS:[&H020]

  ! mov     FUNCTION, AX

END FUNCTION

'==============================================================================
'                        String conversion functions
'==============================================================================

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Convert a Visual Basic string to a PB/DLL String.
'
FUNCTION vbStringToPb(BYVAL HlStr AS DWORD) AS STRING

  DIM Length   AS INTEGER
  DIM VbStrPtr AS DWORD

  VbStrPtr = vbDerefHlStrLen(HlStr, Length)
  IF VbStrPtr THEN
    FUNCTION = PEEK$(VbStrPtr, Length)
  END IF

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Convert a PowerBASIC string into a Visual Basic string.
'
FUNCTION PbStringToVb(BYVAL pbStr AS STRING) AS DWORD

  DIM Length   AS INTEGER
  DIM PbStrPTR AS DWORD

  Length   = LEN(pbStr)
  PbStrPTR = STRPTR(pbStr)
  FUNCTION = VbCreateTempHlStr(PbStrPTR, Length)

END FUNCTION

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Place the value from a PB string into an existing VB string
'
SUB SetVbString(BYVAL Hlstr AS DWORD, BYVAL pbStr AS STRING)

  DIM Length   AS INTEGER
  DIM PbStrPtr AS DWORD
  DIM VbStrPtr AS DWORD

  Length = LEN(pbStr)

  VbResizeHlstr Hlstr, Length

  IF Length = 0 THEN
    EXIT SUB
  END IF

  PbStrPtr = STRPTR(pbStr)
  VbStrPtr = VbDerefHlstr(Hlstr)

  POKE$ VbStrPtr, PEEK$(PbStrPtr, Length)

END SUB
