'==============================================================================
'
' Disk Access routines for Visual Basic
' Copyright (c) 1996,97 by PowerBASIC, Inc. All Rights Reserved.
'
' Requires the PowerBASIC DLL Compiler for Windows (PB/DLL) version 1.50 or
' later to recompile.
'
'==============================================================================

$COMPILE DLL
$DIM ALL

$INCLUDE "WINAPI.INC"       'include Windows API
$INCLUDE "DPMI.INC"         'and DPMI support

'==============================================================================

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Return the current version of Dos
'
FUNCTION DosVersion () EXPORT AS INTEGER

  ! push DS                      ;

  ! mov  AH, &H30                ; DOS function 30h, get DOS version
  Dos3Call                       ' AL = major, AH = minor
  ! push AX                      ; save it
  ! mov  CL, 100                 ; prepare to multiply AL * 100
  ! mul  CL                      ; AX = AL * 100
  ! pop  BX                      ; get version again
  ! mov  BL, BH                  ; move minor version to BL
  ! mov  BH, 0                   ; clear BH
  ! add  AX, BX                  ; add AX and BX
  ! mov  FUNCTION, AX            ; return Dos Version

  ! pop DS                       ;

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Note:  This function uses an UNDOCUMENTED DOS call which may not work on
'        all systems.  If you get irratic results, then yours is one of those
'        systems which does not support this undocumented call.
'
' Return the serial number for the specified drive
' 1 = A:, 2 = B:, 3 = C:, etc.

FUNCTION DiskSerial(BYVAL drive AS INTEGER) EXPORT AS LONG

  DIM Address  AS DWORD
  DIM Selector AS WORD
  DIM Segment  AS WORD
  DIM Regs     AS RegStruc
  DIM RetCode  AS WORD
  DIM Serial   AS LONG

  IF DosVersion < 400 THEN      ' DOS 4.0 or later
    EXIT FUNCTION
  END IF

  Address = GlobalDosAlloc(32)  ' two paragraphs of DOS memory

  IF Address = 0 THEN           ' address is zero if error occurred
    EXIT FUNCTION
  END IF

  Selector = LoWrd(Address)     ' selector in low word
  Segment  = HiWrd(Address)     ' real mode segment in high word

  Regs.BX = Drive               ' drive in BX
  Regs.CX = &H66                ' function code in CX
  Regs.DS = Segment             ' real mode segment in DS
  Regs.DX = 0                   ' clear DX
  Regs.AX = &H440D              ' function 440Dh in AX
  SimRealInt &H21, Regs         ' call DOS

  ! mov ES, Selector            ; put selector in ES
  ! mov BX, 2                   ; serial number at offset of 2
  ! mov AX, ES:[BX]             ; put low word in AX
  ! mov Serial[0], AX           ; and in Serial
  ! mov AX, ES:[BX+2]           ; put high word in AX
  ! mov Serial[2], AX           ; and in Serial

  RetCode = GlobalDosFree(Selector)  'free DOS memory block

  FUNCTION = Serial             ' return the serial number

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'Returns the number of free bytes on selected drive
'0 = default drive, 1 = A:, 2 = B:, etc.

FUNCTION DiskFree(BYVAL drive AS INTEGER) EXPORT AS LONG

  ! push DS                      ;

  ! mov  DX, drive               ; pass drive number in DX
  ! mov  AX, &H3600              ; AH = function number
  Dos3Call                       ' call DOS
  ! jc   FreeError               ; a DOS error occured

  'space = clusters * bytes/sector * sectors/cluster
  '      = AX*CX*BX

  ! mul  CX                      ;
  ! mul  BX                      ; result in DX:AX
  ! mov  FUNCTION[0], AX         ;
  ! mov  FUNCTION[2], DX         ;
  ! jmp  Short FreeDone          ;
FreeError:
  FUNCTION = -1                  ' return -1 for error
FreeDone:
  ! pop  DS                      ;

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'Returns the number of total bytes on selected drive
'0 = default drive, 1 = A:, 2 = B:, etc.

FUNCTION DiskSize(BYVAL drive AS INTEGER) EXPORT AS LONG

  ! push DS                      ;

  ! mov  DX, drive               ; pass drive number in DX
  ! mov  AX, &H3600              ; AH = function number
  Dos3Call                       ' call DOS
  ! jc   TotalError              ; a DOS error occured

  'space = clusters * bytes/sector * sectors/cluster
  '      = AX*CX*BX

  ! mov  BX, DX                  ; mov total clusters to BX
  ! mul  CX                      ;
  ! mul  BX                      ; result in DX:AX
  ! mov  FUNCTION[0], AX         ;
  ! mov  FUNCTION[2], DX         ;
  ! jmp  Short TotalDone         ;
TotalError:
  FUNCTION = -1                  ' return -1 for error
TotalDone:
  ! pop  DS                      ;

END FUNCTION


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Exist - Return true (-1) if a given filespec exists.
'
' Filename = name of file or directory to test for the existence of
'
FUNCTION Exist(Filename AS ASCIIZ) EXPORT AS INTEGER

  FUNCTION = LEN( DIR$(Filename, 17) ) > 0

END FUNCTION
