'------------------------------------------------------------------------------
'
'            WINAPI.INC -- Windows 3.1 API Declarations for PB/DLL
'
'                     Copyright (C) 1996 PowerBASIC, Inc.
'              Portions Copyright (C) 1993 Microsoft Corporation
'
'
'  This file contains the constants, TYPE, and DECLARE statements for the
'  Windows 3.1 API.
'
'  This file is not compatible with Visual Basic.  It uses the correct
'  data type as defined in the Microsoft SDK for Windows for all API calls.
'  This includes data types which are not natively supported in Visual Basic
'  such as unsigned integers and ASCIIZ strings.
'
'  You have a royalty-free right to use, modify, reproduce and distribute
'  this file (and/or any modified version) in any way you find useful,
'  provided that you agree that PowerBASIC has no warranty, obligation or
'  liability for its contents.  Refer to the Microsoft Windows Programmer's
'  Reference for further information.
'
'------------------------------------------------------------------------------


'-------------------------------------------------------------------------
'                              Global Constants
'-------------------------------------------------------------------------

' File attributes
%Normal                           = &H000000
%ReadOnly                         = &H000001
%Hidden                           = &H000010
%System                           = &H000100
%vLabel                           = &H001000
%SubDir                           = &H010000
%Archive                          = &H100000

'Common RGB Colors
%Black                            = &H000000???
%Blue                             = &HFF0000???
%Green                            = &H00FF00???
%Cyan                             = &HFFFF00???
%Red                              = &H0000FF???
%Magenta                          = &HFF00FF???
%Yellow                           = &H00FFFF???
%White                            = &HFFFFFF???

%NULL                             = &H0000???
%FALSE                            = 0
%TRUE                             = NOT %FALSE

' OpenFile() Flags
%OF_READ                          = &H0
%OF_WRITE                         = &H1
%OF_READWRITE                     = &H2
%OF_SHARE_COMPAT                  = &H0
%OF_SHARE_EXCLUSIVE               = &H10
%OF_SHARE_DENY_WRITE              = &H20
%OF_SHARE_DENY_READ               = &H30
%OF_SHARE_DENY_NONE               = &H40
%OF_PARSE                         = &H100
%OF_DELETE                        = &H200
%OF_VERIFY                        = &H400
%OF_CANCEL                        = &H800
%OF_CREATE                        = &H1000
%OF_PROMPT                        = &H2000
%OF_EXIST                         = &H4000
%OF_REOPEN                        = &H8000

' GetTempFileName() Flags
%TF_FORCEDRIVE                    = &H80

' llseek Flags
%SEEK_SET                         = 0
%SEEK_CUR                         = 1
%SEEK_END                         = 2

' GetDriveTYPE return values
%DRIVE_UNKNOWN                    = 0
%DRIVE_NOROOT                     = 1
%DRIVE_REMOVABLE                  = 2
%DRIVE_FIXED                      = 3
%DRIVE_REMOTE                     = 4
%DRIVE_CDROM                      = 5       ' Win32
%DRIVE_RAMDISK                    = 6       ' Win32

' DlgDirList, DlgDirListComboBox flags values
%DDL_READWRITE                    = &H0000
%DDL_READONLY                     = &H0001
%DDL_HIDDEN                       = &H0002
%DDL_SYSTEM                       = &H0004
%DDL_DIRECTORY                    = &H0010
%DDL_ARCHIVE                      = &H0020

%DDL_POSTMSGS                     = &H2000
%DDL_DRIVES                       = &H4000
%DDL_EXCLUSIVE                    = &H8000

%AHINCR                           = 8       ' selector increment value

' Global Memory Flags
%GMEM_FIXED                       = &H0
%GMEM_MOVEABLE                    = &H2
%GMEM_NOCOMPACT                   = &H10
%GMEM_NODISCARD                   = &H20
%GMEM_ZEROINIT                    = &H40
%GMEM_MODIFY                      = &H80
%GMEM_DISCARDABLE                 = &H100
%GMEM_NOT_BANKED                  = &H1000
%GMEM_SHARE                       = &H2000
%GMEM_DDESHARE                    = &H2000
%GMEM_NOTIFY                      = &H4000
%GMEM_LOWER                       = %GMEM_NOT_BANKED

%GHND                             = %GMEM_MOVEABLE OR %GMEM_ZEROINIT
%GPTR                             = %GMEM_FIXED OR %GMEM_ZEROINIT

' Flags returned by GlobalFlags (in addition to GMEM_DISCARDABLE)
%GMEM_DISCARDED                   = &H4000
%GMEM_LOCKCOUNT                   = &HFF

' Local Memory Flags
%LMEM_FIXED                       = &H0
%LMEM_MOVEABLE                    = &H2
%LMEM_NOCOMPACT                   = &H10
%LMEM_NODISCARD                   = &H20
%LMEM_ZEROINIT                    = &H40
%LMEM_MODIFY                      = &H80
%LMEM_DISCARDABLE                 = &HF00

%LHND                             = %LMEM_MOVEABLE OR %LMEM_ZEROINIT
%LPTR                             = %LMEM_FIXED OR %LMEM_ZEROINIT

%NONZEROLHND                      = %LMEM_MOVEABLE
%NONZEROLPTR                      = %LMEM_FIXED

%LNOTIFY_OUTOFMEM                 = 0
%LNOTIFY_MOVE                     = 1
%LNOTIFY_DISCARD                  = 2

%SEM_FAILCRITICALERRORS           = &H0001
%SEM_NOGPFAULTERRORBOX            = &H0002
%SEM_NOOPENFILEERRORBOX           = &H8000

' Flags returned by LocalFlags (in addition to LMEM_DISCARDABLE)
%LMEM_DISCARDED                   = &H4000
%LMEM_LOCKCOUNT                   = &HFF

' Predefined Resource TYPEs
%RT_CURSOR                        = 1???
%RT_BITMAP                        = 2???
%RT_ICON                          = 3???
%RT_MENU                          = 4???
%RT_DIALOG                        = 5???
%RT_STRING                        = 6???
%RT_FONTDIR                       = 7???
%RT_FONT                          = 8???
%RT_ACCELERATOR                   = 9???
%RT_RCDATA                        = 10???

%WF_PMODE                         = &H1
%WF_CPU286                        = &H2
%WF_CPU386                        = &H4
%WF_CPU486                        = &H8
%WF_STANDARD                      = &H10
%WF_WIN286                        = &H10
%WF_ENHANCED                      = &H20
%WF_WIN386                        = &H20
%WF_CPU086                        = &H40
%WF_CPU186                        = &H80
%WF_LARGEFRAME                    = &H100
%WF_SMALLFRAME                    = &H200
%WF_80x87                         = &H400
%WF_WINNT                         = &H4000

' WEP fSystemExit flag values
%WEP_SYSTEM_EXIT                  = 1
%WEP_FREE_DLL                     = 0

' OEM Resource Ordinal Numbers
%OBM_CLOSE                        = 32754
%OBM_UPARROW                      = 32753
%OBM_DNARROW                      = 32752
%OBM_RGARROW                      = 32751
%OBM_LFARROW                      = 32750
%OBM_REDUCE                       = 32749
%OBM_ZOOM                         = 32748
%OBM_RESTORE                      = 32747
%OBM_REDUCED                      = 32746
%OBM_ZOOMD                        = 32745
%OBM_RESTORED                     = 32744
%OBM_UPARROWD                     = 32743
%OBM_DNARROWD                     = 32742
%OBM_RGARROWD                     = 32741
%OBM_LFARROWD                     = 32740
%OBM_MNARROW                      = 32739
%OBM_COMBO                        = 32738

%OBM_OLD_CLOSE                    = 32767
%OBM_SIZE                         = 32766
%OBM_OLD_UPARROW                  = 32765
%OBM_OLD_DNARROW                  = 32764
%OBM_OLD_RGARROW                  = 32763
%OBM_OLD_LFARROW                  = 32762
%OBM_BTSIZE                       = 32761
%OBM_CHECK                        = 32760
%OBM_CHECKBOXES                   = 32759
%OBM_BTNCORNERS                   = 32758
%OBM_OLD_REDUCE                   = 32757
%OBM_OLD_ZOOM                     = 32756
%OBM_OLD_RESTORE                  = 32755

%OCR_NORMAL                       = 32512
%OCR_IBEAM                        = 32513
%OCR_WAIT                         = 32514
%OCR_CROSS                        = 32515
%OCR_UP                           = 32516
%OCR_SIZE                         = 32640
%OCR_ICON                         = 32641
%OCR_SIZENWSE                     = 32642
%OCR_SIZENESW                     = 32643
%OCR_SIZEWE                       = 32644
%OCR_SIZENS                       = 32645
%OCR_SIZEALL                      = 32646
%OCR_ICOCUR                       = 32647

%OIC_SAMPLE                       = 32512
%OIC_HAND                         = 32513
%OIC_QUES                         = 32514
%OIC_BANG                         = 32515
%OIC_NOTE                         = 32516

' Shell API Return Codes
%ERROR_SUCCESS                    = 0???
%ERROR_BADDB                      = 1???
%ERROR_BADKEY                     = 2???
%ERROR_CANTOPEN                   = 3???
%ERROR_CANTREAD                   = 4???
%ERROR_CANTWRITE                  = 5???
%ERROR_OUTOFMEMORY                = 6???
%ERROR_INVALID_PARAMETER          = 7???
%ERROR_ACCESS_DENIED              = 8???

%HKEY_CLASSES_ROOT                = 1???

' Binary raster ops
%R2_BLACK                         = 1  '  0
%R2_NOTMERGEPEN                   = 2  ' DPon
%R2_MASKNOTPEN                    = 3  ' DPna
%R2_NOTCOPYPEN                    = 4  ' PN
%R2_MASKPENNOT                    = 5  ' PDna
%R2_NOT                           = 6  ' Dn
%R2_XORPEN                        = 7  ' DPx
%R2_NOTMASKPEN                    = 8  ' DPan
%R2_MASKPEN                       = 9  ' DPa
%R2_NOTXORPEN                     = 10 ' DPxn
%R2_NOP                           = 11 ' D
%R2_MERGENOTPEN                   = 12 ' DPno
%R2_COPYPEN                       = 13 ' P
%R2_MERGEPENNOT                   = 14 ' PDno
%R2_MERGEPEN                      = 15 ' DPo
%R2_WHITE                         = 16 '  1

'  Ternary raster operations
%SRCCOPY                          = &HCC0020???  ' dest = source
%SRCPAINT                         = &HEE0086???  ' dest = source OR dest
%SRCAND                           = &H8800C6???  ' dest = source AND dest
%SRCINVERT                        = &H660046???  ' dest = source XOR dest
%SRCERASE                         = &H440328???  ' dest = source AND (NOT dest )
%NOTSRCCOPY                       = &H330008???  ' dest = (NOT source)
%NOTSRCERASE                      = &H1100A6???  ' dest = (NOT src) AND (NOT dest)
%MERGECOPY                        = &HC000CA???  ' dest = (source AND pattern)
%MERGEPAINT                       = &HBB0226???  ' dest = (NOT source) OR dest
%PATCOPY                          = &HF00021???  ' dest = pattern
%PATPAINT                         = &HFB0A09???  ' dest = DPSnoo
%PATINVERT                        = &H5A0049???  ' dest = pattern XOR dest
%DSTINVERT                        = &H550009???  ' dest = (NOT dest)
%BLACKNESS                        = &H42???      ' dest = BLACK
%WHITENESS                        = &HFF0062???  ' dest = WHITE

' StretchBlt() Modes
%BLACKONWHITE                     = 1
%WHITEONBLACK                     = 2
%COLORONCOLOR                     = 3

' PolyFill() Modes
%ALTERNATE                        = 1
%WINDING                          = 2

' Text Alignment Options
%TA_NOUPDATECP                    = 0
%TA_UPDATECP                      = 1

%TA_LEFT                          = 0
%TA_RIGHT                         = 2
%TA_CENTER                        = 6

%TA_TOP                           = 0
%TA_BOTTOM                        = 8
%TA_BASELINE                      = 24

%ETO_GRAYED                       = 1
%ETO_OPAQUE                       = 2
%ETO_CLIPPED                      = 4

%ASPECT_FILTERING                 = &H1

' Metafile FUNCTIONs
%META_SETBKCOLOR                  = &H201
%META_SETBKMODE                   = &H102
%META_SETMAPMODE                  = &H103
%META_SETROP2                     = &H104
%META_SETRELABS                   = &H105
%META_SETPOLYFILLMODE             = &H106
%META_SETSTRETCHBLTMODE           = &H107
%META_SETTEXTCHAREXTRA            = &H108
%META_SETTEXTCOLOR                = &H209
%META_SETTEXTJUSTIFICATION        = &H20A
%META_SETWINDOWORG                = &H20B
%META_SETWINDOWEXT                = &H20C
%META_SETVIEWPORTORG              = &H20D
%META_SETVIEWPORTEXT              = &H20E
%META_OFFSETWINDOWORG             = &H20F
%META_SCALEWINDOWEXT              = &H400
%META_OFFSETVIEWPORTORG           = &H211
%META_SCALEVIEWPORTEXT            = &H412
%META_LINETO                      = &H213
%META_MOVETO                      = &H214
%META_EXCLUDECLIPRECT             = &H415
%META_INTERSECTCLIPRECT           = &H416
%META_ARC                         = &H817
%META_ELLIPSE                     = &H418
%META_FLOODFILL                   = &H419
%META_PIE                         = &H81A
%META_RECTANGLE                   = &H41B
%META_ROUNDRECT                   = &H61C
%META_PATBLT                      = &H61D
%META_SAVEDC                      = &H1E
%META_SETPIXEL                    = &H41F
%META_OFFSETCLIPRGN               = &H220
%META_TEXTOUT                     = &H521
%META_BITBLT                      = &H922
%META_STRETCHBLT                  = &HB23
%META_POLYGON                     = &H324
%META_POLYLINE                    = &H325
%META_ESCAPE                      = &H626
%META_RESTOREDC                   = &H127
%META_FILLREGION                  = &H228
%META_FRAMEREGION                 = &H429
%META_INVERTREGION                = &H12A
%META_PAINTREGION                 = &H12B
%META_SELECTCLIPREGION            = &H12C
%META_SELECTOBJECT                = &H12D
%META_SETTEXTALIGN                = &H12E
%META_DRAWTEXT                    = &H62F

%META_CHORD                       = &H830
%META_SETMAPPERFLAGS              = &H231
%META_EXTTEXTOUT                  = &HA32
%META_SETDIBTODEV                 = &HD33
%META_SELECTPALETTE               = &H234
%META_REALIZEPALETTE              = &H35
%META_ANIMATEPALETTE              = &H436
%META_SETPALENTRIES               = &H37
%META_POLYPOLYGON                 = &H538
%META_RESIZEPALETTE               = &H139

%META_DIBBITBLT                   = &H940
%META_DIBSTRETCHBLT               = &HB41
%META_DIBCREATEPATTERNBRUSH       = &H142
%META_STRETCHDIB                  = &HF43

%META_DELETEOBJECT                = &H1F0

%META_CREATEPALETTE               = &HF7
%META_CREATEBRUSH                 = &HF8
%META_CREATEPATTERNBRUSH          = &H1F9
%META_CREATEPENINDIRECT           = &H2FA
%META_CREATEFONTINDIRECT          = &H2FB
%META_CREATEBRUSHINDIRECT         = &H2FC
%META_CREATEBITMAPINDIRECT        = &H2FD
%META_CREATEBITMAP                = &H6FE
%META_CREATEREGION                = &H6FF

' GDI Escapes
%NEWFRAME                         =  1
%NEXTBAND                         =  3
%SETCOLORTABLE                    =  4
%GETCOLORTABLE                    =  5
%FLUSHOUTPUT                      =  6
%DRAFTMODE                        =  7
%QUERYESCSUPPORT                  =  8
%SETABORTPROC                     =  9
%GETPHYSPAGESIZE                  = 12
%GETPRINTINGOFFSET                = 13
%GETSCALINGFACTOR                 = 14
%MFCOMMENT                        = 15
%GETPENWIDTH                      = 16
%SETCOPYCOUNT                     = 17
%SELECTPAPERSOURCE                = 18
%DEVICEDATA                       = 19
%PASSTHROUGH                      = 19
%GETTECHNOLGY                     = 20
%GETTECHNOLOGY                    = 20
%SETENDCAP                        = 21
%SETLINEJOIN                      = 22
%SETMITERLIMIT                    = 23
%BANDINFO = 24
%DRAWPATTERNRECT                  = 25
%GETVECTORPENSIZE                 = 26
%GETVECTORBRUSHSIZE               = 27
%ENABLEDUPLEX                     = 28
%GETSETPAPERBINS                  = 29
%GETSETPRINTORIENT                = 30
%ENUMPAPERBINS                    = 31
%SETDIBSCALING                    = 32
%EPSPRINTING                      = 33
%ENUMPAPERMETRICS                 = 34
%GETSETPAPERMETRICS               = 35
%POSTSCRIPT_DATA                  = 37
%POSTSCRIPT_IGNORE                = 38
%GETEXTENDEDTEXTMETRICS           = 256
%GETEXTENTTABLE                   = 257
%GETPAIRKERNTABLE                 = 258
%GETTRACKKERNTABLE                = 259
%EXTTEXTOUTAPI                    = 512
%ENABLERELATIVEWIDTHS             = 768
%ENABLEPAIRKERNING                = 769
%SETKERNTRACK                     = 770
%SETALLJUSTVALUES                 = 771
%SETCHARSET                       = 772

%STRETCHBLTAPI                    = 2048
%BEGIN_PATH                       = 4096
%CLIP_TO_PATH                     = 4097
%END_PATH                         = 4098
%EXT_DEVICE_CAPS                  = 4099
%RESTORE_CTM                      = 4100
%SAVE_CTM = 4101
%SET_ARC_DIRECTION                = 4102
%SET_BACKGROUND_COLOR             = 4103
%SET_POLY_MODE                    = 4104
%SET_SCREEN_ANGLE                 = 4105
%SET_SPREAD                       = 4106
%TRANSFORM_CTM                    = 4107
%SET_CLIP_BOX                     = 4108
%SET_BOUNDS                       = 4109
%SET_MIRROR_MODE                  = 4110

' Spooler Error Codes
%SP_NOTREPORTED                   = &H4000
%SP_ERROR                         = -1
%SP_APPABORT                      = -2
%SP_USERABORT                     = -3
%SP_OUTOFDISK                     = -4
%SP_OUTOFMEMORY                   = -5

%PR_JOBSTATUS                     = &H0

' constants for the biCompression field
%BI_RGB                           = 0???
%BI_RLE8                          = 1???
%BI_RLE4                          = 2???

' Logical Font
%LF_FACESIZE                      = 32

%SIMULATED_FONTTYPE               = &H8000
%PRINTER_FONTTYPE                 = &H4000
%SCREEN_FONTTYPE                  = &H2000
%BOLD_FONTTYPE                    = &H0100
%ITALIC_FONTTYPE                  = &H0200
%REGULAR_FONTTYPE                 = &H0400

%OUT_DEFAULT_PRECIS               = 0
%OUT_STRING_PRECIS                = 1
%OUT_CHARACTER_PRECIS             = 2
%OUT_STROKE_PRECIS                = 3

%CLIP_DEFAULT_PRECIS              = 0
%CLIP_CHARACTER_PRECIS            = 1
%CLIP_STROKE_PRECIS               = 2

%DEFAULT_QUALITY                  = 0
%DRAFT_QUALITY                    = 1
%PROOF_QUALITY                    = 2

%DEFAULT_PITCH                    = 0
%FIXED_PITCH                      = 1
%VARIABLE_PITCH                   = 2

%ANSI_CHARSET                     = 0
%SYMBOL_CHARSET                   = 2
%SHIFTJIS_CHARSET                 = 128
%OEM_CHARSET                      = 255

' Font Families
'
%FF_DONTCARE                      = 0    ' Don't care or don't know.
%FF_ROMAN                         = 16   ' Variable stroke width, serifed.

' Times Roman, Century Schoolbook, etc.
%FF_SWISS                         = 32   ' Variable stroke width, sans-serifed.

' Helvetica, Swiss, etc.
%FF_MODERN                        = 48   ' Constant stroke width, serifed or sans-serifed.

' Pica, Elite, Courier, etc.
%FF_SCRIPT                        = 64   ' Cursive, etc.
%FF_DECORATIVE                    = 80   ' Old English, etc.

' Font Weights
%FW_DONTCARE                      = 0
%FW_THIN                          = 100
%FW_EXTRALIGHT                    = 200
%FW_LIGHT                         = 300
%FW_NORMAL                        = 400
%FW_MEDIUM                        = 500
%FW_SEMIBOLD                      = 600
%FW_BOLD                          = 700
%FW_EXTRABOLD                     = 800
%FW_HEAVY                         = 900

%FW_ULTRALIGHT                    = %FW_EXTRALIGHT
%FW_REGULAR                       = %FW_NORMAL
%FW_DEMIBOLD                      = %FW_SEMIBOLD
%FW_ULTRABOLD                     = %FW_EXTRABOLD
%FW_BLACK                         = %FW_HEAVY

' Background Modes
%TRANSPARENT                      = 1
%OPAQUE                           = 2

' Mapping Modes
%MM_TEXT                          = 1
%MM_LOMETRIC                      = 2
%MM_HIMETRIC                      = 3
%MM_LOENGLISH                     = 4
%MM_HIENGLISH                     = 5
%MM_TWIPS                         = 6
%MM_ISOTROPIC                     = 7
%MM_ANISOTROPIC                   = 8

' Coordinate Modes
%ABSOLUTE                         = 1
%RELATIVE                         = 2

' Stock Logical Objects
%WHITE_BRUSH                      = 0
%LTGRAY_BRUSH                     = 1
%GRAY_BRUSH                       = 2
%DKGRAY_BRUSH                     = 3
%BLACK_BRUSH                      = 4
%NULL_BRUSH                       = 5
%HOLLOW_BRUSH                     = %NULL_BRUSH
%WHITE_PEN                        = 6
%BLACK_PEN                        = 7
%NULL_PEN                         = 8
%OEM_FIXED_FONT                   = 10
%ANSI_FIXED_FONT                  = 11
%ANSI_VAR_FONT                    = 12
%SYSTEM_FONT                      = 13
%DEVICE_DEFAULT_FONT              = 14
%DEFAULT_PALETTE                  = 15
%SYSTEM_FIXED_FONT                = 16

' Brush Styles
%BS_SOLID                         = 0
%BS_NULL                          = 1
%BS_HOLLOW                        = %BS_NULL
%BS_HATCHED                       = 2
%BS_PATTERN                       = 3
%BS_INDEXED                       = 4
%BS_DIBPATTERN                    = 5

' Hatch Styles
%HS_HORIZONTAL                    = 0  '  -----
%HS_VERTICAL                      = 1  '  |||||
%HS_FDIAGONAL                     = 2  '  \\\\\
%HS_BDIAGONAL                     = 3  '  /////
%HS_CROSS                         = 4  '  +++++
%HS_DIAGCROSS                     = 5  '  xxxxx

' Pen Styles
%PS_SOLID                         = 0
%PS_DASH                          = 1  '  -------
%PS_DOT                           = 2  '  .......
%PS_DASHDOT                       = 3  '  _._._._
%PS_DASHDOTDOT                    = 4  '  _.._.._
%PS_NULL                          = 5
%PS_INSIDEFRAME                   = 6

' Device Parameters for GetDeviceCaps()
%DRIVERVERSION                    = 0   ' Device driver version
%TECHNOLOGY                       = 2   ' Device classification
%HORZSIZE                         = 4   ' Horizontal size in millimeters
%VERTSIZE                         = 6   ' Vertical size in millimeters
%HORZRES                          = 8   ' Horizontal width in pixels
%VERTRES                          = 10  ' Vertical width in pixels
%BITSPIXEL                        = 12  ' Number of bits per pixel
%PLANES                           = 14  ' Number of planes
%NUMBRUSHES                       = 16  ' Number of brushes the device has
%NUMPENS                          = 18  ' Number of pens the device has
%NUMMARKERS                       = 20  ' Number of markers the device has
%NUMFONTS                         = 22  ' Number of fonts the device has
%NUMCOLORS                        = 24  ' Number of colors the device supports
%PDEVICESIZE                      = 26  ' Size required for device descriptor
%CURVECAPS                        = 28  ' Curve capabilities
%LINECAPS                         = 30  ' Line capabilities
%POLYGONALCAPS                    = 32  ' Polygonal capabilities
%TEXTCAPS                         = 34  ' Text capabilities
%CLIPCAPS                         = 36  ' Clipping capabilities
%RASTERCAPS                       = 38  ' Bitblt capabilities
%ASPECTX                          = 40  ' Length of the X leg
%ASPECTY                          = 42  ' Length of the Y leg
%ASPECTXY                         = 44  ' Length of the hypotenuse

%LOGPIXELSX                       = 88  ' Logical pixels/inch in X
%LOGPIXELSY                       = 90  ' Logical pixels/inch in Y

%SIZEPALETTE                      = 104 ' Number of entries in physical palette
%NUMRESERVED                      = 106 ' Number of reserved entries in palette
%COLORRES                         = 108 ' Actual color resolution


' Device Capability Masks:

' Device Technologies
%DT_PLOTTER                       = 0   ' Vector plotter
%DT_RASDISPLAY                    = 1   ' Raster display
%DT_RASPRINTER                    = 2   ' Raster printer
%DT_RASCAMERA                     = 3   ' Raster camera
%DT_CHARSTREAM                    = 4   ' Character-stream, PLP
%DT_METAFILE                      = 5   ' Metafile, VDM
%DT_DISPFILE                      = 6   ' Display-file

' Curve Capabilities
%CC_NONE                          = 0   ' Curves not supported
%CC_CIRCLES                       = 1   ' Can do circles
%CC_PIE                           = 2   ' Can do pie wedges
%CC_CHORD                         = 4   ' Can do chord arcs
%CC_ELLIPSES                      = 8   ' Can do ellipese
%CC_WIDE                          = 16  ' Can do wide lines
%CC_STYLED                        = 32  ' Can do styled lines
%CC_WIDESTYLED                    = 64  ' Can do wide styled lines
%CC_INTERIORS                     = 128 ' Can do interiors

' Line Capabilities
%LC_NONE                          = 0   ' Lines not supported
%LC_POLYLINE                      = 2   ' Can do polylines
%LC_MARKER                        = 4   ' Can do markers
%LC_POLYMARKER                    = 8   ' Can do polymarkers
%LC_WIDE                          = 16  ' Can do wide lines
%LC_STYLED                        = 32  ' Can do styled lines
%LC_WIDESTYLED                    = 64  ' Can do wide styled lines
%LC_INTERIORS                     = 128 ' Can do interiors

' Polygonal Capabilities
%PC_NONE                          = 0   ' Polygonals not supported
%PC_POLYGON                       = 1   ' Can do polygons
%PC_RECTANGLE                     = 2   ' Can do rectangles
%PC_WINDPOLYGON                   = 4   ' Can do winding polygons
%PC_TRAPEZOID                     = 4   ' Can do trapezoids
%PC_SCANLINE                      = 8   ' Can do scanlines
%PC_WIDE                          = 16  ' Can do wide borders
%PC_STYLED                        = 32  ' Can do styled borders
%PC_WIDESTYLED                    = 64  ' Can do wide styled borders
%PC_INTERIORS                     = 128 ' Can do interiors

' Polygonal Capabilities
%CP_NONE                          = 0   ' No clipping of output
%CP_RECTANGLE                     = 1   ' Output clipped to rects

' Text Capabilities
%TC_OP_CHARACTER                  = &H1    ' Can do OutputPrecision   CHARACTER
%TC_OP_STROKE                     = &H2    ' Can do OutputPrecision   STROKE
%TC_CP_STROKE                     = &H4    ' Can do ClipPrecision     STROKE
%TC_CR_90                         = &H8    ' Can do CharRotAbility    90
%TC_CR_ANY                        = &H10   ' Can do CharRotAbility    ANY
%TC_SF_X_YINDEP                   = &H20   ' Can do ScaleFreedom      X_YINDEPENDENT
%TC_SA_DOUBLE                     = &H40   ' Can do ScaleAbility      DOUBLE
%TC_SA_WORD                       = &H80   ' Can do ScaleAbility      WORD
%TC_SA_CONTIN                     = &H100  ' Can do ScaleAbility      CONTINUOUS
%TC_EA_DOUBLE                     = &H200  ' Can do EmboldenAbility   DOUBLE
%TC_IA_ABLE                       = &H400  ' Can do ItalisizeAbility  ABLE
%TC_UA_ABLE                       = &H800  ' Can do UnderlineAbility  ABLE
%TC_SO_ABLE                       = &H1000 ' Can do StrikeOutAbility  ABLE
%TC_RA_ABLE                       = &H2000 ' Can do RasterFontAble    ABLE
%TC_VA_ABLE                       = &H4000 ' Can do VectorFontAble    ABLE
%TC_RESERVED                      = &H8000

' Raster Capabilities
%RC_BITBLT                        = 1      ' Can do standard BLT
%RC_BANDING                       = 2      ' Device requires banding support
%RC_SCALING                       = 4      ' Device requires scaling support
%RC_BITMAP64                      = 8      ' Device can support >64K bitmap
%RC_GDI20_OUTPUT                  = &H10   ' has 2.0 output calls
%RC_DI_BITMAP                     = &H80   ' supports DIB to memory
%RC_PALETTE                       = &H100  ' supports a palette
%RC_DIBTODEV                      = &H200  ' supports DIBitsToDevice
%RC_BIGFONT                       = &H400  ' supports >64K fonts
%RC_STRETCHBLT                    = &H800  ' supports StretchBlt
%RC_FLOODFILL                     = &H1000 ' supports FloodFill
%RC_STRETCHDIB                    = &H2000 ' supports StretchDIBits

' palette entry flags
%PC_RESERVED                      = &H1    ' palette index used for animation
%PC_EXPLICIT                      = &H2    ' palette index is explicit to device
%PC_NOCOLLAPSE                    = &H4    ' do not match color to system palette

' DIB color table identifiers
%DIB_RGB_COLORS                   = 0      ' color table in RGBTriples
%DIB_PAL_COLORS                   = 1      ' color table in palette indices

' constants for Get/SetSystemPaletteUse()
%SYSPAL_STATIC                    = 1
%SYSPAL_NOSTATIC                  = 2

' constants for CreateDIBitmap
%CBM_INIT                         = &H4%   ' initialize bitmap

' DrawText() Format Flags
%DT_TOP                           = &H0
%DT_LEFT                          = &H0
%DT_CENTER                        = &H1
%DT_RIGHT                         = &H2
%DT_VCENTER                       = &H4
%DT_BOTTOM                        = &H8
%DT_WORDBREAK                     = &H10
%DT_SINGLELINE                    = &H20
%DT_EXPANDTABS                    = &H40
%DT_TABSTOP                       = &H80
%DT_NOCLIP                        = &H100
%DT_EXTERNALLEADING               = &H200
%DT_CALCRECT                      = &H400
%DT_NOPREFIX                      = &H800
%DT_INTERNAL                      = &H1000

' ExtFloodFill style flags
%FLOODFILLBORDER                  = 0
%FLOODFILLSURFACE                 = 1

' Scroll Bar Constants
%SB_HORZ                          = 0
%SB_VERT                          = 1
%SB_CTL                           = 2
%SB_BOTH                          = 3

' Scroll Bar Commands
%SB_LINEUP                        = 0
%SB_LINEDOWN                      = 1
%SB_PAGEUP                        = 2
%SB_PAGEDOWN                      = 3
%SB_THUMBPOSITION                 = 4
%SB_THUMBTRACK                    = 5
%SB_TOP                           = 6
%SB_BOTTOM                        = 7
%SB_ENDSCROLL                     = 8

' ShowWindow() Commands
%SW_HIDE                          = 0
%SW_SHOWNORMAL                    = 1
%SW_NORMAL                        = 1
%SW_SHOWMINIMIZED                 = 2
%SW_SHOWMAXIMIZED                 = 3
%SW_MAXIMIZE                      = 3
%SW_SHOWNOACTIVATE                = 4
%SW_SHOW                          = 5
%SW_MINIMIZE                      = 6
%SW_SHOWMINNOACTIVE               = 7
%SW_SHOWNA                        = 8
%SW_RESTORE                       = 9

' Old ShowWindow() Commands
%HIDE_WINDOW                      = 0
%SHOW_OPENWINDOW                  = 1
%SHOW_ICONWINDOW                  = 2
%SHOW_FULLSCREEN                  = 3
%SHOW_OPENNOACTIVATE              = 4

' Identifiers for the WM_SHOWWINDOW message
%SW_PARENTCLOSING                 = 1
%SW_OTHERZOOM                     = 2
%SW_PARENTOPENING                 = 3
%SW_OTHERUNZOOM                   = 4

' Get/SetWindowWord/Long offsets for use with WC_DIALOG windows
%DWL_MSGRESULT                    = 0
%DWL_DLGPROC                      = 4
%DWL_USER                         = 8

' Region Flags
%ERRORAPI                         = 0
%NULLREGION                       = 1
%SIMPLEREGION                     = 2
%COMPLEXREGION                    = 3

' CombineRgn() Styles
%RGN_AND                          = 1
%RGN_OR                           = 2
%RGN_XOR                          = 3
%RGN_DIFF                         = 4
%RGN_COPY                         = 5

' Virtual Keys, Standard Set
%VK_BACK                          = &H8
%VK_CANCEL                        = &H3
%VK_CAPITAL                       = &H14
%VK_CLEAR                         = &HC
%VK_CONTROL                       = &H11
%VK_DELETE                        = &H2E
%VK_DOWN                          = &H28
%VK_END                           = &H23
%VK_ESCAPE                        = &H1B
%VK_EXECUTE                       = &H2B
%VK_HELP                          = &H2F
%VK_HOME                          = &H24
%VK_INSERT                        = &H2D
%VK_LBUTTON                       = &H1
%VK_LEFT                          = &H25
%VK_MBUTTON                       = &H4
%VK_MENU                          = &H12
%VK_NEXT                          = &H22
%VK_PAUSE                         = &H13
%VK_PGDN                          = &H22
%VK_PGUP                          = &H21
%VK_PRINT                         = &H2A
%VK_PRIOR                         = &H21
%VK_RBUTTON                       = &H2
%VK_RETURN                        = &HD
%VK_RIGHT                         = &H27
%VK_SELECT                        = &H29
%VK_SHIFT                         = &H10
%VK_SNAPSHOT                      = &H2C
%VK_SPACE                         = &H20
%VK_TAB                           = &H9
%VK_UP                            = &H26

' VK_A thru VK_Z are the same as their ASCII equivalents: 'A' thru 'Z'
' VK_0 thru VK_9 are the same as their ASCII equivalents: '0' thru '9'
%VK_NUMPAD0                       = &H60
%VK_NUMPAD1                       = &H61
%VK_NUMPAD2                       = &H62
%VK_NUMPAD3                       = &H63
%VK_NUMPAD4                       = &H64
%VK_NUMPAD5                       = &H65
%VK_NUMPAD6                       = &H66
%VK_NUMPAD7                       = &H67
%VK_NUMPAD8                       = &H68
%VK_NUMPAD9                       = &H69
%VK_MULTIPLY                      = &H6A
%VK_ADD                           = &H6B
%VK_SEPARATOR                     = &H6C
%VK_SUBTRACT                      = &H6D
%VK_DECIMAL                       = &H6E
%VK_DIVIDE                        = &H6F
%VK_F1                            = &H70
%VK_F2                            = &H71
%VK_F3                            = &H72
%VK_F4                            = &H73
%VK_F5                            = &H74
%VK_F6                            = &H75
%VK_F7                            = &H76
%VK_F8                            = &H77
%VK_F9                            = &H78
%VK_F10                           = &H79
%VK_F11                           = &H7A
%VK_F12                           = &H7B
%VK_F13                           = &H7C
%VK_F14                           = &H7D
%VK_F15                           = &H7E
%VK_F16                           = &H7F

%VK_NUMLOCK                       = &H90

' SetWindowsHook() codes
%WH_MSGFILTER                     = (-1)
%WH_JOURNALRECORD                 = 0
%WH_JOURNALPLAYBACK               = 1
%WH_KEYBOARD                      = 2
%WH_GETMESSAGE                    = 3
%WH_CALLWNDPROC                   = 4
%WH_CBT                           = 5
%WH_SYSMSGFILTER                  = 6
%WH_WINDOWMGR                     = 7

' Hook Codes
%HC_LPLPFNNEXT                    = -2
%HC_LPFNNEXT                      = -1
%HC_ACTION                        = 0
%HC_GETNEXT                       = 1
%HC_SKIP                          = 2
%HC_NOREM                         = 3
%HC_NOREMOVE                      = 3
%HC_SYSMODALON                    = 4
%HC_SYSMODALOFF                   = 5

' CBT Hook Codes
%HCBT_MOVESIZE                    = 0
%HCBT_MINMAX                      = 1
%HCBT_QS                          = 2

' WH_MSGFILTER Filter Proc Codes
%MSGF_DIALOGBOX                   = 0
%MSGF_MESSAGEBOX                  = 1
%MSGF_MENU                        = 2
%MSGF_MOVE                        = 3
%MSGF_SIZE                        = 4
%MSGF_SCROLLBAR                   = 5
%MSGF_NEXTWINDOW                  = 6

' Window Manager Hook Codes
%WC_INIT                          = 1
%WC_SWP                           = 2
%WC_DEFWINDOWPROC                 = 3
%WC_MINMAX                        = 4
%WC_MOVE                          = 5
%WC_SIZE                          = 6
%WC_DRAWCAPTION                   = 7

' Window field offsets for GetWindowLong() and GetWindowWord()
%GWL_WNDPROC                      = -4
%GWW_HINSTANCE                    = -6
%GWW_HWNDPARENT                   = -8
%GWW_ID                           = -12
%GWL_STYLE                        = -16
%GWL_EXSTYLE                      = -20

' Class field offsets for GetClassLong() and GetClassWord()
%GCL_MENUNAME                     = -8
%GCW_HBRBACKGROUND                = -10
%GCW_HCURSOR                      = -12
%GCW_HICON                        = -14
%GCW_HMODULE                      = -16
%GCW_CBWNDEXTRA                   = -18
%GCW_CBCLSEXTRA                   = -20
%GCL_WNDPROC                      = -24
%GCW_STYLE                        = -26

' Window Messages
%WM_ACTIVATE                      = &H0006
%WM_ACTIVATEAPP                   = &H001C
%WM_ASKCBFORMATNAME               = &H030C
%WM_CANCELMODE                    = &H001F
%WM_CHANGECBCHAIN                 = &H030D
%WM_CHAR                          = &H0102
%WM_CHARTOITEM                    = &H002F
%WM_CHILDACTIVATE                 = &H0022
%WM_CLEAR                         = &H0303
%WM_CLOSE                         = &H0010
%WM_COMMAND                       = &H0111
%WM_COMPACTING                    = &H0041
%WM_COMPAREITEM                   = &H0039
%WM_COPY                          = &H0301
%WM_CREATE                        = &H0001
%WM_CTLCOLOR                      = &H0019
%WM_CUT                           = &H0300
%WM_DEADCHAR                      = &H0103
%WM_DELETEITEM                    = &H002D
%WM_DESTROY                       = &H0002
%WM_DESTROYCLIPBOARD              = &H0307
%WM_DEVMODECHANGE                 = &H001B
%WM_DRAWCLIPBOARD                 = &H0308
%WM_DRAWITEM                      = &H002B
%WM_DROPFILES                     = &H0233
%WM_ENABLE                        = &H000A
%WM_ENDSESSION                    = &H0016
%WM_ENTERIDLE                     = &H0121
%WM_ERASEBKGND                    = &H0014
%WM_FONTCHANGE                    = &H001D
%WM_GETDLGCODE                    = &H0087
%WM_GETFONT                       = &H0031
%WM_GETMINMAXINFO                 = &H0024
%WM_GETTEXT                       = &H000D
%WM_GETTEXTLENGTH                 = &H000E
%WM_HSCROLL                       = &H0114
%WM_HSCROLLCLIPBOARD              = &H030E
%WM_ICONERASEBKGND                = &H0027
%WM_INITDIALOG                    = &H0110
%WM_INITMENU                      = &H0116
%WM_INITMENUPOPUP                 = &H0117
%WM_KEYDOWN                       = &H0100
%WM_KEYFIRST                      = &H0100
%WM_KEYLAST                       = &H0108
%WM_KEYUP                         = &H0101
%WM_KILLFOCUS                     = &H0008
%WM_LBUTTONDBLCLK                 = &H0203
%WM_LBUTTONDOWN                   = &H0201
%WM_LBUTTONUP                     = &H0202
%WM_MBUTTONDBLCLK                 = &H0209
%WM_MBUTTONDOWN                   = &H0207
%WM_MBUTTONUP                     = &H0208
%WM_MDIACTIVATE                   = &H0222
%WM_MDICASCADE                    = &H0227
%WM_MDICREATE                     = &H0220
%WM_MDIDESTROY                    = &H0221
%WM_MDIGETACTIVE                  = &H0229
%WM_MDIICONARRANGE                = &H0228
%WM_MDIMAXIMIZE                   = &H0225
%WM_MDINEXT                       = &H0224
%WM_MDIRESTORE                    = &H0223
%WM_MDISETMENU                    = &H0230
%WM_MDITILE                       = &H0226
%WM_MEASUREITEM                   = &H002C
%WM_MENUCHAR                      = &H0120
%WM_MENUSELECT                    = &H011F
%WM_MOUSEACTIVATE                 = &H0021
%WM_MOUSEFIRST                    = &H0200
%WM_MOUSELAST                     = &H0209
%WM_MOUSEMOVE                     = &H0200
%WM_MOVE                          = &H0003
%WM_NCACTIVATE                    = &H0086
%WM_NCCALCSIZE                    = &H0083
%WM_NCCREATE                      = &H0081
%WM_NCDESTROY                     = &H0082
%WM_NCHITTEST                     = &H0084
%WM_NCLBUTTONDBLCLK               = &H00A3
%WM_NCLBUTTONDOWN                 = &H00A1
%WM_NCLBUTTONUP                   = &H00A2
%WM_NCMBUTTONDBLCLK               = &H00A9
%WM_NCMBUTTONDOWN                 = &H00A7
%WM_NCMBUTTONUP                   = &H00A8
%WM_NCMOUSEMOVE                   = &H00A0
%WM_NCPAINT                       = &H0085
%WM_NCRBUTTONDBLCLK               = &H00A6
%WM_NCRBUTTONDOWN                 = &H00A4
%WM_NCRBUTTONUP                   = &H00A5
%WM_NEXTDLGCTL                    = &H0028
%WM_NULL                          = &H0000
%WM_PAINT                         = &H000F
%WM_PAINTCLIPBOARD                = &H0309
%WM_PAINTICON                     = &H0026
%WM_PALETTECHANGED                = &H0311
%WM_PALETTEISCHANGING             = &H0310
%WM_PARENTNOTIFY                  = &H0210
%WM_PASTE                         = &H0302
%WM_QUERYDRAGICON                 = &H0037
%WM_QUERYENDSESSION               = &H0011
%WM_QUERYNEWPALETTE               = &H030F
%WM_QUERYOPEN                     = &H0013
%WM_QUEUESYNC                     = &H0023
%WM_QUIT                          = &H0012
%WM_RBUTTONDBLCLK                 = &H0206
%WM_RBUTTONDOWN                   = &H0204
%WM_RBUTTONUP                     = &H0205
%WM_RENDERALLFORMATS              = &H0306
%WM_RENDERFORMAT                  = &H0305
%WM_SETCURSOR                     = &H0020
%WM_SETFOCUS                      = &H0007
%WM_SETFONT                       = &H0030
%WM_SETREDRAW                     = &H000B
%WM_SETTEXT                       = &H000C
%WM_SHOWWINDOW                    = &H0018
%WM_SIZE                          = &H0005
%WM_SIZECLIPBOARD                 = &H030B
%WM_SPOOLERSTATUS                 = &H002A
%WM_SYSCHAR                       = &H0106
%WM_SYSCOLORCHANGE                = &H0015
%WM_SYSCOMMAND                    = &H0112
%WM_SYSDEADCHAR                   = &H0107
%WM_SYSKEYDOWN                    = &H0104
%WM_SYSKEYUP                      = &H0105
%WM_TIMECHANGE                    = &H001E
%WM_TIMER                         = &H0113
%WM_UNDO                          = &H0304
%WM_VKEYTOITEM                    = &H002E
%WM_VSCROLL                       = &H0115
%WM_VSCROLLCLIPBOARD              = &H030A
%WM_WININICHANGE                  = &H001A

' NOTE: All Message Numbers below &H0400 are Reserved.

' Private Window Messages Start Here:
%WM_USER                          = &H400

' WM_SYNCTASK Commands
%ST_BEGINSWP                      = 0
%ST_ENDSWP                        = 1

' WinWhere() Area Codes
%HTERROR                          = -2
%HTTRANSPARENT                    = -1
%HTNOWHERE                        = 0
%HTCLIENT                         = 1
%HTCAPTION                        = 2
%HTSYSMENU                        = 3
%HTGROWBOX                        = 4
%HTSIZE                           = %HTGROWBOX
%HTMENU                           = 5
%HTHSCROLL                        = 6
%HTVSCROLL                        = 7
%HTREDUCE                         = 8
%HTZOOM                           = 9
%HTLEFT                           = 10
%HTRIGHT                          = 11
%HTTOP                            = 12
%HTTOPLEFT                        = 13
%HTTOPRIGHT                       = 14
%HTBOTTOM                         = 15
%HTBOTTOMLEFT                     = 16
%HTBOTTOMRIGHT                    = 17
%HTSIZEFIRST                      = %HTLEFT
%HTSIZELAST                       = %HTBOTTOMRIGHT

' WM_MOUSEACTIVATE Return Codes
%MA_ACTIVATE                      = 1
%MA_ACTIVATEANDEAT                = 2
%MA_NOACTIVATE                    = 3

' Size Message Commands
%SIZENORMAL                       = 0
%SIZEICONIC                       = 1
%SIZEFULLSCREEN                   = 2
%SIZEZOOMSHOW                     = 3
%SIZEZOOMHIDE                     = 4

' Key State Masks for Mouse Messages
%MK_LBUTTON                       = &H1
%MK_RBUTTON                       = &H2
%MK_SHIFT                         = &H4
%MK_CONTROL                       = &H8
%MK_MBUTTON                       = &H10

'** Basic window types **
%WS_OVERLAPPED                    = &H00000000???
%WS_POPUP                         = &H80000000???
%WS_CHILD                         = &H40000000???

'** Clipping styles **
%WS_CLIPSIBLINGS                  = &H04000000???
%WS_CLIPCHILDREN                  = &H02000000???

'** Generic window states **
%WS_VISIBLE                       = &H10000000???
%WS_DISABLED                      = &H08000000???

'** Main window states **
%WS_MINIMIZE                      = &H20000000???
%WS_MAXIMIZE                      = &H01000000???

'** Main window styles **
%WS_BORDER                        = &H00800000???
%WS_DLGFRAME                      = &H00400000???
%WS_CAPTION                       = &H00C00000??? '** WS_BORDER OR WS_DLGFRAME  **
%WS_VSCROLL                       = &H00200000???
%WS_HSCROLL                       = &H00100000???
%WS_SYSMENU                       = &H00080000???
%WS_THICKFRAME                    = &H00040000???
%WS_MINIMIZEBOX                   = &H00020000???
%WS_MAXIMIZEBOX                   = &H00010000???

'** Control window styles **
%WS_GROUP                         = &H00020000???
%WS_TABSTOP                       = &H00010000???

'** Common Window Styles **
%WS_OVERLAPPEDWINDOW              = %WS_OVERLAPPED OR %WS_CAPTION OR %WS_SYSMENU OR %WS_THICKFRAME OR %WS_MINIMIZEBOX OR %WS_MAXIMIZEBOX
%WS_CHILDWINDOW                   = %WS_CHILD
%WS_TILEDWINDOW                   = %WS_OVERLAPPEDWINDOW

' Extended Window Styles
%WS_EX_DLGMODALFRAME              = &H00001???
%WS_EX_NOPARENTNOTIFY             = &H00004???

' Class styles
%CS_VREDRAW                       = &H1
%CS_HREDRAW                       = &H2
%CS_KEYCVTWINDOW                  = &H4
%CS_DBLCLKS                       = &H8
%CS_OWNDC                         = &H20
%CS_CLASSDC                       = &H40
%CS_PARENTDC                      = &H80
%CS_NOKEYCVT                      = &H100
%CS_NOCLOSE                       = &H200
%CS_SAVEBITS                      = &H800
%CS_BYTEALIGNCLIENT               = &H1000
%CS_BYTEALIGNWINDOW               = &H2000
%CS_GLOBALCLASS                   = &H4000    '  Global window class

' Clipboard Formats
%CF_TEXT                          = 1
%CF_BITMAP                        = 2
%CF_METAFILEPICT                  = 3
%CF_SYLK                          = 4
%CF_DIF                           = 5
%CF_TIFF                          = 6
%CF_OEMTEXT                       = 7
%CF_DIB                           = 8
%CF_PALETTE                       = 9

%CF_OWNERDISPLAY                  = &H80
%CF_DSPTEXT                       = &H81
%CF_DSPBITMAP                     = &H82
%CF_DSPMETAFILEPICT               = &H83

%CF_PRIVATEFIRST                  = &H200
%CF_PRIVATELAST                   = &H2FF

' "GDIOBJ" formats do get DeleteObject()'d
%CF_GDIOBJFIRST                   = &H300
%CF_GDIOBJLAST                    = &H3FF

' Owner draw control types
%ODT_MENU                         = 1
%ODT_LISTBOX                      = 2
%ODT_COMBOBOX                     = 3
%ODT_BUTTON                       = 4

' Owner draw actions
%ODA_DRAWENTIRE                   = &H1
%ODA_SELECT                       = &H2
%ODA_FOCUS                        = &H4

' Owner draw state
%ODS_SELECTED                     = &H1
%ODS_GRAYED                       = &H2
%ODS_DISABLED                     = &H4
%ODS_CHECKED                      = &H8
%ODS_FOCUS                        = &H10

' PeekMessage() Options
%PM_NOREMOVE                      = &H0
%PM_REMOVE                        = &H1
%PM_NOYIELD                       = &H2

' Flags for _lopen
%READAPI                          = 0
%WRITEAPI                         = 1
%READ_WRITE                       = 2

%EW_RESTARTWINDOWS                = &H42

' Special HWND value for use with PostMessage and SendMessage
%HWND_BROADCAST                   = &HFFFF

%CW_USEDEFAULT                    = &H8000
%HWND_DESKTOP                     = 0

' SetWindowPos Flags
%SWP_NOSIZE                       = &H1
%SWP_NOMOVE                       = &H2
%SWP_NOZORDER                     = &H4
%SWP_NOREDRAW                     = &H8
%SWP_NOACTIVATE                   = &H10
%SWP_DRAWFRAME                    = &H20
%SWP_SHOWWINDOW                   = &H40
%SWP_HIDEWINDOW                   = &H80
%SWP_NOCOPYBITS                   = &H100
%SWP_NOREPOSITION                 = &H200

' SetWindowPos() hWndInsertAfter values
%HWND_TOP                         =  0
%HWND_BOTTOM                      =  1
%HWND_TOPMOST                     = -1
%HWND_NOTOPMOST                   = -2

%DLGWINDOWEXTRA                   = 30 '  Window extra bytes needed for private dialog classes

' GetSystemMetrics() codes
%SM_CXSCREEN                      =  0
%SM_CYSCREEN                      =  1
%SM_CXVSCROLL                     =  2
%SM_CYHSCROLL                     =  3
%SM_CYCAPTION                     =  4
%SM_CXBORDER                      =  5
%SM_CYBORDER                      =  6
%SM_CXDLGFRAME                    =  7
%SM_CYDLGFRAME                    =  8
%SM_CYVTHUMB                      =  9
%SM_CXHTHUMB                      = 10
%SM_CXICON                        = 11
%SM_CYICON                        = 12
%SM_CXCURSOR                      = 13
%SM_CYCURSOR                      = 14
%SM_CYMENU                        = 15
%SM_CXFULLSCREEN                  = 16
%SM_CYFULLSCREEN                  = 17
%SM_CYKANJIWINDOW                 = 18
%SM_MOUSEPRESENT                  = 19
%SM_CYVSCROLL                     = 20
%SM_CXHSCROLL                     = 21
%SM_DEBUG                         = 22
%SM_SWAPBUTTON                    = 23
%SM_RESERVED1                     = 24
%SM_RESERVED2                     = 25
%SM_RESERVED3                     = 26
%SM_RESERVED4                     = 27
%SM_CXMIN                         = 28
%SM_CYMIN                         = 29
%SM_CXSIZE                        = 30
%SM_CYSIZE                        = 31
%SM_CXFRAME                       = 32
%SM_CYFRAME                       = 33
%SM_CXMINTRACK                    = 34
%SM_CYMINTRACK                    = 35
%SM_CMETRICS                      = 36

' MessageBox() Flags
%MB_OK                            = &H0
%MB_OKCANCEL                      = &H1
%MB_ABORTRETRYIGNORE              = &H2
%MB_YESNOCANCEL                   = &H3
%MB_YESNO                         = &H4
%MB_RETRYCANCEL                   = &H5

%MB_ICONHAND                      = &H10
%MB_ICONQUESTION                  = &H20
%MB_ICONEXCLAMATION               = &H30
%MB_ICONASTERISK                  = &H40

%MB_ICONINFORMATION               = %MB_ICONASTERISK
%MB_ICONSTOP                      = %MB_ICONHAND

%MB_DEFBUTTON1                    = &H0
%MB_DEFBUTTON2                    = &H100
%MB_DEFBUTTON3                    = &H200

%MB_APPLMODAL                     = &H0
%MB_SYSTEMMODAL                   = &H1000
%MB_TASKMODAL                     = &H2000

%MB_NOFOCUS                       = &H8000

%MB_TYPEMASK                      = &HF
%MB_ICONMASK                      = &HF0
%MB_DEFMASK                       = &HF00
%MB_MODEMASK                      = &H3000
%MB_MISCMASK                      = &HC000

' Color TYPEs
%CTLCOLOR_MSGBOX                  =  0
%CTLCOLOR_EDIT                    =  1
%CTLCOLOR_LISTBOX                 =  2
%CTLCOLOR_BTN                     =  3
%CTLCOLOR_DLG                     =  4
%CTLCOLOR_SCROLLBAR               =  5
%CTLCOLOR_STATIC                  =  6
%CTLCOLOR_MAX                     =  8   '  three bits max

%COLOR_SCROLLBAR                  =  0
%COLOR_BACKGROUND                 =  1
%COLOR_ACTIVECAPTION              =  2
%COLOR_INACTIVECAPTION            =  3
%COLOR_MENU                       =  4
%COLOR_WINDOW                     =  5
%COLOR_WINDOWFRAME                =  6
%COLOR_MENUTEXT                   =  7
%COLOR_WINDOWTEXT                 =  8
%COLOR_CAPTIONTEXT                =  9
%COLOR_ACTIVEBORDER               = 10
%COLOR_INACTIVEBORDER             = 11
%COLOR_APPWORKSPACE               = 12
%COLOR_HIGHLIGHT                  = 13
%COLOR_HIGHLIGHTTEXT              = 14
%COLOR_BTNFACE                    = 15
%COLOR_BTNSHADOW                  = 16
%COLOR_GRAYTEXT                   = 17
%COLOR_BTNTEXT                    = 18
%COLOR_BTNHILIGHT                 = 20
%COLOR_ENDCOLORS                  = %COLOR_BTNHILIGHT

' GetWindow() Constants
%GW_HWNDFIRST                     = 0
%GW_HWNDLAST                      = 1
%GW_HWNDNEXT                      = 2
%GW_HWNDPREV                      = 3
%GW_OWNER                         = 4
%GW_CHILD                         = 5

' Menu flags for Add/Check/EnableMenuItem()
%MF_INSERT                        = &H0
%MF_CHANGE                        = &H80
%MF_APPEND                        = &H100
%MF_DELETE                        = &H200
%MF_REMOVE                        = &H1000

%MF_BYCOMMAND                     = &H0
%MF_BYPOSITION                    = &H400

%MF_SEPARATOR                     = &H800

%MF_ENABLED                       = &H0
%MF_GRAYED                        = &H1
%MF_DISABLED                      = &H2

%MF_UNCHECKED                     = &H0
%MF_CHECKED                       = &H8
%MF_USECHECKBITMAPS               = &H200

%MF_STRING                        = &H0
%MF_BITMAP                        = &H4
%MF_OWNERDRAW                     = &H100

%MF_POPUP                         = &H10
%MF_MENUBARBREAK                  = &H20
%MF_MENUBREAK                     = &H40

%MF_UNHILITE                      = &H0
%MF_HILITE                        = &H80

%MF_SYSMENU                       = &H2000
%MF_HELP                          = &H4000
%MF_MOUSESELECT                   = &H8000

%MF_END = &H80

' System Menu Command Values
%SC_ARRANGE                       = &HF110
%SC_CLOSE                         = &HF060
%SC_HSCROLL                       = &HF080
%SC_KEYMENU                       = &HF100
%SC_MAXIMIZE                      = &HF030
%SC_MINIMIZE                      = &HF020
%SC_MOUSEMENU                     = &HF090
%SC_MOVE                          = &HF010
%SC_NEXTWINDOW                    = &HF040
%SC_PREVWINDOW                    = &HF050
%SC_RESTORE                       = &HF120
%SC_SEPERATOR                     = &H0000
%SC_SIZE                          = &HF000
%SC_TASKLIST                      = &HF130
%SC_VSCROLL                       = &HF070

%SC_ICON                          = %SC_MINIMIZE
%SC_ZOOM                          = %SC_MAXIMIZE

' Standard Cursor IDs
%IDC_ARROW                        = 32512???
%IDC_IBEAM                        = 32513???
%IDC_WAIT                         = 32514???
%IDC_CROSS                        = 32515???
%IDC_UPARROW                      = 32516???
%IDC_SIZE                         = 32640???
%IDC_ICON                         = 32641???
%IDC_SIZENWSE                     = 32642???
%IDC_SIZENESW                     = 32643???
%IDC_SIZEWE                       = 32644???
%IDC_SIZENS                       = 32645???

%ORD_LANGDRIVER                   = 1 '  The ordinal number for the entry point of
                                      '  language drivers.

' Standard Icon IDs
%IDI_APPLICATION                  = 32512???
%IDI_HAND                         = 32513???
%IDI_QUESTION                     = 32514???
%IDI_EXCLAMATION                  = 32515???
%IDI_ASTERISK                     = 32516???

' Dialog Box Command IDs
%IDOK                             = 1
%IDCANCEL                         = 2
%IDABORT                          = 3
%IDRETRY                          = 4
%IDIGNORE                         = 5
%IDYES                            = 6
%IDNO                             = 7

' Edit Control Styles
%ES_LEFT                          = &H0???
%ES_CENTER                        = &H1???
%ES_RIGHT                         = &H2???
%ES_MULTILINE                     = &H4???
%ES_UPPERCASE                     = &H8???
%ES_LOWERCASE                     = &H10???
%ES_PASSWORD                      = &H20???
%ES_AUTOVSCROLL                   = &H40???
%ES_AUTOHSCROLL                   = &H80???
%ES_NOHIDESEL                     = &H100???
%ES_OEMCONVERT                    = &H400???

' Edit Control Notification Codes
%EN_SETFOCUS                      = &H100
%EN_KILLFOCUS                     = &H200
%EN_CHANGE                        = &H300
%EN_UPDATE                        = &H400
%EN_ERRSPACE                      = &H500
%EN_MAXTEXT                       = &H501
%EN_HSCROLL                       = &H601
%EN_VSCROLL                       = &H602

' Edit Control Messages
%EM_GETSEL                        = %WM_USER +  0
%EM_SETSEL                        = %WM_USER +  1
%EM_GETRECT                       = %WM_USER +  2
%EM_SETRECT                       = %WM_USER +  3
%EM_SETRECTNP                     = %WM_USER +  4
%EM_SCROLL                        = %WM_USER +  5
%EM_LINESCROLL                    = %WM_USER +  6
%EM_GETMODIFY                     = %WM_USER +  8
%EM_SETMODIFY                     = %WM_USER +  9
%EM_GETLINECOUNT                  = %WM_USER + 10
%EM_LINEINDEX                     = %WM_USER + 11
%EM_SETHANDLE                     = %WM_USER + 12
%EM_GETHANDLE                     = %WM_USER + 13
%EM_GETTHUMB                      = %WM_USER + 14
%EM_LINELENGTH                    = %WM_USER + 17
%EM_REPLACESEL                    = %WM_USER + 18
%EM_SETFONT                       = %WM_USER + 19
%EM_GETLINE                       = %WM_USER + 20
%EM_LIMITTEXT                     = %WM_USER + 21
%EM_CANUNDO                       = %WM_USER + 22
%EM_UNDO                          = %WM_USER + 23
%EM_FMTLINES                      = %WM_USER + 24
%EM_LINEFROMCHAR                  = %WM_USER + 25
%EM_SETWORDBREAK                  = %WM_USER + 26
%EM_SETTABSTOPS                   = %WM_USER + 27
%EM_SETPASSWORDCHAR               = %WM_USER + 28
%EM_EMPTYUNDOBUFFER               = %WM_USER + 29
%EM_MSGMAX                        = %WM_USER + 30

' Button Control Styles
%BS_PUSHBUTTON                    = &H0???
%BS_DEFPUSHBUTTON                 = &H1???
%BS_CHECKBOX                      = &H2???
%BS_AUTOCHECKBOX                  = &H3???
%BS_RADIOBUTTON                   = &H4???
%BS_3STATE                        = &H5???
%BS_AUTO3STATE                    = &H6???
%BS_GROUPBOX                      = &H7???
%BS_USERBUTTON                    = &H8???
%BS_AUTORADIOBUTTON               = &H9???
%BS_PUSHBOX                       = &HA???
%BS_OWNERDRAW                     = &HB???
%BS_LEFTTEXT                      = &H20???

' User Button Notification Codes
%BN_CLICKED                       = 0
%BN_PAINT                         = 1
%BN_HILITE                        = 2
%BN_UNHILITE                      = 3
%BN_DISABLE                       = 4
%BN_DOUBLECLICKED                 = 5

' Button Control Messages
%BM_GETCHECK                      = %WM_USER + 0
%BM_SETCHECK                      = %WM_USER + 1
%BM_GETSTATE                      = %WM_USER + 2
%BM_SETSTATE                      = %WM_USER + 3
%BM_SETSTYLE                      = %WM_USER + 4

' Static Control Constants
%SS_LEFT                          = &H0???
%SS_CENTER                        = &H1???
%SS_RIGHT                         = &H2???
%SS_ICON                          = &H3???
%SS_BLACKRECT                     = &H4???
%SS_GRAYRECT                      = &H5???
%SS_WHITERECT                     = &H6???
%SS_BLACKFRAME                    = &H7???
%SS_GRAYFRAME                     = &H8???
%SS_WHITEFRAME                    = &H9???
%SS_USERITEM                      = &HA???
%SS_SIMPLE                        = &HB???
%SS_LEFTNOWORDWRAP                = &HC???
%SS_NOPREFIX                      = &H80??? ' Don't do "&" character translation

' Dialog Styles
%DS_ABSALIGN                      = &H1???
%DS_SYSMODAL                      = &H2???
%DS_3DLOOK                        = &H4???    '  3D Look in Windows 95/NT
%DS_LOCALEDIT                     = &H20???   '  Edit items get Local storage.
%DS_SETFONT                       = &H40???   '  User specified font for Dlg controls
%DS_MODALFRAME                    = &H80???   '  Can be combined with WS_CAPTION
%DS_NOIDLEMSG                     = &H100???  '  WM_ENTERIDLE message will not be sent

%DM_GETDEFID                      = %WM_USER + 0
%DM_SETDEFID                      = %WM_USER + 1
%DC_HASDEFID                      = &H534%  '0x534B

' Dialog Codes
%DLGC_WANTARROWS                  = &H1     '  Control wants arrow keys
%DLGC_WANTTAB                     = &H2     '  Control wants tab keys
%DLGC_WANTALLKEYS                 = &H4     '  Control wants all keys
%DLGC_WANTMESSAGE                 = &H4     '  Pass message to control
%DLGC_HASSETSEL                   = &H8     '  Understands EM_SETSEL message
%DLGC_DEFPUSHBUTTON               = &H10    '  Default pushbutton
%DLGC_UNDEFPUSHBUTTON             = &H20    '  Non-default pushbutton
%DLGC_RADIOBUTTON                 = &H40    '  Radio button
%DLGC_WANTCHARS                   = &H80    '  Want WM_CHAR messages
%DLGC_STATIC                      = &H100   '  Static item: don't include
%DLGC_BUTTON                      = &H2000  ' Button item: can be checked

%LB_CTLCODE                       = 0???

' Listbox Return Values
%LB_OKAY                          =  0
%LB_ERR                           = -1
%LB_ERRSPACE                      = -2

'
' The idStaticPath parameter to DlgDirList can have the following values
' ORed if the list box should show other details of the files along with
' the name of the files;

' all other details also will be returned

' Listbox Notification Codes
%LBN_ERRSPACE                     = -2
%LBN_SELCHANGE                    =  1
%LBN_DBLCLK                       =  2
%LBN_SELCANCEL                    =  3
%LBN_SETFOCUS                     =  4
%LBN_KILLFOCUS                    =  5

' Listbox messages
%LB_ADDSTRING                     = %WM_USER + 1
%LB_INSERTSTRING                  = %WM_USER + 2
%LB_DELETESTRING                  = %WM_USER + 3
%LB_RESETCONTENT                  = %WM_USER + 5
%LB_SETSEL                        = %WM_USER + 6
%LB_SETCURSEL                     = %WM_USER + 7
%LB_GETSEL                        = %WM_USER + 8
%LB_GETCURSEL                     = %WM_USER + 9
%LB_GETTEXT                       = %WM_USER + 10
%LB_GETTEXTLEN                    = %WM_USER + 11
%LB_GETCOUNT                      = %WM_USER + 12
%LB_SELECTSTRING                  = %WM_USER + 13
%LB_DIR                           = %WM_USER + 14
%LB_GETTOPINDEX                   = %WM_USER + 15
%LB_FINDSTRING                    = %WM_USER + 16
%LB_GETSELCOUNT                   = %WM_USER + 17
%LB_GETSELITEMS                   = %WM_USER + 18
%LB_SETTABSTOPS                   = %WM_USER + 19
%LB_GETHORIZONTALEXTENT           = %WM_USER + 20
%LB_SETHORIZONTALEXTENT           = %WM_USER + 21
%LB_SETCOLUMNWIDTH                = %WM_USER + 22
%LB_SETTOPINDEX                   = %WM_USER + 24
%LB_GETITEMRECT                   = %WM_USER + 25
%LB_GETITEMDATA                   = %WM_USER + 26
%LB_SETITEMDATA                   = %WM_USER + 27
%LB_SELITEMRANGE                  = %WM_USER + 28
%LB_MSGMAX                        = %WM_USER + 33

' Listbox Styles
%LBS_NOTIFY                       = &H1???
%LBS_SORT                         = &H2???
%LBS_NOREDRAW                     = &H4???
%LBS_MULTIPLESEL                  = &H8???
%LBS_OWNERDRAWFIXED               = &H10???
%LBS_OWNERDRAWVARIABLE            = &H20???
%LBS_HASSTRINGS                   = &H40???
%LBS_USETABSTOPS                  = &H80???
%LBS_NOINTEGRALHEIGHT             = &H100???
%LBS_MULTICOLUMN                  = &H200???
%LBS_WANTKEYBOARDINPUT            = &H400???
%LBS_EXTENDEDSEL                  = &H800???
%LBS_STANDARD                     = %LBS_NOTIFY OR %LBS_SORT OR %WS_VSCROLL OR %WS_BORDER

' Combo Box return Values
%CB_OKAY                          =  0
%CB_ERR                           = -1
%CB_ERRSPACE                      = -2

' Combo Box Notification Codes
%CBN_ERRSPACE                     = -1
%CBN_SELCHANGE                    =  1
%CBN_DBLCLK                       =  2
%CBN_SETFOCUS                     =  3
%CBN_KILLFOCUS                    =  4
%CBN_EDITCHANGE                   =  5
%CBN_EDITUPDATE                   =  6
%CBN_DROPDOWN                     =  7

' Combo Box styles
%CBS_SIMPLE                       = &H1???
%CBS_DROPDOWN                     = &H2???
%CBS_DROPDOWNLIST                 = &H3???
%CBS_OWNERDRAWFIXED               = &H10???
%CBS_OWNERDRAWVARIABLE            = &H20???
%CBS_AUTOHSCROLL                  = &H40???
%CBS_OEMCONVERT                   = &H80???
%CBS_SORT                         = &H100???
%CBS_HASSTRINGS                   = &H200???
%CBS_NOINTEGRALHEIGHT             = &H400???

' Combo Box messages
%CB_GETEDITSEL                    = %WM_USER + 0
%CB_LIMITTEXT                     = %WM_USER + 1
%CB_SETEDITSEL                    = %WM_USER + 2
%CB_ADDSTRING                     = %WM_USER + 3
%CB_DELETESTRING                  = %WM_USER + 4
%CB_DIR                           = %WM_USER + 5
%CB_GETCOUNT                      = %WM_USER + 6
%CB_GETCURSEL                     = %WM_USER + 7
%CB_GETLBTEXT                     = %WM_USER + 8
%CB_GETLBTEXTLEN                  = %WM_USER + 9
%CB_INSERTSTRING                  = %WM_USER + 10
%CB_RESETCONTENT                  = %WM_USER + 11
%CB_FINDSTRING                    = %WM_USER + 12
%CB_SELECTSTRING                  = %WM_USER + 13
%CB_SETCURSEL                     = %WM_USER + 14
%CB_SHOWDROPDOWN                  = %WM_USER + 15
%CB_GETITEMDATA                   = %WM_USER + 16
%CB_SETITEMDATA                   = %WM_USER + 17
%CB_GETDROPPEDCONTROLRECT         = %WM_USER + 18
%CB_MSGMAX                        = %WM_USER + 19

' Scroll Bar Styles
%SBS_HORZ                         = 0???
%SBS_VERT                         = 1???
%SBS_TOPALIGN                     = 2???
%SBS_LEFTALIGN                    = 2???
%SBS_BOTTOMALIGN                  = 4???
%SBS_RIGHTALIGN                   = 4???
%SBS_SIZEBOXTOPLEFTALIGN          = 2???
%SBS_SIZEBOXBOTTOMRIGHTALIGN      = 4???
%SBS_SIZEBOX                      = 8???

' COMM declarations
%NOPARITY                         = 0
%ODDPARITY                        = 1
%EVENPARITY                       = 2
%MARKPARITY                       = 3
%SPACEPARITY                      = 4

%ONESTOPBIT                       = 0
%ONE5STOPBITS                     = 1
%TWOSTOPBITS                      = 2

%IGNORE                           = 0       '  Ignore signal
%INFINITE                         = &HFFFF  '  Infinite timeout

' Error Flags
%CE_RXOVER                        = &H1     '  Receive Queue overflow
%CE_OVERRUN                       = &H2     '  Receive Overrun Error
%CE_RXPARITY                      = &H4     '  Receive Parity Error
%CE_FRAME                         = &H8     '  Receive Framing error
%CE_BREAK                         = &H10    '  Break Detected
%CE_CTSTO                         = &H20    '  CTS Timeout
%CE_DSRTO                         = &H40    '  DSR Timeout
%CE_RLSDTO                        = &H80    '  RLSD Timeout
%CE_TXFULL                        = &H100   '  TX Queue is full
%CE_PTO                           = &H200   '  LPTx Timeout
%CE_IOE                           = &H400   '  LPTx I/O Error
%CE_DNS                           = &H800   '  LPTx Device not selected
%CE_OOP                           = &H1000  '  LPTx Out-Of-Paper
%CE_MODE                          = &H8000  '  Requested mode unsupported

%IE_BADID                         = -1     ' Invalid or unsupported id
%IE_OPEN                          = -2     ' Device Already Open
%IE_NOPEN                         = -3     ' Device Not Open
%IE_MEMORY                        = -4     ' Unable to allocate queues
%IE_DEFAULT                       = -5     ' Error in default parameters
%IE_HARDWARE                      = -10    ' Hardware Not Present
%IE_BYTESIZE                      = -11    ' Illegal Byte Size
%IE_BAUDRATE                      = -12    ' Unsupported BaudRate

' Events
%EV_RXCHAR                        = &H1    ' ANY Character received
%EV_RXFLAG                        = &H2    ' Received certain character
%EV_TXEMPTY                       = &H4    ' Transmitt Queue Empty
%EV_CTS                           = &H8    ' CTS changed state
%EV_DSR                           = &H10   ' DSR changed state
%EV_RLSD                          = &H20   ' RLSD changed state
%EV_BREAK                         = &H40   ' BREAK received
%EV_ERR                           = &H80   ' Line status error occurred
%EV_RING                          = &H100  ' Ring signal detected
%EV_PERR                          = &H200  ' Printer error occured

' Escape FUNCTIONs
%SETXOFF                          = 1    ' Simulate XOFF received
%SETXON                           = 2    ' Simulate XON received
%SETRTS                           = 3    ' Set RTS high
%CLRRTS                           = 4    ' Set RTS low
%SETDTR                           = 5    ' Set DTR high
%CLRDTR                           = 6    ' Set DTR low
%RESETDEV                         = 7    ' Reset device if possible

%LPTx                             = &H80 ' Set if ID is for LPT device

' Commands to pass WinHelp()
%HELP_CONTEXT                     = &H1   ' Display topic in ulTopic
%HELP_QUIT                        = &H2   ' Terminate help
%HELP_INDEX                       = &H3   ' Display index
%HELP_CONTENTS                    = &H3   ' Display Help for a particular topic
%HELP_HELPONHELP                  = &H4   ' Display help on using help
%HELP_SETINDEX                    = &H5   ' Set the current Index for multi index help
%HELP_SETCONTENTS                 = &H5   ' Display Help contents topic
%HELP_CONTEXTPOPUP                = &H8   ' Display Help topic in popup window
%HELP_FORCEFILE                   = &H9   ' Ensure correct Help file is displayed
%HELP_KEY                         = &H101 ' Display topic for keyword in offabData
%HELP_COMMAND                     = &H102 ' Execute Help macro
%HELP_PARTIALKEY                  = &H105 ' Display topic found in keyword list
%HELP_MULTIKEY                    = &H201
%HELP_SETWINPOS                   = &H203 ' Display and position Help window

%GFSR_SYSTEMRESOURCES             = &H0000
%GFSR_GDIRESOURCES                = &H0001
%GFSR_USERRESOURCES               = &H0002

' ***** LogParamError/LogError values *****
' Error modifier bits
%ERR_WARNING                      = &H8000
%ERR_PARAM                        = &H4000

%ERR_SIZE_MASK                    = &H3000
%ERR_BYTE                         = &H1000
%ERR_WORD                         = &H2000
%ERR_DWORD                        = &H3000


' ***** LogParamError() values *****
' Generic parameter values
%ERR_BAD_VALUE                    = &H6001
%ERR_BAD_FLAGS                    = &H6002
%ERR_BAD_INDEX                    = &H6003
%ERR_BAD_DVALUE                   = &H7004
%ERR_BAD_DFLAGS                   = &H7005
%ERR_BAD_DINDEX                   = &H7006
%ERR_BAD_PTR                      = &H7007
%ERR_BAD_FUNC_PTR                 = &H7008
%ERR_BAD_SELECTOR                 = &H6009
%ERR_BAD_STRING_PTR               = &H700A
%ERR_BAD_HANDLE                   = &H600B

' KERNEL parameter errors
%ERR_BAD_HINSTANCE                = &H6020
%ERR_BAD_HMODULE                  = &H6021
%ERR_BAD_GLOBAL_HANDLE            = &H6022
%ERR_BAD_LOCAL_HANDLE             = &H6023
%ERR_BAD_ATOM                     = &H6024
%ERR_BAD_HFILE                    = &H6025

' USER parameter errors
%ERR_BAD_HWND                     = &H6040
%ERR_BAD_HMENU                    = &H6041
%ERR_BAD_HCURSOR                  = &H6042
%ERR_BAD_HICON                    = &H6043
%ERR_BAD_HDWP                     = &H6044
%ERR_BAD_CID                      = &H6045
%ERR_BAD_HDRVR                    = &H6046

' GDI parameter errors
%ERR_BAD_COORDS                   = &H7060
%ERR_BAD_GDI_OBJECT               = &H6061
%ERR_BAD_HDC                      = &H6062
%ERR_BAD_HPEN                     = &H6063
%ERR_BAD_HFONT                    = &H6064
%ERR_BAD_HBRUSH                   = &H6065
%ERR_BAD_HBITMAP                  = &H6066
%ERR_BAD_HRGN                     = &H6067
%ERR_BAD_HPALETTE                 = &H6068
%ERR_BAD_HMETAFILE                = &H6069

' ***** LogError() values *****
' KERNEL errors
%ERR_GALLOC                       = &H0001
%ERR_GREALLOC                     = &H0002
%ERR_GLOCK                        = &H0003
%ERR_LALLOC                       = &H0004
%ERR_LREALLOC                     = &H0005
%ERR_LLOCK                        = &H0006
%ERR_ALLOCRES                     = &H0007
%ERR_LOCKRES                      = &H0008
%ERR_LOADMODULE                   = &H0009

' USER errors
%ERR_CREATEDLG                    = &H0040
%ERR_CREATEDLG2                   = &H0041
%ERR_REGISTERCLASS                = &H0042
%ERR_DCBUSY                       = &H0043
%ERR_CREATEWND                    = &H0044
%ERR_STRUCEXTRA                   = &H0045
%ERR_LOADSTR                      = &H0046
%ERR_LOADMENU                     = &H0047
%ERR_NESTEDBEGINPAINT             = &H0048
%ERR_BADINDEX                     = &H0049
%ERR_CREATEMENU                   = &H004A

' GDI errors
%ERR_CREATEDC                     = &H0080
%ERR_CREATEMETA                   = &H0081
%ERR_DELOBJSELECTED               = &H0082
%ERR_SELBITMAP                    = &H0083

' WINDEBUGINFO flags values
%WDI_OPTIONS                      = &H0001
%WDI_FILTER                       = &H0002
%WDI_ALLOCBREAK                   = &H0004

' dwOptions values
%DBO_CHECKHEAP                    = &H0001
%DBO_BUFFERFILL                   = &H0004
%DBO_DISABLEGPTRAPPING            = &H0010
%DBO_CHECKFREE                    = &H0020
%DBO_SILENT                       = &H8000
%DBO_TRACEBREAK                   = &H2000
%DBO_WARNINGBREAK                 = &H1000
%DBO_NOERRORBREAK                 = &H0800
%DBO_NOFATALBREAK                 = &H0400
%DBO_INT3BREAK                    = &H0100

' DebugOutput flags values
%DBF_TRACE                        = &H0000
%DBF_WARNING                      = &H4000
%DBF_ERROR                        = &H8000
%DBF_FATAL                        = &HC000

' dwFilter values
%DBF_KERNEL                       = &H1000
%DBF_KRN_MEMMAN                   = &H0001
%DBF_KRN_LOADMODULE               = &H0002
%DBF_KRN_SEGMENTLOAD              = &H0004
%DBF_USER                         = &H0800
%DBF_GDI                          = &H0400
%DBF_MMSYSTEM                     = &H0040
%DBF_PENWIN                       = &H0020
%DBF_APPLICATION                  = &H0008
%DBF_DRIVER                       = &H0010

%EW_REBOOTSYSTEM                  = &H43

%OBM_LFARROWI                     = 32734
%OBM_RGARROWI                     = 32735
%OBM_DNARROWI                     = 32736
%OBM_UPARROWI                     = 32737

%DCB_RESET                        = &H0001
%DCB_ACCUMULATE                   = &H0002
%DCB_DIRTY                        = %DCB_ACCUMULATE
%DCB_SET                          = %DCB_RESET OR %DCB_ACCUMULATE
%DCB_ENABLE                       = &H0004
%DCB_DISABLE                      = &H0008

%COLOR_INACTIVECAPTIONTEXT        = 19
%COLOR_BTNHIGHLIGHT               = 20

%OUT_TT_PRECIS                    = 4
%OUT_DEVICE_PRECIS                = 5
%OUT_RASTER_PRECIS                = 6
%OUT_TT_ONLY_PRECIS               = 7

%CLIP_LH_ANGLES                   = &H10
%CLIP_TT_ALWAYS                   = &H20
%CLIP_EMBEDDED                    = &H80

%TMPF_TRUETYPE                    = &H04

' ntmFlags field flags
%NTM_REGULAR                      = &H00000040???
%NTM_BOLD                         = &H00000020???
%NTM_ITALIC                       = &H00000001???

%LF_FULLFACESIZE                  = 64

%TRUETYPE_FONTTYPE                = &H0004

' GetGlyphOutline constants
%GGO_METRICS                      = 0
%GGO_BITMAP                       = 1
%GGO_NATIVE                       = 2

%TT_POLYGON_TYPE                  = 24

%TT_PRIM_LINE                     =  1
%TT_PRIM_QSPLINE                  =  2

' bits defined in wFlags of RASTERIZER_STATUS
%TT_AVAILABLE                     = &H0001
%TT_ENABLED                       = &H0002

%SM_CXDOUBLECLK                   = 36
%SM_CYDOUBLECLK                   = 37
%SM_CXICONSPACING                 = 38
%SM_CYICONSPACING                 = 39
%SM_MENUDROPALIGNMENT             = 40
%SM_PENWINDOWS                    = 41
%SM_DBCSENABLED                   = 42

%SPI_GETBEEP                      =  1
%SPI_SETBEEP                      =  2
%SPI_GETMOUSE                     =  3
%SPI_SETMOUSE                     =  4
%SPI_GETBORDER                    =  5
%SPI_SETBORDER                    =  6
%SPI_GETKEYBOARDSPEED             = 10
%SPI_SETKEYBOARDSPEED             = 11
%SPI_LANGDRIVER                   = 12
%SPI_ICONHORIZONTALSPACING        = 13
%SPI_GETSCREENSAVETIMEOUT         = 14
%SPI_SETSCREENSAVETIMEOUT         = 15
%SPI_GETSCREENSAVEACTIVE          = 16
%SPI_SETSCREENSAVEACTIVE          = 17
%SPI_GETGRIDGRANULARITY           = 18
%SPI_SETGRIDGRANULARITY           = 19
%SPI_SETDESKWALLPAPER             = 20
%SPI_SETDESKPATTERN               = 21
%SPI_GETKEYBOARDDELAY             = 22
%SPI_SETKEYBOARDDELAY             = 23
%SPI_ICONVERTICALSPACING          = 24
%SPI_GETICONTITLEWRAP             = 25
%SPI_SETICONTITLEWRAP             = 26
%SPI_GETMENUDROPALIGNMENT         = 27
%SPI_SETMENUDROPALIGNMENT         = 28
%SPI_SETDOUBLECLKWIDTH            = 29
%SPI_SETDOUBLECLKHEIGHT           = 30
%SPI_GETICONTITLELOGFONT          = 31
%SPI_SETDOUBLECLICKTIME           = 32
%SPI_SETMOUSEBUTTONSWAP           = 33
%SPI_SETICONTITLELOGFONT          = 34
%SPI_GETFASTTASKSWITCH            = 35
%SPI_SETFASTTASKSWITCH            = 36

' SystemParametersInfo flags
%SPIF_UPDATEINIFILE               = &H0001
%SPIF_SENDWININICHANGE            = &H0002

' GetQueueStatus flags
%QS_KEY                           = &H0001
%QS_MOUSEMOVE                     = &H0002
%QS_MOUSEBUTTON                   = &H0004
%QS_MOUSE                         = %QS_MOUSEMOVE OR %QS_MOUSEBUTTON
%QS_POSTMESSAGE                   = &H0008
%QS_TIMER                         = &H0010
%QS_PAINT                         = &H0020
%QS_SENDMESSAGE                   = &H0040

%QS_ALLINPUT                      = &H007f

' ***** Power management *****

%WM_POWER                         = &H0048

' wParam for WM_POWER window message and DRV_POWER driver notification
%PWR_OK                           = 1
%PWR_FAIL                         = -1
%PWR_SUSPENDREQUEST               = 1
%PWR_SUSPENDRESUME                = 2
%PWR_CRITICALRESUME               = 3

%GCW_ATOM                         = -32

%WS_EX_TOPMOST                    = &H00000008???
%WS_EX_ACCEPTFILES                = &H00000010???
%WS_EX_TRANSPARENT                = &H00000020???

%WPF_SETMINPOSITION               = &H0001
%WPF_RESTORETOMAXIMIZED           = &H0002

%WM_WINDOWPOSCHANGING             = &H0046
%WM_WINDOWPOSCHANGED              = &H0047

%DCX_WINDOW                       = &H00000001???
%DCX_CACHE                        = &H00000002???
%DCX_CLIPCHILDREN                 = &H00000008???
%DCX_CLIPSIBLINGS                 = &H00000010???
%DCX_PARENTCLIP                   = &H00000020???
%DCX_EXCLUDERGN                   = &H00000040???
%DCX_INTERSECTRGN                 = &H00000080???
%DCX_LOCKWINDOWUPDATE             = &H00000400???
%DCX_USESTYLE                     = &H00010000???

%RDW_INVALIDATE                   = &H0001
%RDW_INTERNALPAINT                = &H0002
%RDW_ERASE                        = &H0004
%RDW_VALIDATE                     = &H0008
%RDW_NOINTERNALPAINT              = &H0010
%RDW_NOERASE                      = &H0020
%RDW_NOCHILDREN                   = &H0040
%RDW_ALLCHILDREN                  = &H0080
%RDW_UPDATENOW                    = &H0100
%RDW_ERASENOW                     = &H0200
%RDW_FRAME                        = &H0400
%RDW_NOFRAME                      = &H0800

%SW_SCROLLCHILDREN                = &H0001
%SW_INVALIDATE                    = &H0002
%SW_ERASE                         = &H0004

' WM_NCCALCSIZE return flags
%WVR_ALIGNTOP                     = &H0010
%WVR_ALIGNLEFT                    = &H0020
%WVR_ALIGNBOTTOM                  = &H0040
%WVR_ALIGNRIGHT                   = &H0080
%WVR_HREDRAW                      = &H0100
%WVR_VREDRAW                      = &H0200
%WVR_REDRAW                       = %WVR_HREDRAW OR %WVR_VREDRAW
%WVR_VALIDRECTS                   = &H0400

%MA_NOACTIVATEANDEAT              =  4

%TPM_LEFTALIGN                    = &H0000
%TPM_RIGHTBUTTON                  = &H0002
%TPM_CENTERALIGN                  = &H0004
%TPM_RIGHTALIGN                   = &H0008

%MDIS_ALLCHILDSTYLES              = &H0001

' wParam values for WM_MDITILE and WM_MDICASCADE messages.
%MDITILE_VERTICAL                 = &H0000
%MDITILE_HORIZONTAL               = &H0001
%MDITILE_SKIPDISABLED             = &H0002

' Static Control Mesages
%STM_SETICON                      = %WM_USER + 0
%STM_GETICON                      = %WM_USER + 1

%ES_READONLY                      = &H00000800???
%ES_WANTRETURN                    = &H00001000???

%EM_GETFIRSTVISIBLELINE           = %WM_USER + 30
%EM_SETREADONLY                   = %WM_USER + 31
%EM_SETWORDBREAKPROC              = %WM_USER + 32
%EM_GETWORDBREAKPROC              = %WM_USER + 33
%EM_GETPASSWORDCHAR               = %WM_USER + 34

' EDITWORDBREAKPROC code values
%WB_LEFT                          = 0
%WB_RIGHT                         = 1
%WB_ISDELIMITER                   = 2

%LBS_DISABLENOSCROLL              = &H1000???

%LB_SETITEMHEIGHT                 = %WM_USER + 33
%LB_GETITEMHEIGHT                 = %WM_USER + 34
%LB_FINDSTRINGEXACT               = %WM_USER + 35

%CBS_DISABLENOSCROLL              = &H0800???

%CB_SETITEMHEIGHT                 = %WM_USER + 19
%CB_GETITEMHEIGHT                 = %WM_USER + 20
%CB_SETEXTENDEDUI                 = %WM_USER + 21
%CB_GETEXTENDEDUI                 = %WM_USER + 22
%CB_GETDROPPEDSTATE               = %WM_USER + 23
%CB_FINDSTRINGEXACT               = %WM_USER + 24

%CBN_CLOSEUP                      = 8
%CBN_SELENDOK                     = 9
%CBN_SELENDCANCEL                 = 10

%WH_DEBUG                         = 9
%WH_HARDWARE                      = 8
%WH_SHELL                         = 10

%HSHELL_WINDOWCREATED             = 1
%HSHELL_WINDOWDESTROYED           = 2
%HSHELL_ACTIVATESHELLWINDOW       = 3

' Flags returned by GetSystemDebugState.
%SDS_MENU                         = &H0001
%SDS_SYSMODAL                     = &H0002
%SDS_NOTASKQUEUE                  = &H0004
%SDS_DIALOG                       = &H0008
%SDS_TASKLOCKED                   = &H0010

' new escape functions
%GETMAXLPT                        = 8
%GETMAXCOM                        = 9
%GETBASEIRQ                       = 10

' Comm Baud Rate indices
%CBR_110                          = &HFF10
%CBR_300                          = &HFF11
%CBR_600                          = &HFF12
%CBR_1200                         = &HFF13
%CBR_2400                         = &HFF14
%CBR_4800                         = &HFF15
%CBR_9600                         = &HFF16
%CBR_14400                        = &HFF17
%CBR_19200                        = &HFF18
%CBR_38400                        = &HFF1B
%CBR_56000                        = &HFF1F
%CBR_57600                        = &HFF1F
%CBR_128000                       = &HFF23
%CBR_256000                       = &HFF27

%WM_COMMNOTIFY                    = &H0044

' notifications passed in low word of lParam on WM_COMMNOTIFY messages
%CN_RECEIVE                       = &H0001
%CN_TRANSMIT                      = &H0002
%CN_EVENT                         = &H0004

' GetNextDriver flags
%GND_FIRSTINSTANCEONLY            = &H00000001
%GND_FORWARD                      = &H00000000
%GND_REVERSE                      = &H00000002

' Supported lParam1 of DRV_EXITAPPLICATION notification
%DRVEA_NORMALEXIT                 = &H0001
%DRVEA_ABNORMALEXIT               = &H0002

' Supported return values for DRV_CONFIGURE message
%DRVCNF_CANCEL                    = &H0000
%DRVCNF_OK                        = &H0001
%DRVCNF_RESTART                   = &H0002

' Driver messages
%DRV_LOAD                         = &H0001
%DRV_ENABLE                       = &H0002
%DRV_OPEN                         = &H0003
%DRV_CLOSE                        = &H0004
%DRV_DISABLE                      = &H0005
%DRV_FREE                         = &H0006
%DRV_CONFIGURE                    = &H0007
%DRV_QUERYCONFIGURE               = &H0008
%DRV_INSTALL                      = &H0009
%DRV_REMOVE                       = &H000A
%DRV_EXITSESSION                  = &H000B
%DRV_EXITAPPLICATION              = &H000C
%DRV_POWER                        = &H000F
%DRV_RESERVED                     = &H0800
%DRV_USER                         = &H4000

' ** Return Codes **
%WN_SUCCESS                       = &H0000
%WN_NOT_SUPPORTED                 = &H001
%WN_NET_ERROR                     = &H0002
%WN_MORE_DATA                     = &H0003
%WN_BAD_POINTER                   = &H0004
%WN_BAD_VALUE                     = &H0005
%WN_BAD_PASSWORD                  = &H0006
%WN_ACCESS_DENIED                 = &H0007
%WN_FUNCTION_BUSY                 = &H0008
%WN_WINDOWS_ERROR                 = &H0009
%WN_BAD_USER                      = &H000A
%WN_OUT_OF_MEMORY                 = &H000B
%WN_CANCEL                        = &H000C
%WN_CONTINUE                      = &H000D

%WN_NOT_CONNECTED                 = &H0030
%WN_OPEN_FILES                    = &H0031
%WN_BAD_NETNAME                   = &H0032
%WN_BAD_LOCALNAME                 = &H0033
%WN_ALREADY_CONNECTED             = &H0034
%WN_DEVICE_ERROR                  = &H0035
%WN_CONNECTION_CLOSED             = &H0036


'-------------------------------------------------------------------------
'                                Structures
'-------------------------------------------------------------------------

TYPE RECT
  nLeft                  AS WORD
  nTop                   AS WORD
  nRight                 AS WORD
  nBottom                AS WORD
END TYPE

TYPE POINTAPI
  x                      AS WORD
  y                      AS WORD
END TYPE

' ParameterBlock description structure for use with LoadModule
TYPE PARAMETERBLOCK
  wEnvSeg                AS WORD
  lpCmdLine              AS DWORD
  lpCmdShow              AS LONG
  dwReserved             AS DWORD
END TYPE

' OpenFile() Structure
TYPE OFSTRUCT
  cBytes                 AS BYTE
  fFixedDisk             AS BYTE
  nErrCode               AS WORD
  reserved               AS STRING * 4
  szPathName             AS STRING * 128
END TYPE

' Drag and Drop File Support
TYPE DROPFILESTRUCT
  wSize AS INTEGER            ' Number of bytes in this structure
  ptMousePos AS POINTAPI      ' Mouse position
  fInNonClientArea AS INTEGER ' TRUE if mouse was in client area
                              ' Pathnames begin after structure each one
                              ' zero-terminated; Zero-length pathname used to
                              ' indicate the end
END TYPE

' Bitmap Header Definition
TYPE BITMAP '14 bytes
  bmTYPE                 AS WORD
  bmWidth                AS WORD
  bmHeight               AS WORD
  bmWidthBytes           AS WORD
  bmPlanes               AS BYTE
  bmBitsPixel            AS BYTE
  bmBits                 AS DWORD
END TYPE

TYPE RGBTRIPLE
  rgbtBlue               AS BYTE
  rgbtGreen              AS BYTE
  rgbtRed                AS BYTE
END TYPE

TYPE RGBQUAD
  rgbBlue                AS BYTE
  rgbGreen               AS BYTE
  rgbRed                 AS BYTE
  rgbReserved            AS BYTE
END TYPE

' structures for defining DIBs
TYPE BITMAPCOREHEADER '12 bytes
  bcSize                 AS DWORD
  bcWidth                AS WORD
  bcHeight               AS WORD
  bcPlanes               AS WORD
  bcBitCount             AS WORD
END TYPE

TYPE BITMAPINFOHEADER '40 bytes
  biSize                 AS DWORD
  biWidth                AS DWORD
  biHeight               AS DWORD
  biPlanes               AS WORD
  biBitCount             AS WORD
  biCompression          AS DWORD
  biSizeImage            AS DWORD
  biXPelsPerMeter        AS DWORD
  biYPelsPerMeter        AS DWORD
  biClrUsed              AS DWORD
  biClrImportant         AS DWORD
END TYPE

TYPE BITMAPINFO
  bmiHeader              AS BITMAPINFOHEADER
  bmiColors              AS STRING * 128 ' Array length is arbitrary; may be changed
END TYPE

TYPE BITMAPCOREINFO
  bmciHeader             AS BITMAPCOREHEADER
  bmciColors             AS STRING * 96 ' Array length is arbitrary; may be changed
END TYPE

TYPE BITMAPFILEHEADER
  bfTYPE                 AS WORD
  bfSize                 AS DWORD
  bfReserved1            AS WORD
  bfReserved2            AS WORD
  bfOffBits              AS DWORD
END TYPE

' Clipboard Metafile Picture Structure
TYPE HANDLETABLE
  objectHandle           AS STRING * 512 ' Array length is arbitrary; may be changed
END TYPE

TYPE METARECORD
  rdSize                 AS DWORD
  rdFUNCTION             AS WORD
  rdParm                 AS STRING * 512 ' Array length is arbitrary; may be changed
END TYPE

TYPE METAFILEPICT
  mm   AS WORD
  xExt AS WORD
  yExt AS WORD
  hMF  AS WORD
END TYPE

TYPE METAHEADER
  mtTYPE         AS WORD
  mtHeaderSize   AS WORD
  mtVersion      AS WORD
  mtSize         AS DWORD
  mtNoObjects    AS WORD
  mtMaxRecord    AS DWORD
  mtNoParameters AS WORD
END TYPE

TYPE TEXTMETRIC
  tmHeight           AS WORD
  tmAscent           AS WORD
  tmDescent          AS WORD
  tmInternalLeading  AS WORD
  tmExternalLeading  AS WORD
  tmAveCharWidth     AS WORD
  tmMaxCharWidth     AS WORD
  tmWeight           AS WORD
  tmItalic           AS BYTE
  tmUnderlined       AS BYTE
  tmStruckOut        AS BYTE
  tmFirstChar        AS BYTE
  tmLastChar         AS BYTE
  tmDefaultChar      AS BYTE
  tmBreakChar        AS BYTE
  tmPitchAndFamily   AS BYTE
  tmCharSet          AS BYTE
  tmOverhang         AS WORD
  tmDigitizedAspectX AS WORD
  tmDigitizedAspectY AS WORD
END TYPE

' GDI Logical Objects:

'  Pel Array
TYPE PELARRAY
  paXCount AS WORD
  paYCount AS WORD
  paXExt   AS WORD
  paYExt   AS WORD
  paRGBs   AS WORD
END TYPE

' Logical Brush (or Pattern)
TYPE LOGBRUSH
  lbStyle AS WORD
  lbColor AS DWORD
  lbHatch AS WORD
END TYPE

' Logical Pen
TYPE LOGPEN
  lopnStyle AS WORD
  lopnWidth AS POINTAPI
  lopnColor AS DWORD
END TYPE

TYPE PALETTEENTRY
  peRed   AS BYTE
  peGreen AS BYTE
  peBlue  AS BYTE
  peFlags AS BYTE
END TYPE

' Logical Palette
TYPE LOGPALETTE
  palVersion       AS WORD
  palNumEntries    AS WORD
  palPalEntry(255) AS PALETTEENTRY
END TYPE

TYPE LOGFONT
  lfHeight         AS WORD
  lfWidth          AS WORD
  lfEscapement     AS WORD
  lfOrientation    AS WORD
  lfWeight         AS WORD
  lfItalic         AS BYTE
  lfUnderline      AS BYTE
  lfStrikeOut      AS BYTE
  lfCharSet        AS BYTE
  lfOutPrecision   AS BYTE
  lfClipPrecision  AS BYTE
  lfQuality        AS BYTE
  lfPitchAndFamily AS BYTE
  lfFaceName       AS STRING * %LF_FACESIZE
END TYPE

' Message Structure used in Journaling
TYPE EVENTMSG
  message AS WORD
  paramL  AS WORD
  paramH  AS WORD
  time    AS DWORD
END TYPE

' Message structure
TYPE TAGMSG
  hWnd    AS INTEGER
  message AS INTEGER
  wParam  AS INTEGER
  lParam  AS LONG
  time    AS DWORD
  pt      AS POINTAPI
END TYPE

TYPE MSGSTRUC
  hWnd    AS WORD
  message AS WORD
  wParam  AS WORD
  lParam  AS LONG
  time    AS DWORD
  pt      AS POINTAPI
END TYPE

TYPE PAINTSTRUCT
  hdc         AS WORD
  fErase      AS WORD
  rcPaint     AS RECT
  fRestore    AS WORD
  fIncUpdate  AS WORD
  rgbReserved AS STRING * 16
END TYPE

TYPE CREATESTRUCT
  lpCreateParams AS DWORD
  hInstance      AS WORD
  hMenu          AS WORD
  hWndParent     AS WORD
  cy             AS WORD
  cx             AS WORD
  y              AS WORD
  x              AS WORD
  style          AS DWORD
  lpszName       AS DWORD
  lpszClass      AS DWORD
  ExStyle        AS DWORD
END TYPE

' MEASUREITEMSTRUCT for ownerdraw
TYPE MEASUREITEMSTRUCT
  CtlType    AS WORD
  CtlID      AS WORD
  itemID     AS WORD
  itemWidth  AS WORD
  itemHeight AS WORD
  itemData   AS DWORD
END TYPE

' DRAWITEMSTRUCT for ownerdraw
TYPE DRAWITEMSTRUCT
  CtlType    AS WORD
  CtlID      AS WORD
  itemID     AS WORD
  itemAction AS WORD
  itemState  AS WORD
  hWndItem   AS WORD
  hDC        AS WORD
  rcItem     AS RECT
  itemData   AS DWORD
END TYPE

' DELETEITEMSTRUCT for ownerdraw
TYPE DELETEITEMSTRUCT
  CtlType  AS WORD
  CtlID    AS WORD
  itemID   AS WORD
  hWndItem AS WORD
  itemData AS DWORD
END TYPE

' COMPAREITEMSTRUCT for ownerdraw sorting
TYPE COMPAREITEMSTRUCT
  CtlType                AS WORD
  CtlID                  AS WORD
  hWndItem               AS WORD
  itemID1                AS WORD
  itemData1              AS DWORD
  itemID2                AS WORD
  itemData2              AS DWORD
END TYPE

TYPE WNDCLASS
  Style                  AS WORD     ' class style
  LpfnWndProc            AS DWORD
  CbClsExtra             AS WORD
  CbWndExtra             AS WORD
  HInstance              AS WORD     ' instance handle
  HIcon                  AS WORD     ' class icon handle
  HCursor                AS WORD     ' class cursor handle
  HbrBackground          AS WORD     ' class background brush
  LpszMenuName           AS DWORD    ' menu name
  LpszClassName          AS DWORD    ' far ptr to class name
END TYPE

' Menu item resource format
TYPE MENUITEMTEMPLATEHEADER
  versionNumber          AS WORD
  offset                 AS WORD
END TYPE

TYPE MENUITEMTEMPLATE
  mtOption               AS WORD
  mtID                   AS WORD
  mtString               AS DWORD
END TYPE

TYPE DCB
  Id                     AS BYTE
  BaudRate               AS WORD
  ByteSize               AS BYTE
  Parity                 AS BYTE
  StopBits               AS BYTE
  RlsTimeout             AS WORD
  CtsTimeout             AS WORD
  DsrTimeout             AS WORD
  Bits1                  AS BYTE ' The fifteen actual DCB bit-sized data fields
  Bits2                  AS BYTE ' within these two bytes can be manipulated by
                                 ' bitwise logical And/Or operations.  Refer to
                                 ' SDKWIN.HLP for location/meaning of specific bits
  XonChar                AS BYTE
  XoffChar               AS BYTE
  XonLim                 AS WORD
  XoffLim                AS WORD
  PeChar                 AS BYTE
  EofChar                AS BYTE
  EvtChar                AS BYTE
  TxDelay                AS WORD
END TYPE

TYPE COMSTAT
  Bits                   AS BYTE ' For specific bit flags and their
                                 ' meanings, refer to SDKWIN.HLP.
  cbInQue                AS WORD
  cbOutQue               AS WORD
END TYPE

TYPE MDICREATESTRUCT
  szClass                AS DWORD
  szTitle                AS DWORD
  hOwner                 AS WORD
  x                      AS WORD
  y                      AS WORD
  cx                     AS WORD
  cy                     AS WORD
  style                  AS DWORD
  lParam                 AS DWORD
END TYPE

TYPE CLIENTCREATESTRUCT
  hWindowMenu            AS WORD
  idFirstChild           AS WORD
END TYPE

TYPE MULTIKEYHELP
  mkSize                 AS WORD
  mkKeylist              AS BYTE
  szKeyphrase            AS STRING * 253 ' Array length is arbitrary; may be changed
END TYPE

' Debugging support (DEBUG SYSTEM ONLY)
TYPE WINDEBUGINFO
  flags                  AS WORD
  dwOptions              AS DWORD
  dwFilter               AS DWORD
  achAllocModule         AS STRING * 8
  dwAllocBreak           AS DWORD
  dwAllocCount           AS DWORD
END TYPE

TYPE SIZE
  cx                     AS WORD
  cy                     AS WORD
END TYPE

TYPE PANOSE
  bFamilyType            AS BYTE
  bSerifStyle            AS BYTE
  bWeight                AS BYTE
  bProportion            AS BYTE
  bContrast              AS BYTE
  bStrokeVariation       AS BYTE
  bArmStyle              AS BYTE
  bLetterform            AS BYTE
  bMidline               AS BYTE
  bXHeight               AS BYTE
END TYPE

TYPE OUTLINETEXTMETRIC
  otmSize                AS WORD
  otmTextMetrics         AS TEXTMETRIC
  otmFiller              AS BYTE
  otmPanoseNumber        AS PANOSE
  otmfsSelection         AS WORD
  otmfsTYPE              AS WORD
  otmsCharSlopeRise      AS WORD
  otmsCharSlopeRun       AS WORD
  otmItalicAngle         AS WORD
  otmEMSquare            AS WORD
  otmAscent              AS WORD
  otmDescent             AS WORD
  otmLineGap             AS WORD
  otmsCapEmHeight        AS WORD
  otmsXHeight            AS WORD
  otmrcFontBox           AS RECT
  otmMacAscent           AS WORD
  otmMacDescent          AS WORD
  otmMacLineGap          AS WORD
  otmusMinimumPPEM       AS WORD
  otmptSUBscriptSize     AS POINTAPI
  otmptSUBscriptOffset   AS POINTAPI
  otmptSuperscriptSize   AS POINTAPI
  otmptSuperscriptOffset AS POINTAPI
  otmsStrikeoutSize      AS WORD
  otmsStrikeoutPosition  AS WORD
  otmsUnderscorePosition AS WORD
  otmsUnderscoreSize     AS WORD
  otmpFamilyName         AS DWORD
  otmpFaceName           AS DWORD
  otmpStyleName          AS DWORD
  otmpFullName           AS DWORD
END TYPE

' Structure passed to FONTENUMPROC
' NOTE: NEWTEXTMETRIC is the same AS TEXTMETRIC plus 4 new fields
TYPE NEWTEXTMETRIC
  tmHeight               AS WORD
  tmAscent               AS WORD
  tmDescent              AS WORD
  tmInternalLeading      AS WORD
  tmExternalLeading      AS WORD
  tmAveCharWidth         AS WORD
  tmMaxCharWidth         AS WORD
  tmWeight               AS WORD
  tmItalic               AS BYTE
  tmUnderlined           AS BYTE
  tmStruckOut            AS BYTE
  tmFirstChar            AS BYTE
  tmLastChar             AS BYTE
  tmDefaultChar          AS BYTE
  tmBreakChar            AS BYTE
  tmPitchAndFamily       AS BYTE
  tmCharSet              AS BYTE
  tmOverhang             AS WORD
  tmDigitizedAspectX     AS WORD
  tmDigitizedAspectY     AS WORD
  ntmFlags               AS DWORD
  ntmSizeEM              AS WORD
  ntmCellHeight          AS WORD
  ntmAvgWidth            AS WORD
END TYPE

TYPE GLYPHMETRICS
  gmBlackBoxX            AS WORD
  gmBlackBoxY            AS WORD
  gmptGlyphOrigin        AS POINTAPI
  gmCellIncX             AS WORD
  gmCellIncY             AS WORD
END TYPE

TYPE FIXED
  fract                  AS WORD
  value                  AS WORD
END TYPE

TYPE MAT2
  eM11                   AS FIXED
  eM12                   AS FIXED
  eM21                   AS FIXED
  eM22                   AS FIXED
END TYPE

TYPE POINTFX
  x                      AS FIXED
  y                      AS FIXED
END TYPE

TYPE TTPOLYCURVE
  wTYPE                  AS WORD
  cpfx                   AS WORD
  apfx                   AS POINTFX
END TYPE

TYPE TTPOLYGONHEADER
  cb                     AS DWORD
  dwTYPE                 AS DWORD
  pfxStart               AS POINTFX
END TYPE

TYPE ABC
  abcA                   AS WORD
  abcB                   AS WORD
  abcC                   AS WORD
END TYPE

TYPE KERNINGPAIR
  wFirst                 AS WORD
  wSecond                AS WORD
  iKernAmount            AS WORD
END TYPE

TYPE RASTERIZER_STATUS
  nSize                  AS WORD
  wFlags                 AS WORD
  nLanguageID            AS WORD
END TYPE

TYPE DOCINFO
  cbSize                 AS WORD
  lpszDocName            AS DWORD
  lpszOutput             AS DWORD
END TYPE

TYPE WINDOWPLACEMENT
  length                 AS WORD
  flags                  AS WORD
  showCmd                AS WORD
  ptMinPosition          AS POINTAPI
  ptMaxPosition          AS POINTAPI
  rcNormalPosition       AS RECT
END TYPE

' WM_WINDOWPOSCHANGING/CHANGED struct pointed to by lParam
TYPE WINDOWPOS
  hWnd                   AS WORD
  hWndInsertAfter        AS WORD
  x                      AS WORD
  y                      AS WORD
  cx                     AS WORD
  cy                     AS WORD
  flags                  AS WORD
END TYPE

' WM_NCCALCSIZE parameter structure
TYPE NCCALCSIZE_PARAMS
  rgrc                   AS DWORD
  lppos                  AS DWORD
END TYPE

' HCBT_CREATEWND parameters pointed to by lParam
TYPE CBT_CREATEWND
  lpcs                   AS DWORD
  hWndInsertAfter        AS WORD
END TYPE

' HCBT_ACTIVATE structure pointed to by lParam
TYPE CBTACTIVATESTRUCT
  fMouse                 AS WORD
  hWndActive             AS WORD
END TYPE

TYPE HARDWAREHOOKSTRUCT
  hWnd                   AS WORD
  wMessage               AS WORD
  wParam                 AS WORD
  lParam                 AS DWORD
END TYPE

TYPE DEBUGHOOKINFO
  hModuleHook            AS WORD
  reserved               AS DWORD
  lParam                 AS DWORD
  wParam                 AS WORD
  code                   AS WORD
END TYPE

' LPARAM of DRV_CONFIGURE message
TYPE DRVCONFIGINFO
  dwDCISize              AS DWORD
  lpszDCISectionName     AS DWORD
  lpszDCIALIASName       AS DWORD
END TYPE

TYPE DRIVERINFOSTRUCT
  length                 AS WORD
  hDriver                AS WORD
  hModule                AS WORD
  szAliasName            AS STRING * 128
END TYPE


'-------------------------------------------------------------------------
'                          Windows API Procedures
'-------------------------------------------------------------------------

DECLARE FUNCTION DlgDirSelectEx LIB "USER" (BYVAL hWndDlg AS WORD, lpszPath AS ASCIIZ, BYVAL cbPath AS WORD, BYVAL idListBox AS WORD) AS WORD
DECLARE FUNCTION DlgDirSelectComboBoxEx LIB "USER" (BYVAL hWndDlg AS WORD, lpszPath AS ASCIIZ, BYVAL cbPath AS WORD, BYVAL idComboBox AS WORD) AS WORD

DECLARE FUNCTION EnumWindows LIB "USER" (BYVAL WndEnumProc AS DWORD, BYVAL lParam AS LONG) AS INTEGER
DECLARE FUNCTION EnumChildWindows LIB "USER" (BYVAL hWnd AS WORD, BYVAL WndEnumProc AS DWORD, BYVAL lParam AS LONG) AS INTEGER
DECLARE FUNCTION EnumTaskWindows LIB "USER" (BYVAL hTask AS WORD, BYVAL WndEnumProc AS DWORD, BYVAL lParam AS LONG) AS INTEGER

DECLARE FUNCTION GetCurrentPDB LIB "KERNEL" () AS WORD
DECLARE FUNCTION GetFreeSpace LIB "KERNEL" (BYVAL wFlags AS WORD) AS DWORD
DECLARE FUNCTION GetInstanceData LIB "KERNEL" (BYVAL hInstance AS WORD, BYVAL pData AS WORD, BYVAL nCount AS WORD) AS WORD
DECLARE FUNCTION GetModuleFileName LIB "KERNEL" (BYVAL hModule AS WORD, lpFilename AS ASCIIZ, BYVAL nSize AS WORD) AS WORD
DECLARE FUNCTION GetModuleHandle LIB "KERNEL" (lpModuleName AS ASCIIZ) AS WORD
DECLARE FUNCTION GetModuleUsage LIB "KERNEL" (BYVAL hModule AS WORD) AS WORD
DECLARE FUNCTION GetNumTasks LIB "KERNEL" () AS WORD
DECLARE FUNCTION GetProcAddress LIB "KERNEL" (BYVAL hInst AS WORD, lpszProcName AS ASCIIZ) AS DWORD
DECLARE FUNCTION GetVersion LIB "KERNEL" () AS DWORD
DECLARE FUNCTION GlobalDosAlloc LIB "KERNEL" (BYVAL bytes AS DWORD) AS DWORD
DECLARE FUNCTION GlobalDosFree LIB "KERNEL" (BYVAL selector AS WORD) AS WORD
DECLARE FUNCTION LoadLibrary LIB "KERNEL" (lpLibFileName AS ASCIIZ) AS WORD
DECLARE FUNCTION LoadModule LIB "KERNEL" (lpModuleName AS ASCIIZ, lpParameterBlock AS PARAMETERBLOCK) AS WORD
DECLARE FUNCTION WinExec LIB "KERNEL" (lpCmdLine AS ASCIIZ * 99, BYVAL nCmdShow AS WORD) AS WORD

DECLARE SUB DebugBreak LIB "KERNEL" ()
DECLARE SUB Dos3Call LIB "KERNEL" ()
DECLARE SUB FreeLibrary LIB "KERNEL" (BYVAL hLibModule AS WORD)
DECLARE SUB FreeModule LIB "KERNEL" (BYVAL hModule AS WORD)
DECLARE SUB OutputDebugString LIB "KERNEL" (lpOutputString AS ASCIIZ)
DECLARE SUB SwitchStackBack LIB "KERNEL" ()
DECLARE SUB SwitchStackTo LIB "KERNEL" (BYVAL wStackSegment AS WORD, BYVAL wStackPointer AS WORD, BYVAL wStackTop AS WORD)

DECLARE FUNCTION OpenFile LIB "KERNEL" (lpFileName AS ASCIIZ, lpReOpenBuff AS OFSTRUCT, BYVAL wStyle AS WORD) AS WORD

DECLARE FUNCTION GetTempDrive LIB "KERNEL" (BYVAL cDriveLetter AS WORD) AS WORD
DECLARE FUNCTION GetTempFileName LIB "KERNEL" (BYVAL cDriveLetter AS WORD, lpPrefixString AS ASCIIZ, BYVAL wUnique AS WORD, lpTempFileName AS ASCIIZ) AS WORD
DECLARE FUNCTION SetHandleCount LIB "KERNEL" (BYVAL wNumber AS WORD) AS WORD

DECLARE FUNCTION GetDriveType LIB "KERNEL" (BYVAL nDrive AS WORD) AS WORD

DECLARE FUNCTION GlobalAlloc LIB "KERNEL" (BYVAL wFlags AS WORD, BYVAL dwBytes AS DWORD) AS WORD
DECLARE FUNCTION GlobalCompact LIB "KERNEL" (BYVAL dwMinFree AS DWORD) AS DWORD
DECLARE FUNCTION GlobalFree LIB "KERNEL" (BYVAL hMem AS WORD) AS WORD
DECLARE FUNCTION GlobalHandle LIB "KERNEL" (BYVAL wMem AS WORD) AS DWORD
DECLARE FUNCTION GlobalLock LIB "KERNEL" (BYVAL hMem AS WORD) AS DWORD
DECLARE FUNCTION GlobalReAlloc LIB "KERNEL" (BYVAL hMem AS WORD, BYVAL dwBytes AS DWORD, BYVAL wFlags AS WORD) AS WORD

DECLARE FUNCTION GetKerningPairs LIB "GDI" (BYVAL hdc AS WORD, BYVAL cPairs AS WORD, lpkrnpair AS KERNINGPAIR) AS WORD

'NOTE: instead of declaring the function GlobalDiscard and calling
'      GlobalDiscard(hMem), call GlobalReAlloc(hMem, 0, GMEM_MOVEABLE)
DECLARE FUNCTION GlobalSize LIB "KERNEL" (BYVAL hMem AS WORD) AS DWORD
DECLARE FUNCTION GlobalUnlock LIB "KERNEL" (BYVAL hMem AS WORD) AS WORD
''DECLARE FUNCTION UnlockResource LIB "KERNEL" ALIAS "GlobalUnlock" (BYVAL hMem AS WORD) AS WORD
DECLARE FUNCTION GlobalFlags LIB "KERNEL" (BYVAL hMem AS WORD) AS WORD
DECLARE FUNCTION GlobalWire LIB "KERNEL" (BYVAL hMem AS WORD) AS DWORD
DECLARE FUNCTION GlobalUnWire LIB "KERNEL" (BYVAL hMem AS WORD) AS WORD
DECLARE FUNCTION GlobalLRUNewest LIB "KERNEL" (BYVAL hMem AS WORD) AS WORD
DECLARE FUNCTION GlobalLRUOldest LIB "KERNEL" (BYVAL hMem AS WORD) AS WORD
DECLARE FUNCTION GlobalPageLock LIB "KERNEL" (BYVAL wSelector AS WORD) AS WORD
DECLARE FUNCTION GlobalPageUnlock LIB "KERNEL" (BYVAL wSelector AS WORD) AS WORD
DECLARE SUB GlobalFix LIB "KERNEL" (BYVAL hMem AS WORD)
DECLARE FUNCTION GlobalUnfix LIB "KERNEL" (BYVAL hMem AS WORD) AS WORD

DECLARE FUNCTION LockSegment LIB "KERNEL" (BYVAL wSegment AS WORD) AS WORD
DECLARE FUNCTION UnlockSegment LIB "KERNEL" (BYVAL wSegment AS WORD) AS WORD

DECLARE FUNCTION LocalAlloc LIB "KERNEL" (BYVAL wFlags AS WORD, BYVAL wBytes AS WORD) AS WORD
DECLARE FUNCTION LocalCompact LIB "KERNEL" (BYVAL wMinFree AS WORD) AS WORD
DECLARE FUNCTION LocalFree LIB "KERNEL" (BYVAL hMem AS WORD) AS WORD
DECLARE FUNCTION LocalHandle LIB "KERNEL" (BYVAL wMem AS WORD) AS WORD
DECLARE FUNCTION LocalInit LIB "KERNEL" (BYVAL wSegment AS WORD, BYVAL pStart AS WORD, BYVAL pEnd AS WORD) AS WORD
DECLARE FUNCTION LocalLock LIB "KERNEL" (BYVAL hMem AS WORD) AS WORD '(returns a near pointer)
DECLARE FUNCTION LocalReAlloc LIB "KERNEL" (BYVAL hMem AS WORD, BYVAL wBytes AS WORD, BYVAL wFlags AS WORD) AS WORD

'NOTE: instead of declaring the function LocalDiscard and calling
'      LocalDiscard(hMem), call LocalReAlloc(hMem, 0, LMEM_MOVEABLE)
DECLARE FUNCTION LocalSize LIB "KERNEL" (BYVAL hMem AS WORD) AS WORD
DECLARE FUNCTION LocalUnlock LIB "KERNEL" (BYVAL hMem AS WORD) AS WORD
DECLARE FUNCTION LocalFlags LIB "KERNEL" (BYVAL hMem AS WORD) AS WORD
DECLARE FUNCTION LocalShrink LIB "KERNEL" (BYVAL hSeg AS WORD, BYVAL wSize AS WORD) AS WORD

DECLARE FUNCTION SetErrorMode LIB "KERNEL" (BYVAL wMode AS WORD) AS WORD
DECLARE FUNCTION SetSwapAreaSize LIB "KERNEL" (BYVAL rsSize AS WORD) AS DWORD
DECLARE FUNCTION ValidateFreeSpaces LIB "KERNEL" () AS DWORD
DECLARE SUB LimitEmsPages LIB "KERNEL" (BYVAL dwKbytes AS DWORD)
DECLARE SUB ValidateCodeSegments LIB "KERNEL" ()

DECLARE FUNCTION GetDOSEnvironment LIB "KERNEL" () AS DWORD

DECLARE FUNCTION AllocDStoCSalias LIB "KERNEL" (BYVAL wSelector AS WORD) AS WORD
DECLARE FUNCTION AllocSelector LIB "KERNEL" (BYVAL wSelector AS WORD) AS WORD
DECLARE FUNCTION ChangeSelector LIB "KERNEL" (BYVAL wDestSelector AS WORD, BYVAL wSourceSelector AS WORD) AS WORD
DECLARE FUNCTION FreeSelector LIB "KERNEL" (BYVAL wSelector AS WORD) AS WORD
DECLARE FUNCTION SetSelectorBase LIB "KERNEL" (BYVAL wSelector AS WORD, BYVAL zBase AS DWORD) AS WORD
DECLARE FUNCTION SetSelectorLimit LIB "KERNEL" (BYVAL wSelector AS WORD, BYVAL zLimit AS DWORD) AS WORD

DECLARE FUNCTION FindResource LIB "KERNEL" (BYVAL hInstance AS WORD, lpString AS ASCIIZ, lpType AS ANY) AS WORD
DECLARE FUNCTION LoadResource LIB "KERNEL" (BYVAL hInstance AS WORD, BYVAL hResInfo AS WORD) AS WORD
DECLARE FUNCTION FreeResource LIB "KERNEL" (BYVAL hResData AS WORD) AS WORD
DECLARE FUNCTION LockResource LIB "KERNEL" (BYVAL hResData AS WORD) AS DWORD
DECLARE FUNCTION AllocResource LIB "KERNEL" (BYVAL hInstance AS WORD, BYVAL hResInfo AS WORD, BYVAL dwSize AS DWORD) AS WORD
DECLARE FUNCTION SizeofResource LIB "KERNEL" (BYVAL hInstance AS WORD, BYVAL hResInfo AS WORD) AS WORD
DECLARE FUNCTION AccessResource LIB "KERNEL" (BYVAL hInstance AS WORD, BYVAL hResInfo AS WORD) AS WORD

DECLARE SUB Yield LIB "KERNEL" ()
DECLARE FUNCTION GetCurrentTask LIB "KERNEL" () AS WORD

DECLARE FUNCTION InitAtomTable LIB "KERNEL" (BYVAL nSize AS WORD) AS WORD
DECLARE FUNCTION AddAtom LIB "KERNEL" (lpString AS ASCIIZ) AS WORD
DECLARE FUNCTION DeleteAtom LIB "KERNEL" (BYVAL nAtom AS WORD) AS WORD
DECLARE FUNCTION FindAtom LIB "KERNEL" (lpString AS ASCIIZ) AS WORD
DECLARE FUNCTION GetAtomName LIB "KERNEL" (BYVAL nAtom AS WORD, lpBuffer AS ASCIIZ, BYVAL nSize AS WORD) AS WORD
DECLARE FUNCTION GetAtomHandle LIB "KERNEL" (BYVAL wAtom AS WORD) AS WORD

DECLARE FUNCTION GlobalAddAtom LIB "USER" (lpstring AS ASCIIZ) AS WORD
DECLARE FUNCTION GlobalDeleteAtom LIB "USER" (BYVAL nAtom AS WORD) AS WORD
DECLARE FUNCTION GlobalFindAtom LIB "USER" (lpString AS ASCIIZ) AS WORD
DECLARE FUNCTION GlobalGetAtomName LIB "USER" (BYVAL nAtom AS WORD, lpbuffer AS ASCIIZ, BYVAL nSize AS WORD) AS WORD

' User Profile Routines
' NOTE: The lpKeyName argument for GetProfileString, WriteProfileString,
'       GetPrivateProfileString, and WritePrivateProfileString can be either
'       a string or NULL.  To pass null specify "BYVAL %NULL" or "BYVAL 0???"
DECLARE FUNCTION GetProfileInt LIB "KERNEL" (lpAppName AS ASCIIZ, lpKeyName AS ASCIIZ, BYVAL nDefault AS WORD) AS WORD
DECLARE FUNCTION GetProfileString LIB "KERNEL" (lpAppName AS ASCIIZ, lpKeyName AS ASCIIZ, lpDefault AS ASCIIZ, lpReturnedString AS ASCIIZ, BYVAL nSize AS WORD) AS WORD
DECLARE FUNCTION WriteProfileString LIB "KERNEL" (lpApplicationName AS ASCIIZ, lpKeyName AS ASCIIZ, lpString AS ASCIIZ) AS WORD
DECLARE FUNCTION GetPrivateProfileInt LIB "KERNEL" (lpApplicationName AS ASCIIZ, lpKeyName AS ASCIIZ, BYVAL nDefault AS WORD, lpFileName AS ASCIIZ) AS WORD
DECLARE FUNCTION GetPrivateProfileString LIB "KERNEL" (lpApplicationName AS ASCIIZ, lpKeyName AS ASCIIZ, lpDefault AS ASCIIZ, lpReturnedString AS ASCIIZ, BYVAL nSize AS WORD, lpFileName AS ASCIIZ) AS WORD
DECLARE FUNCTION WritePrivateProfileString LIB "KERNEL" (lpApplicationName AS ASCIIZ, lpKeyName AS ASCIIZ, lpString AS ASCIIZ, lplFileName AS ASCIIZ) AS WORD
DECLARE FUNCTION GetWindowsDirectory LIB "KERNEL" (lpBuffer AS ASCIIZ, BYVAL nSize AS WORD) AS WORD
DECLARE FUNCTION GetSystemDirectory LIB "KERNEL" (lpBuffer AS ASCIIZ, BYVAL nSize AS WORD) AS WORD

DECLARE FUNCTION Catch LIB "KERNEL" (lpCatchBuf AS ANY) AS WORD
DECLARE SUB Throw LIB "KERNEL" (lpCatchBuf AS ANY, BYVAL nThrowBack AS WORD)

DECLARE SUB FatalExit LIB "KERNEL" (BYVAL Code AS WORD)
DECLARE SUB SwapRecording LIB "KERNEL" (BYVAL wFlag AS WORD)

' Character Translation Routines
DECLARE FUNCTION AnsiToOem LIB "KEYBOARD" (lpAnsiStr AS ASCIIZ, lpOemStr AS ASCIIZ) AS WORD
DECLARE FUNCTION OemToAnsi LIB "KEYBOARD" (lpOemStr AS ASCIIZ, lpAnsiStr AS ASCIIZ) AS WORD
DECLARE SUB AnsiToOemBuff LIB "KEYBOARD" (lpAnsiStr AS ASCIIZ, lpOemStr AS ASCIIZ, BYVAL nLength AS WORD)
DECLARE SUB OemToAnsiBuff LIB "KEYBOARD" (lpOemStr AS ASCIIZ, lpAnsiStr AS ASCIIZ, BYVAL nLength AS WORD)
DECLARE FUNCTION AnsiUpper LIB "USER" (lpString AS ASCIIZ) AS DWORD
DECLARE FUNCTION AnsiUpperBuff LIB "USER" (lpString AS ASCIIZ, BYVAL aWord AS WORD) AS WORD
DECLARE FUNCTION AnsiLower LIB "USER" (lpString AS ASCIIZ) AS DWORD
DECLARE FUNCTION AnsiLowerBuff LIB "USER" (lpString AS ASCIIZ, BYVAL aWord AS WORD) AS WORD
DECLARE FUNCTION AnsiNext LIB "USER" (lpString AS ASCIIZ) AS DWORD
DECLARE FUNCTION AnsiPrev LIB "USER" (lpString AS ASCIIZ, lpString AS ASCIIZ) AS DWORD

' Keyboard Information Routines
DECLARE FUNCTION OemKeyScan LIB "KEYBOARD" (BYVAL wOemChar AS WORD) AS DWORD
DECLARE FUNCTION VkKeyScan LIB "KEYBOARD" (BYVAL cChar AS WORD) AS WORD
DECLARE FUNCTION GetKeyboardType LIB "KEYBOARD" (BYVAL nTypeFlag AS WORD) AS WORD
DECLARE FUNCTION MapVirtualKey LIB "KEYBOARD" (BYVAL wCode AS WORD, BYVAL wMapType AS WORD) AS WORD
DECLARE FUNCTION GetKBCodePage LIB "KEYBOARD" () AS WORD
DECLARE FUNCTION GetKeyNameText LIB "KEYBOARD" (BYVAL lParam AS DWORD, lpBuffer AS ASCIIZ, BYVAL nSize AS WORD) AS WORD
DECLARE FUNCTION ToAscii LIB "KEYBOARD" (BYVAL wVirtKey AS WORD, BYVAL wScanCode AS WORD, lpKeyState AS ANY, lpChar AS ANY, Byval wFlags AS WORD) AS WORD

' Language dependent Routines
DECLARE FUNCTION IsCharAlpha LIB "USER" (BYVAL cChar AS WORD) AS WORD
DECLARE FUNCTION IsCharAlphaNumeric LIB "USER" (BYVAL cChar AS WORD) AS WORD
DECLARE FUNCTION IsCharUpper LIB "USER" (BYVAL cChar AS WORD) AS WORD
DECLARE FUNCTION IsCharLower LIB "USER" (BYVAL cChar AS WORD) AS WORD

DECLARE FUNCTION GetWinFlags LIB "KERNEL" () AS DWORD

DECLARE FUNCTION DrawText LIB "USER" (BYVAL hDC AS WORD, lpStr AS ASCIIZ, BYVAL nCount AS WORD, lpRect AS RECT, BYVAL wFormat AS WORD) AS WORD
DECLARE FUNCTION DrawIcon LIB "USER" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD, BYVAL hIcon AS WORD) AS WORD

DECLARE FUNCTION GetWindowDC LIB "USER" (BYVAL hWnd AS WORD) AS WORD
DECLARE FUNCTION GetDC LIB "USER" (BYVAL hWnd AS WORD) AS WORD
DECLARE FUNCTION ReleaseDC LIB "USER" (BYVAL hWnd AS WORD, BYVAL hDC AS WORD) AS WORD
DECLARE FUNCTION CreateDC LIB "GDI" (lpDriverName AS ASCIIZ, lpDeviceName AS ASCIIZ, lpOutput AS ASCIIZ, lpInitData AS ASCIIZ) AS WORD
DECLARE FUNCTION CreateIC LIB "GDI" (lpDriverName AS ASCIIZ, lpDeviceName AS ASCIIZ, lpOutput AS ASCIIZ, lpInitData AS ASCIIZ) AS WORD
DECLARE FUNCTION CreateCompatibleDC LIB "GDI" (BYVAL hDC AS WORD) AS WORD
DECLARE FUNCTION DeleteDC LIB "GDI" (BYVAL hDC AS WORD) AS WORD
DECLARE FUNCTION SaveDC LIB "GDI" (BYVAL hDC AS WORD) AS WORD
DECLARE FUNCTION RestoreDC LIB "GDI" (BYVAL hDC AS WORD, BYVAL nSavedDC AS WORD) AS WORD
DECLARE FUNCTION MoveTo LIB "GDI" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD) AS DWORD
DECLARE FUNCTION GetCurrentPosition LIB "GDI" (BYVAL hDC AS WORD) AS DWORD
DECLARE FUNCTION LineTo LIB "GDI" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD) AS WORD
DECLARE FUNCTION GetDCOrg LIB "GDI" (BYVAL hDC AS WORD) AS DWORD

DECLARE FUNCTION MulDiv LIB "GDI" (BYVAL nNumber AS WORD, BYVAL nNumerator AS WORD, BYVAL nDenominator AS WORD) AS WORD

DECLARE FUNCTION ExtTextOut LIB "GDI" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD, BYVAL wOptions AS WORD, lpRect AS ANY, lpString AS ASCIIZ, BYVAL nCount AS WORD, lpDx AS ANY) AS WORD

DECLARE FUNCTION Polyline LIB "GDI" (BYVAL hDC AS WORD, lpPoints AS POINTAPI, BYVAL nCount AS WORD) AS WORD
DECLARE FUNCTION Polygon LIB "GDI" (BYVAL hDC AS WORD, lpPoints AS POINTAPI, BYVAL nCount AS WORD) AS WORD
DECLARE FUNCTION PolyPolygon LIB "GDI" (BYVAL hDC AS WORD, lpPoints AS POINTAPI, lpPolyCounts AS WORD, BYVAL nCount AS WORD) AS WORD

DECLARE FUNCTION Rectangle LIB "GDI" (BYVAL hDC AS WORD, BYVAL X1 AS WORD, BYVAL Y1 AS WORD, BYVAL X2 AS WORD, BYVAL Y2 AS WORD) AS WORD
DECLARE FUNCTION RoundRect LIB "GDI" (BYVAL hDC AS WORD, BYVAL X1 AS WORD, BYVAL Y1 AS WORD, BYVAL X2 AS WORD, BYVAL Y2 AS WORD, BYVAL X3 AS WORD, BYVAL Y3 AS WORD) AS WORD
DECLARE FUNCTION Ellipse LIB "GDI" (BYVAL hDC AS WORD, BYVAL X1 AS WORD, BYVAL Y1 AS WORD, BYVAL X2 AS WORD, BYVAL Y2 AS WORD) AS WORD
DECLARE FUNCTION Arc LIB "GDI" (BYVAL hDC AS WORD, BYVAL X1 AS WORD, BYVAL Y1 AS WORD, BYVAL X2 AS WORD, BYVAL Y2 AS WORD, BYVAL X3 AS WORD, BYVAL Y3 AS WORD, BYVAL X4 AS WORD, BYVAL Y4 AS WORD) AS WORD
DECLARE FUNCTION Chord LIB "GDI" (BYVAL hDC AS WORD, BYVAL X1 AS WORD, BYVAL Y1 AS WORD, BYVAL X2 AS WORD, BYVAL Y2 AS WORD, BYVAL X3 AS WORD, BYVAL Y3 AS WORD, BYVAL X4 AS WORD, BYVAL Y4 AS WORD) AS WORD
DECLARE FUNCTION Pie LIB "GDI" (BYVAL hDC AS WORD, BYVAL X1 AS WORD, BYVAL Y1 AS WORD, BYVAL X2 AS WORD, BYVAL Y2 AS WORD, BYVAL X3 AS WORD, BYVAL Y3 AS WORD, BYVAL X4 AS WORD, BYVAL Y4 AS WORD) AS WORD
DECLARE FUNCTION PatBlt LIB "GDI" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD, BYVAL nWidth AS WORD, BYVAL nHeight AS WORD, BYVAL dwRop AS DWORD) AS WORD
DECLARE FUNCTION BitBlt LIB "GDI" (BYVAL hDestDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD, BYVAL nWidth AS WORD, BYVAL nHeight AS WORD, BYVAL hSrcDC AS WORD, BYVAL XSrc AS WORD, BYVAL YSrc AS WORD, BYVAL dwRop AS DWORD) AS WORD
DECLARE FUNCTION StretchBlt LIB "GDI" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD, BYVAL nWidth AS WORD, BYVAL nHeight AS WORD, BYVAL hSrcDC AS WORD, BYVAL XSrc AS WORD, BYVAL YSrc AS WORD, BYVAL nSrcWidth AS WORD, _
                                       BYVAL nSrcHeight AS WORD, BYVAL dwRop AS DWORD) AS WORD
DECLARE FUNCTION TextOut LIB "GDI" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD, lpString AS ASCIIZ, BYVAL nCount AS WORD) AS WORD
DECLARE FUNCTION TabbedTextOut LIB "USER" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD, lpString AS ASCIIZ, BYVAL nCount AS WORD, BYVAL nTabPositions AS WORD, lpnTabStopPositions AS WORD,BYVAL nTabOrigin AS WORD) AS DWORD
DECLARE FUNCTION GetCharWidth LIB "GDI" (BYVAL hDC AS WORD, BYVAL wFirstChar AS WORD, BYVAL wLastChar AS WORD, lpBuffer AS WORD) AS WORD
DECLARE FUNCTION SetPixel LIB "GDI" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD, BYVAL crColor AS DWORD) AS DWORD
DECLARE FUNCTION GetPixel LIB "GDI" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD) AS DWORD
DECLARE FUNCTION FloodFill LIB "GDI" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD, BYVAL crColor AS DWORD) AS WORD
DECLARE FUNCTION ExtFloodFill LIB "GDI" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD, BYVAL crColor AS DWORD, BYVAL wFillType AS WORD) AS WORD

DECLARE FUNCTION GetStockObject LIB "GDI" (BYVAL nIndex AS WORD) AS WORD

DECLARE FUNCTION CreatePen LIB "GDI" (BYVAL nPenStyle AS WORD, BYVAL nWidth AS WORD, BYVAL crColor AS DWORD) AS WORD
DECLARE FUNCTION CreatePenIndirect LIB "GDI" (lpLogPen AS LOGPEN) AS WORD

DECLARE FUNCTION CreateSolidBrush LIB "GDI" (BYVAL crColor AS DWORD) AS WORD
DECLARE FUNCTION CreateHatchBrush LIB "GDI" (BYVAL nIndex AS WORD, BYVAL crColor AS DWORD) AS WORD
DECLARE FUNCTION SetBrushOrg LIB "GDI" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD) AS DWORD
DECLARE FUNCTION GetBrushOrg LIB "GDI" (BYVAL hDC AS WORD) AS DWORD
DECLARE FUNCTION CreatePatternBrush LIB "GDI" (BYVAL hBitmap AS WORD) AS WORD
DECLARE FUNCTION CreateBrushIndirect LIB "GDI" (lpLogBrush AS LOGBRUSH) AS WORD

DECLARE FUNCTION CreateBitmap LIB "GDI" (BYVAL nWidth AS WORD, BYVAL nHeight AS WORD, BYVAL nPlanes AS WORD, BYVAL nBitCount AS WORD, lpBits AS ANY) AS WORD
DECLARE FUNCTION CreateBitmapIndirect LIB "GDI" (lpBitmap AS BITMAP) AS WORD
DECLARE FUNCTION CreateCompatibleBitmap LIB "GDI" (BYVAL hDC AS WORD, BYVAL nWidth AS WORD, BYVAL nHeight AS WORD) AS WORD
DECLARE FUNCTION CreateDiscardableBitmap LIB "GDI" (BYVAL hDC AS WORD, BYVAL nWidth AS WORD, BYVAL nHeight AS WORD) AS WORD

DECLARE FUNCTION SetBitmapBits LIB "GDI" (BYVAL hBitmap AS WORD, BYVAL dwCount AS DWORD, lpBits AS ANY) AS DWORD
DECLARE FUNCTION GetBitmapBits LIB "GDI" (BYVAL hBitmap AS WORD, BYVAL dwCount AS DWORD, lpBits AS ANY) AS DWORD
DECLARE FUNCTION SetBitmapDimension LIB "GDI" (BYVAL hBitmap AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD) AS DWORD
DECLARE FUNCTION GetBitmapDimension LIB "GDI" (BYVAL hBitmap AS WORD) AS DWORD

DECLARE FUNCTION CreateFont LIB "GDI" (BYVAL nHeight AS WORD, BYVAL nWidth AS WORD, BYVAL e AS WORD, BYVAL o AS WORD, BYVAL w AS WORD, BYVAL i AS WORD, BYVAL u AS WORD, BYVAL s AS WORD, BYVAL c AS WORD, BYVAL op AS WORD, BYVAL cp AS WORD, _
                                       BYVAL q AS WORD, BYVAL paf AS WORD, f AS ASCIIZ) AS WORD
DECLARE FUNCTION CreateFontIndirect LIB "GDI" (lpLogFont AS LOGFONT) AS WORD

DECLARE FUNCTION SelectClipRgn LIB "GDI" (BYVAL hDC AS WORD, BYVAL hRgn AS WORD) AS WORD
DECLARE FUNCTION CreateRectRgn LIB "GDI" (BYVAL X1 AS WORD, BYVAL Y1 AS WORD, BYVAL X2 AS WORD, BYVAL Y2 AS WORD) AS WORD
DECLARE SUB SetRectRgn LIB "GDI" (BYVAL hRgn AS WORD, BYVAL X1 AS WORD, BYVAL Y1 AS WORD, BYVAL X2 AS WORD, BYVAL Y2 AS WORD)
DECLARE FUNCTION CreateRectRgnIndirect LIB "GDI" (lpRect AS RECT) AS WORD
DECLARE FUNCTION CreateEllipticRgnIndirect LIB "GDI" (lpRect AS RECT) AS WORD
DECLARE FUNCTION CreateEllipticRgn LIB "GDI" (BYVAL X1 AS WORD, BYVAL Y1 AS WORD, BYVAL X2 AS WORD, BYVAL Y2 AS WORD) AS WORD
DECLARE FUNCTION CreatePolygonRgn LIB "GDI" (lpPoints AS POINTAPI, BYVAL nCount AS WORD, BYVAL nPolyFillMode AS WORD) AS WORD
DECLARE FUNCTION CreatePolyPolygonRgn LIB "GDI" (lpPoints AS POINTAPI, lpPolyCounts AS WORD, BYVAL nCount AS WORD, BYVAL nPolyFillMode AS WORD) AS WORD
DECLARE FUNCTION CreateRoundRectRgn LIB "GDI" (BYVAL X1 AS WORD, BYVAL Y1 AS WORD, BYVAL X2 AS WORD, BYVAL Y2 AS WORD, BYVAL X3 AS WORD, BYVAL Y3 AS WORD) AS WORD

'DECLARE FUNCTION GetObject LIB "GDI" (BYVAL hObject AS WORD, BYVAL nCount AS WORD, BYVAL lpObject AS DWORD) AS WORD
DECLARE FUNCTION GetObjectGDI LIB "GDI" ALIAS "GetObject" (BYVAL hObject AS WORD, BYVAL nCount AS WORD, BYVAL lpObject AS DWORD) AS WORD

DECLARE FUNCTION DeleteObject LIB "GDI" (BYVAL hObject AS WORD) AS WORD
DECLARE FUNCTION SelectObject LIB "GDI" (BYVAL hDC AS WORD, BYVAL hObject AS WORD) AS WORD
DECLARE FUNCTION UnrealizeObject LIB "GDI" (BYVAL hObject AS WORD) AS WORD

DECLARE FUNCTION SetBkColor LIB "GDI" (BYVAL hDC AS WORD, BYVAL crColor AS DWORD) AS DWORD
DECLARE FUNCTION GetBkColor LIB "GDI" (BYVAL hDC AS WORD) AS DWORD
DECLARE FUNCTION SetBkMode LIB "GDI" (BYVAL hDC AS WORD, BYVAL nBkMode AS WORD) AS WORD
DECLARE FUNCTION GetBkMode LIB "GDI" (BYVAL hDC AS WORD) AS WORD
DECLARE FUNCTION SetTextColor LIB "GDI" (BYVAL hDC AS WORD, BYVAL crColor AS DWORD) AS DWORD
DECLARE FUNCTION GetTextColor LIB "GDI" (BYVAL hDC AS WORD) AS DWORD
DECLARE FUNCTION SetTextAlign LIB "GDI" (BYVAL hDC AS WORD, BYVAL wFlags AS WORD) AS WORD
DECLARE FUNCTION GetTextAlign LIB "GDI" (BYVAL hDC AS WORD) AS WORD
DECLARE FUNCTION SetMapperFlags LIB "GDI" (BYVAL hDC AS WORD, BYVAL dwFlag AS DWORD) AS DWORD
DECLARE FUNCTION GetAspectRatioFilter LIB "GDI" (BYVAL hDC AS WORD) AS DWORD
DECLARE FUNCTION GetNearestColor LIB "GDI" (BYVAL hDC AS WORD, BYVAL crColor AS DWORD) AS DWORD
DECLARE FUNCTION SetROP2 LIB "GDI" (BYVAL hDC AS WORD, BYVAL nDrawMode AS WORD) AS WORD
DECLARE FUNCTION GetROP2 LIB "GDI" (BYVAL hDC AS WORD) AS WORD
DECLARE FUNCTION SetStretchBltMode LIB "GDI" (BYVAL hDC AS WORD, BYVAL nStretchMode AS WORD) AS WORD
DECLARE FUNCTION GetStretchBltMode LIB "GDI" (BYVAL hDC AS WORD) AS WORD
DECLARE FUNCTION SetPolyFillMode LIB "GDI" (BYVAL hDC AS WORD, BYVAL nPolyFillMode AS WORD) AS WORD
DECLARE FUNCTION GetPolyFillMode LIB "GDI" (BYVAL hDC AS WORD) AS WORD
DECLARE FUNCTION SetMapMode LIB "GDI" (BYVAL hDC AS WORD, BYVAL nMapMode AS WORD) AS WORD
DECLARE FUNCTION GetMapMode LIB "GDI" (BYVAL hDC AS WORD) AS WORD
DECLARE FUNCTION SetWindowOrg LIB "GDI" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD) AS DWORD
DECLARE FUNCTION GetWindowOrg LIB "GDI" (BYVAL hDC AS WORD) AS DWORD
DECLARE FUNCTION SetWindowExt LIB "GDI" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD) AS DWORD
DECLARE FUNCTION GetWindowExt LIB "GDI" (BYVAL hDC AS WORD) AS DWORD
DECLARE FUNCTION SetViewportOrg LIB "GDI" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD) AS DWORD
DECLARE FUNCTION GetViewportOrg LIB "GDI" (BYVAL hDC AS WORD) AS DWORD
DECLARE FUNCTION SetViewportExt LIB "GDI" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD) AS DWORD
DECLARE FUNCTION GetViewportExt LIB "GDI" (BYVAL hDC AS WORD) AS DWORD
DECLARE FUNCTION OffsetViewportOrg LIB "GDI" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD) AS DWORD
DECLARE FUNCTION ScaleViewportExt LIB "GDI" (BYVAL hDC AS WORD, BYVAL Xnum AS WORD, BYVAL Xdenom AS WORD, BYVAL Ynum AS WORD, BYVAL Ydenom AS WORD) AS DWORD
DECLARE FUNCTION OffsetWindowOrg LIB "GDI" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD) AS DWORD
DECLARE FUNCTION ScaleWindowExt LIB "GDI" (BYVAL hDC AS WORD, BYVAL Xnum AS WORD, BYVAL Xdenom AS WORD, BYVAL Ynum AS WORD, BYVAL Ydenom AS WORD) AS DWORD

DECLARE FUNCTION GetClipBox LIB "GDI" (BYVAL hDC AS WORD, lpRect AS RECT) AS WORD
DECLARE FUNCTION IntersectClipRect LIB "GDI" (BYVAL hDC AS WORD, BYVAL X1 AS WORD, BYVAL Y1 AS WORD, BYVAL X2 AS WORD, BYVAL Y2 AS WORD) AS WORD
DECLARE FUNCTION OffsetClipRgn LIB "GDI" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD) AS WORD
DECLARE FUNCTION ExcludeClipRect LIB "GDI" (BYVAL hDC AS WORD, BYVAL X1 AS WORD, BYVAL Y1 AS WORD, BYVAL X2 AS WORD, BYVAL Y2 AS WORD) AS WORD
DECLARE FUNCTION PtVisible LIB "GDI" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD) AS WORD
DECLARE FUNCTION CombineRgn LIB "GDI" (BYVAL hDestRgn AS WORD, BYVAL hSrcRgn1 AS WORD, BYVAL hSrcRgn2 AS WORD, BYVAL nCombineMode AS WORD) AS WORD
DECLARE FUNCTION EqualRgn LIB "GDI" (BYVAL hSrcRgn1 AS WORD, BYVAL hSrcRgn2 AS WORD) AS WORD
DECLARE FUNCTION OffsetRgn LIB "GDI" (BYVAL hRgn AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD) AS WORD
DECLARE FUNCTION GetRgnBox LIB "GDI" (BYVAL hRgn AS WORD, lpRect AS RECT) AS WORD

DECLARE FUNCTION SetTextJustification LIB "GDI" (BYVAL hDC AS WORD, BYVAL nBreakExtra AS WORD, BYVAL nBreakCount AS WORD) AS WORD
DECLARE FUNCTION GetTextExtent LIB "GDI" (BYVAL hDC AS WORD, lpString AS ASCIIZ, BYVAL nCount AS WORD) AS DWORD
DECLARE FUNCTION GetTabbedTextExtent LIB "GDI" (BYVAL hDC AS WORD, lpString AS ASCIIZ, BYVAL nCount AS WORD, BYVAL nTabPositions AS WORD, lpnTabStopPositions AS WORD) AS DWORD
DECLARE FUNCTION SetTextCharacterExtra LIB "GDI" (BYVAL hDC AS WORD, BYVAL nCharExtra AS WORD) AS WORD
DECLARE FUNCTION GetTextCharacterExtra LIB "GDI" (BYVAL hDC AS WORD) AS WORD

DECLARE FUNCTION GetMetaFile LIB "GDI" (lpFilename AS ASCIIZ) AS WORD
DECLARE FUNCTION DeleteMetaFile LIB "GDI" (BYVAL hMF AS WORD) AS WORD
DECLARE FUNCTION CopyMetaFile LIB "GDI" (BYVAL hMF AS WORD, lpFilename AS ASCIIZ) AS WORD

DECLARE FUNCTION PlayMetaFile LIB "GDI" (BYVAL hDC AS WORD, BYVAL hMF AS WORD) AS WORD
DECLARE SUB PlayMetaFileRecord LIB "GDI" (BYVAL hDC AS WORD, lpHandletable AS WORD, lpMetaRecord AS METARECORD, BYVAL nHandles AS WORD)

DECLARE FUNCTION Escape LIB "GDI" (BYVAL hDC AS WORD, BYVAL nEscape AS WORD, BYVAL nCount AS WORD, lplnData AS ANY, lpOutData AS ANY) AS WORD
DECLARE FUNCTION GetTextFace LIB "GDI" (BYVAL hDC AS WORD, BYVAL nCount AS WORD, lpFacename AS ASCIIZ) AS WORD

DECLARE FUNCTION GetTextMetrics LIB "GDI" (BYVAL hDC AS WORD, lpMetrics AS TEXTMETRIC) AS WORD

DECLARE FUNCTION GetDeviceCaps LIB "GDI" (BYVAL hDC AS WORD, BYVAL nIndex AS WORD) AS WORD

DECLARE FUNCTION SetEnvironment LIB "GDI" (lpPortName AS ASCIIZ, lpEnviron AS ASCIIZ, BYVAL nCount AS WORD) AS WORD
DECLARE FUNCTION GetEnvironment LIB "GDI" (lpPortName AS ASCIIZ, lpEnviron AS ASCIIZ, BYVAL nMaxCount AS WORD) AS WORD

DECLARE FUNCTION DPtoLP LIB "GDI" (BYVAL hDC AS WORD, lpPoints AS POINTAPI, BYVAL nCount AS WORD) AS WORD
DECLARE FUNCTION LPtoDP LIB "GDI" (BYVAL hDC AS WORD, lpPoints AS POINTAPI, BYVAL nCount AS WORD) AS WORD

DECLARE FUNCTION CreateMetaFile LIB "GDI" (lpString AS ASCIIZ) AS WORD
DECLARE FUNCTION CloseMetaFile LIB "GDI" (BYVAL hMF AS WORD) AS WORD
DECLARE FUNCTION GetMetaFileBits LIB "GDI" (BYVAL hMF AS WORD) AS WORD
DECLARE FUNCTION SetMetaFileBits LIB "GDI" (BYVAL hMem AS WORD) AS WORD

DECLARE FUNCTION SetDIBits LIB "GDI" (BYVAL aHDC AS WORD, BYVAL hBitmap AS WORD, BYVAL nStartScan AS WORD, BYVAL nNumScans AS WORD, lpBits AS ANY, lpBI AS BITMAPINFO, BYVAL wUsage AS WORD) AS WORD
DECLARE FUNCTION GetDIBits LIB "GDI" (BYVAL aHDC AS WORD, BYVAL hBitmap AS WORD, BYVAL nStartScan AS WORD, BYVAL nNumScans AS WORD, lpBits AS ANY, lpBI AS BITMAPINFO, BYVAL wUsage AS WORD) AS WORD
DECLARE FUNCTION SetDIBitsToDevice LIB "GDI" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD, BYVAL dX AS WORD, BYVAL dY AS WORD, BYVAL SrcX AS WORD, BYVAL SrcY AS WORD, BYVAL nScan AS WORD, BYVAL NumScans AS WORD, _
                 Bits AS ANY, BitsInfo AS BITMAPINFO, BYVAL wUsage AS WORD) AS WORD
DECLARE FUNCTION CreateDIBitmap LIB "GDI" (BYVAL hDC AS WORD, lpInfoHeader AS BITMAPINFOHEADER, BYVAL dwUsage AS DWORD, lpInitBits AS ANY, lpInitInfo AS BITMAPINFO, BYVAL wUsage AS WORD) AS WORD
DECLARE FUNCTION CreateDIBPatternBrush LIB "GDI" (BYVAL hPackedDIB AS WORD, BYVAL wUsage AS WORD) AS WORD
DECLARE FUNCTION StretchDIBits LIB "GDI" (BYVAL hDC AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD, BYVAL dX AS WORD, BYVAL dY AS WORD, BYVAL SrcX AS WORD, BYVAL SrcY AS WORD, BYVAL wSrcWidth AS WORD, BYVAL wSrcHeight AS WORD, _
                 lpBits AS ANY, lpBitsInfo AS BITMAPINFO, BYVAL wUsage AS WORD, BYVAL dwRop AS WORD) AS WORD

DECLARE FUNCTION CreatePalette LIB "GDI" (lpLogPalette AS LOGPALETTE) AS WORD
DECLARE FUNCTION SelectPalette LIB "USER" (BYVAL hDC AS WORD, BYVAL hPalette AS WORD, BYVAL bForceBackground AS WORD) AS WORD
DECLARE FUNCTION RealizePalette LIB "USER" (BYVAL hDC AS WORD) AS WORD
DECLARE FUNCTION UpdateColors LIB "GDI" (BYVAL hDC AS WORD) AS WORD
DECLARE SUB AnimatePalette LIB "GDI" (BYVAL hPalette AS WORD, BYVAL wStartIndex AS WORD, BYVAL wNumEntries AS WORD, lpPaletteColors AS PALETTEENTRY)
DECLARE FUNCTION SetPaletteEntries LIB "GDI" (BYVAL hPalette AS WORD, BYVAL wStartIndex AS WORD, BYVAL wNumEntries AS WORD, lpPaletteEntries AS PALETTEENTRY) AS WORD
DECLARE FUNCTION GetPaletteEntries LIB "GDI" (BYVAL hPalette AS WORD, BYVAL wStartIndex AS WORD, BYVAL wNumEntries AS WORD, lpPaletteEntries AS PALETTEENTRY) AS WORD
DECLARE FUNCTION GetNearestPaletteIndex LIB "GDI" (BYVAL hPalette AS WORD, BYVAL crColor AS DWORD) AS WORD
DECLARE FUNCTION ResizePalette LIB "GDI" (BYVAL hPalette AS WORD, BYVAL nNumEntries AS WORD) AS WORD

DECLARE FUNCTION GetSystemPaletteEntries LIB "GDI" (BYVAL hDC AS WORD, BYVAL wStartIndex AS WORD, BYVAL wNumEntries AS WORD, lpPaletteEntries AS PALETTEENTRY) AS WORD
DECLARE FUNCTION GetSystemPaletteUse LIB "GDI" (BYVAL hDC AS WORD) AS WORD
DECLARE FUNCTION SetSystemPaletteUse LIB "GDI" (BYVAL hDC AS WORD, BYVAL wUsage AS WORD) AS WORD

DECLARE FUNCTION RegisterWindowMessage LIB "USER" (lpString AS ASCIIZ) AS WORD

' Message FUNCTION Templates
DECLARE FUNCTION GetMessage LIB "USER" (lpMsg AS MsgStruc, BYVAL hWnd AS WORD, BYVAL wMsgFilterMin AS WORD, BYVAL wMsgFilterMax AS WORD) AS WORD
DECLARE FUNCTION TranslateMessage LIB "USER" (lpMsg AS MsgStruc) AS WORD
DECLARE FUNCTION DispatchMessage LIB "USER" (lpMsg AS MsgStruc) AS DWORD
DECLARE FUNCTION PeekMessage LIB "USER" (lpMsg AS MsgStruc, BYVAL hWnd AS WORD, BYVAL wMsgFilterMin AS WORD, BYVAL wMsgFilterMax AS WORD, BYVAL wRemoveMsg AS WORD) AS WORD

DECLARE FUNCTION lstrcmp LIB "USER" (lpString1 AS ASCIIZ, lpString2 AS ASCIIZ) AS WORD
DECLARE FUNCTION lstrcmpi LIB "USER" (lpString1 AS ASCIIZ, lpString2 AS ASCIIZ) AS WORD
DECLARE FUNCTION lstrcpy LIB "KERNEL" (lpString1 AS ASCIIZ, lpString2 AS ASCIIZ) AS DWORD
DECLARE FUNCTION lstrcat LIB "KERNEL" (lpString1 AS ASCIIZ, lpString2 AS ASCIIZ) AS DWORD
DECLARE FUNCTION lstrlen LIB "KERNEL" (lpString AS ASCIIZ) AS WORD

DECLARE FUNCTION lopen LIB "KERNEL" ALIAS "_lopen" (lpPathName AS ASCIIZ, BYVAL iReadWrite AS WORD) AS WORD
DECLARE FUNCTION lclose LIB "KERNEL" ALIAS "_lclose" (BYVAL hFile AS WORD) AS WORD
DECLARE FUNCTION lcreat LIB "KERNEL" ALIAS "_lcreat" (lpPathName AS ASCIIZ, BYVAL iAttribute AS WORD) AS WORD
DECLARE FUNCTION llseek LIB "KERNEL" ALIAS "_llseek" (BYVAL hFile AS WORD, BYVAL lOffset AS DWORD, BYVAL iOrigin AS WORD) AS DWORD
DECLARE FUNCTION lread LIB "KERNEL" ALIAS "_lread" (BYVAL hFile AS WORD, lpBuffer AS ASCIIZ, BYVAL wBytes AS WORD) AS WORD
DECLARE FUNCTION lwrite LIB "KERNEL" ALIAS "_lwrite" (BYVAL hFile AS WORD, lpBuffer AS ASCIIZ, BYVAL wBytes AS WORD) AS WORD

DECLARE FUNCTION ExitWindows LIB "USER" (BYVAL dwReturnCode AS DWORD, BYVAL wReserved AS WORD) AS WORD

DECLARE FUNCTION SwapMouseButton LIB "USER" (BYVAL bSwap AS WORD) AS WORD
DECLARE FUNCTION GetMessagePos LIB "USER" () AS DWORD
DECLARE FUNCTION GetMessageTime LIB "USER" () AS DWORD

DECLARE FUNCTION GetSysModalWindow LIB "USER" () AS WORD
DECLARE FUNCTION SetSysModalWindow LIB "USER" (BYVAL hWnd AS WORD) AS WORD

DECLARE FUNCTION DefWindowProc LIB "USER" (BYVAL hWnd AS WORD, BYVAL wMsg AS WORD, BYVAL wParam AS WORD, BYVAL lParam AS DWORD) AS DWORD
DECLARE FUNCTION InSendMessage LIB "USER" () AS WORD
DECLARE FUNCTION PostAppMessage LIB "USER" (BYVAL hTask AS WORD, BYVAL wMsg AS WORD, BYVAL wParam AS WORD, BYVAL lParam AS DWORD) AS WORD
DECLARE FUNCTION PostMessage LIB "USER" (BYVAL hWnd AS WORD, BYVAL wMsg AS WORD, BYVAL wParam AS WORD, BYVAL lParam AS DWORD) AS WORD
DECLARE FUNCTION SendMessage LIB "USER" (BYVAL hWnd AS WORD, BYVAL wMsg AS WORD, BYVAL wParam AS WORD, BYVAL lParam AS DWORD) AS DWORD
DECLARE SUB PostQuitMessage LIB "USER" (BYVAL nExitCode AS WORD)
DECLARE SUB ReplyMessage LIB "USER" (BYVAL lReply AS DWORD)
DECLARE SUB WaitMessage LIB "USER" ()

DECLARE FUNCTION GetDoubleClickTime LIB "USER" () AS WORD
DECLARE SUB SetDoubleClickTime LIB "USER" (BYVAL wCount AS WORD)

DECLARE FUNCTION UnregisterClass LIB "USER" (lpClassName AS ASCIIZ, BYVAL hInstance AS WORD) AS WORD

DECLARE FUNCTION SetMessageQueue LIB "USER" (BYVAL cMsg AS WORD) AS WORD

DECLARE FUNCTION RegisterClass LIB "USER" (Temp AS WndClass) AS WORD
DECLARE FUNCTION CreateWindow LIB "USER" (lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ, BYVAL dwStyle AS DWORD, BYVAL X AS WORD, BYVAL Y AS WORD, BYVAL nWidth AS WORD, BYVAL nHeight AS WORD, _
                                          BYVAL hWndParent AS WORD, BYVAL hMenu AS WORD, BYVAL hInstance AS WORD, BYVAL lpParam AS DWORD) AS WORD
DECLARE FUNCTION CreateWindowEx LIB "USER" (BYVAL dwExStyle AS DWORD, lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ, BYVAL dwStyle AS DWORD, BYVAL X AS WORD, BYVAL Y AS WORD, _
                 BYVAL nWidth AS WORD, BYVAL nHeight AS WORD, BYVAL hWndParent AS WORD, BYVAL hMenu AS WORD, BYVAL hInstance AS WORD, BYVAL lpParam AS DWORD) AS WORD
DECLARE FUNCTION IsWindow LIB "USER" (BYVAL hWnd AS WORD) AS WORD
DECLARE FUNCTION IsChild LIB "USER" (BYVAL hWndParent AS WORD, BYVAL hWnd AS WORD) AS WORD
DECLARE FUNCTION DestroyWindow LIB "USER" (BYVAL hWnd AS WORD) AS WORD

DECLARE FUNCTION ShowWindow LIB "USER" (BYVAL hWnd AS WORD, BYVAL nCmdShow AS WORD) AS WORD
DECLARE FUNCTION FlashWindow LIB "USER" (BYVAL hWnd AS WORD, BYVAL bInvert AS WORD) AS WORD
DECLARE SUB ShowOwnedPopups LIB "USER" (BYVAL hWnd AS WORD, BYVAL fShow AS WORD)

DECLARE FUNCTION OpenIcon LIB "USER" (BYVAL hWnd AS WORD) AS WORD
DECLARE SUB CloseWindow LIB "USER" (BYVAL hWnd AS WORD)
DECLARE SUB MoveWindow LIB "USER" (BYVAL hWnd AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD, BYVAL nWidth AS WORD, BYVAL nHeight AS WORD, BYVAL bRepaint AS WORD)
DECLARE SUB SetWindowPos LIB "USER" (BYVAL hWnd AS WORD, BYVAL hWndInsertAfter AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD, BYVAL cx AS WORD, BYVAL cy AS WORD, BYVAL wFlags AS WORD)

DECLARE FUNCTION BeginDeferWindowPos LIB "USER" (BYVAL nNumWindows AS WORD) AS WORD
DECLARE FUNCTION DeferWindowPos LIB "USER" (BYVAL hWinPosInfo AS WORD, BYVAL hWnd AS WORD, BYVAL hWndInsertAfter AS WORD, BYVAL x AS WORD, BYVAL y AS WORD, BYVAL cx AS WORD, BYVAL cy AS WORD, BYVAL wFlags AS WORD) AS WORD
DECLARE SUB EndDeferWindowPos LIB "USER" (BYVAL hWinPosInfo AS WORD)

DECLARE FUNCTION AnyPopup LIB "USER" () AS WORD
DECLARE FUNCTION IsIconic LIB "USER" (BYVAL hWnd AS WORD) AS WORD
DECLARE FUNCTION IsWindowVisible LIB "USER" (BYVAL hWnd AS WORD) AS WORD
DECLARE FUNCTION IsZoomed LIB "USER" (BYVAL hWnd AS WORD) AS WORD
DECLARE SUB BringWindowToTop LIB "USER" (BYVAL hWnd AS WORD)

DECLARE FUNCTION MakeProcInstance LIB "KERNEL" (BYVAL Address AS DWORD, BYVAL hInst AS WORD) AS DWORD
DECLARE FUNCTION FreeProcInstance LIB "KERNEL" (BYVAL lpProc As DWORD) AS INTEGER
DECLARE FUNCTION CreateDialog LIB "USER" (BYVAL hInst AS WORD, lpCStr AS ASCIIZ, BYVAL hWndOwnder AS WORD, BYVAL dlgProc AS DWORD) AS WORD
DECLARE FUNCTION CreateDialogIndirect LIB "USER" (BYVAL hInst AS WORD, BYVAL DlgTmp AS DWORD, BYVAL hWndOwner AS WORD, BYVAL dlgProc AS DWORD) AS WORD
DECLARE FUNCTION CreateDialogIndirectParam LIB "USER" (BYVAL hInst AS WORD, BYVAL DlgTmp AS DWORD, BYVAL hWndOwner AS WORD, BYVAL dlgProc AS DWORD, BYVAL lParam AS DWORD) AS WORD
DECLARE FUNCTION CreateDialogParam LIB "USER" (BYVAL hInst AS WORD, lpCStr AS ASCIIZ, BYVAL hWndOwnder AS WORD, BYVAL dlgProc AS DWORD, BYVAL lParam AS DWORD) AS WORD
DECLARE FUNCTION DefDlgProc LIB "USER" (BYVAL hDlg AS WORD, BYVAL wMsg AS WORD, BYVAL wParam AS WORD, BYVAL lParam AS LONG) AS DWORD
DECLARE FUNCTION DialogBox LIB "USER" (BYVAL hInst AS WORD, lpCStr AS ASCIIZ, BYVAL hWndOwner AS WORD, BYVAL dlgProc AS DWORD) AS INTEGER
DECLARE FUNCTION DialogBoxIndirect LIB "USER" (BYVAL hInst AS WORD, BYVAL hGlobal AS WORD,  BYVAL hWndOwner AS WORD, BYVAL dlgProc AS DWORD) AS INTEGER
DECLARE FUNCTION DialogBoxIndirectParam LIB "USER" (BYVAL hInst AS WORD, BYVAL hGlobal AS WORD, BYVAL hWndOwner AS WORD, BYVAL dlgProc AS DWORD, BYVAL lParam AS DWORD) AS INTEGER
DECLARE FUNCTION DialogBoxParam LIB "USER" (BYVAL hInst AS WORD, lpCStr AS ASCIIZ, BYVAL hWndOwner AS WORD, BYVAL dlgProc AS DWORD, BYVAL lParam AS DWORD) AS WORD
DECLARE FUNCTION GetDialogBaseUnits LIB "USER" () AS DWORD
DECLARE FUNCTION GetDlgCtrlID LIB "USER" (BYVAL hWnd AS WORD) AS WORD
DECLARE FUNCTION GetDlgItem LIB "USER" (BYVAL hDlg AS WORD, BYVAL nIDDlgItem AS WORD) AS WORD
DECLARE FUNCTION GetDlgItemInt LIB "USER" (BYVAL hDlg AS WORD, BYVAL nIDDlgItem AS WORD, lpTranslated AS WORD, BYVAL bSigned AS WORD) AS WORD
DECLARE FUNCTION GetDlgItemText LIB "USER" (BYVAL hDlg AS WORD, BYVAL nIDDlgItem AS WORD, lpString AS ASCIIZ, BYVAL nMaxCount AS WORD) AS WORD
DECLARE FUNCTION GetNextDlgGroupItem LIB "USER" (BYVAL hDlg AS WORD, BYVAL hCtl AS WORD, BYVAL bPrevious AS WORD) AS WORD
DECLARE FUNCTION GetNextDlgTabItem LIB "USER" (BYVAL hDlg AS WORD, BYVAL hCtl AS WORD, BYVAL bPrevious AS WORD) AS WORD
DECLARE FUNCTION IsDlgButtonChecked LIB "USER" (BYVAL hDlg AS WORD, BYVAL nIDButton AS WORD) AS WORD
DECLARE FUNCTION SendDlgItemMessage LIB "USER" (BYVAL hDlg AS WORD, BYVAL nIDDlgItem AS WORD, BYVAL wMsg AS WORD, BYVAL wParam AS WORD, BYVAL lParam AS LONG) AS DWORD
DECLARE SUB CheckDlgButton LIB "USER" (BYVAL hDlg AS WORD, BYVAL nIDButton AS WORD, BYVAL wCheck AS WORD)
DECLARE SUB CheckRadioButton LIB "USER" (BYVAL hDlg AS WORD, BYVAL nIDFirstButton AS WORD, BYVAL nIDLastButton AS WORD, BYVAL nIDCheckButton AS WORD)
DECLARE SUB EndDialog LIB "USER" (BYVAL hDlg AS WORD, BYVAL nResult AS WORD)
DECLARE SUB SetDlgItemInt LIB "USER" (BYVAL hDlg AS WORD, BYVAL nIDDlgItem AS WORD, BYVAL wValue AS WORD, BYVAL bSigned AS WORD)
DECLARE SUB SetDlgItemText LIB "USER" (BYVAL hDlg AS WORD, BYVAL nIDDlgItem AS WORD, lpString AS ASCIIZ)

DECLARE FUNCTION CallMsgFilter LIB "USER" (lpMsg AS MsgStruc, BYVAL nCode AS WORD) AS WORD

' Clipboard Manager FUNCTIONs
DECLARE FUNCTION OpenClipboard LIB "USER" (BYVAL hWnd AS WORD) AS WORD
DECLARE FUNCTION CloseClipboard LIB "USER" () AS WORD
DECLARE FUNCTION GetClipboardOwner LIB "USER" () AS WORD
DECLARE FUNCTION SetClipboardViewer LIB "USER" (BYVAL hWnd AS WORD) AS WORD
DECLARE FUNCTION GetClipboardViewer LIB "USER" () AS WORD
DECLARE FUNCTION ChangeClipboardChain LIB "USER" (BYVAL hWnd AS WORD, BYVAL hWndNext AS WORD) AS WORD
DECLARE FUNCTION SetClipboardData LIB "USER" (BYVAL wFormat AS WORD, BYVAL hMem AS WORD) AS WORD
DECLARE FUNCTION GetClipboardData LIB "USER" (BYVAL wFormat AS WORD) AS WORD
DECLARE FUNCTION RegisterClipboardFormat LIB "USER" (lpString AS ASCIIZ) AS WORD
DECLARE FUNCTION CountClipboardFormats LIB "USER" () AS WORD
DECLARE FUNCTION EnumClipboardFormats LIB "USER" (BYVAL wFormat AS WORD) AS WORD
DECLARE FUNCTION GetClipboardFormatName LIB "USER" (BYVAL wFormat AS WORD, lpString AS ASCIIZ, BYVAL nMaxCount AS WORD) AS WORD
DECLARE FUNCTION EmptyClipboard LIB "USER" () AS WORD
DECLARE FUNCTION IsClipboardFormatAvailable LIB "USER" (BYVAL wFormat AS WORD) AS WORD
DECLARE FUNCTION GetPriorityClipboardFormat LIB "USER" (lpPriorityList AS WORD, BYVAL nCount AS WORD) AS WORD

DECLARE FUNCTION SetFocus LIB "USER" (BYVAL hWnd AS WORD) AS WORD
DECLARE FUNCTION GetFocus LIB "USER" () AS WORD
DECLARE FUNCTION GetActiveWindow LIB "USER" () AS WORD
DECLARE FUNCTION GetKeyState LIB "USER" (BYVAL nVirtKey AS WORD) AS WORD
DECLARE FUNCTION GetAsyncKeyState LIB "USER" (BYVAL vKey AS WORD) AS WORD
DECLARE SUB GetKeyboardState LIB "USER" (LpKeyState AS ANY)
DECLARE SUB SetKeyboardState LIB "USER" (lpKeyState AS ANY)
DECLARE FUNCTION EnableHardwareInput LIB "USER" (BYVAL bEnableInput AS WORD) AS WORD
DECLARE FUNCTION GetInputState LIB "USER" () AS WORD
DECLARE FUNCTION GetCapture LIB "USER" () AS WORD
DECLARE FUNCTION SetCapture LIB "USER" (BYVAL hWnd AS WORD) AS WORD
DECLARE SUB ReleaseCapture LIB "USER" ()

' Windows FUNCTIONs
DECLARE FUNCTION SetTimer LIB "USER" (BYVAL hWnd AS WORD, BYVAL nIDEvent AS WORD, BYVAL mSec AS WORD, BYVAL lpTimerProc AS DWORD) AS WORD
DECLARE FUNCTION KillTimer LIB "USER" (BYVAL hWnd AS WORD, BYVAL nIDEvent AS WORD) AS WORD

DECLARE FUNCTION EnableWindow LIB "USER" (BYVAL hWnd AS WORD, BYVAL aBOOL AS WORD) AS WORD
DECLARE FUNCTION IsWindowEnabled LIB "USER" (BYVAL hWnd AS WORD) AS WORD

DECLARE FUNCTION LoadAccelerators LIB "USER" (BYVAL hInstance AS WORD, lpTableName AS ASCIIZ) AS WORD

DECLARE FUNCTION TranslateAccelerator LIB "USER" (BYVAL hWnd AS WORD, BYVAL hAccTable AS WORD, lpMsg AS MsgStruc) AS WORD

DECLARE FUNCTION GetSystemMetrics LIB "USER" (BYVAL nIndex AS WORD) AS WORD

DECLARE FUNCTION LoadMenu LIB "USER" (BYVAL hInstance AS WORD, lpString AS ASCIIZ) AS WORD
DECLARE FUNCTION LoadMenuIndirect LIB "USER" (lpMenuTemplate AS ANY) AS WORD
DECLARE FUNCTION GetMenu LIB "USER" (BYVAL hWnd AS WORD) AS WORD
DECLARE FUNCTION SetMenu LIB "USER" (BYVAL hWnd AS WORD, BYVAL hMenu AS WORD) AS WORD
DECLARE FUNCTION ChangeMenu LIB "USER" (BYVAL hMenu AS WORD, BYVAL wID AS WORD, lpszNew AS ASCIIZ, BYVAL wIDNew AS WORD, BYVAL wChange AS WORD) AS WORD
DECLARE FUNCTION HiliteMenuItem LIB "USER" (BYVAL hWnd AS WORD, BYVAL hMenu AS WORD, BYVAL wIDHiliteItem AS WORD, BYVAL wHilite AS WORD) AS WORD
DECLARE FUNCTION GetMenuString LIB "USER" (BYVAL hMenu AS WORD, BYVAL wIDItem AS WORD, lpString AS ASCIIZ, BYVAL nMaxCount AS WORD, BYVAL wFlag AS WORD) AS WORD
DECLARE FUNCTION GetMenuState LIB "USER" (BYVAL hMenu AS WORD, BYVAL wId AS WORD, BYVAL wFlags AS WORD) AS WORD
DECLARE SUB DrawMenuBar LIB "USER" (BYVAL hWnd AS WORD)
DECLARE FUNCTION GetSystemMenu LIB "USER" (BYVAL hWnd AS WORD, BYVAL bRevert AS WORD) AS WORD
DECLARE FUNCTION CreateMenu LIB "USER" () AS WORD
DECLARE FUNCTION CreatePopupMenu LIB "USER" () AS WORD
DECLARE FUNCTION DestroyMenu LIB "USER" (BYVAL hMenu AS WORD) AS WORD
DECLARE FUNCTION CheckMenuItem LIB "USER" (BYVAL hMenu AS WORD, BYVAL wIDCheckItem AS WORD, BYVAL wCheck AS WORD) AS WORD
DECLARE FUNCTION EnableMenuItem LIB "USER" (BYVAL hMenu AS WORD, BYVAL wIDEnableItem AS WORD, BYVAL wEnable AS WORD) AS WORD
DECLARE FUNCTION GetSUBMenu LIB "USER" (BYVAL hMenu AS WORD, BYVAL nPos AS WORD) AS WORD
DECLARE FUNCTION GetMenuItemID LIB "USER" (BYVAL hMenu AS WORD, BYVAL nPos AS WORD) AS WORD
DECLARE FUNCTION GetMenuItemCount LIB "USER" (BYVAL hMenu AS WORD) AS WORD

DECLARE FUNCTION InsertMenu LIB "USER" (BYVAL hMenu AS WORD, BYVAL nPosition AS WORD, BYVAL wFlags AS WORD, BYVAL wIDNewItem AS WORD, lpNewItem AS ANY) AS WORD
DECLARE FUNCTION AppendMenu LIB "USER" (BYVAL hMenu AS WORD, BYVAL wFlags AS WORD, BYVAL wIDNewItem AS WORD, lpNewItem AS ASCIIZ) AS WORD
DECLARE FUNCTION ModifyMenu LIB "USER" (BYVAL hMenu AS WORD, BYVAL nPosition AS WORD, BYVAL wFlags AS WORD, BYVAL wIDNewItem AS WORD, lpString AS ASCIIZ) AS WORD
DECLARE FUNCTION RemoveMenu LIB "USER" (BYVAL hMenu AS WORD, BYVAL nPosition AS WORD, BYVAL wFlags AS WORD) AS WORD
DECLARE FUNCTION DeleteMenu LIB "USER" (BYVAL hMenu AS WORD, BYVAL nPosition AS WORD, BYVAL wFlags AS WORD) AS WORD
DECLARE FUNCTION SetMenuItemBitmaps LIB "USER" (BYVAL hMenu AS WORD, BYVAL nPosition AS WORD, BYVAL wFlags AS WORD, BYVAL hBitmapUnchecked AS WORD, BYVAL hBitmapChecked AS WORD) AS WORD
DECLARE FUNCTION GetMenuCheckMarkDimensions LIB "USER" () AS DWORD
DECLARE FUNCTION TrackPopupMenu LIB "USER" (BYVAL hMenu AS WORD, BYVAL wFlags AS WORD, BYVAL x AS WORD, BYVAL y AS WORD, BYVAL nReserved AS WORD, BYVAL hWnd AS WORD, lpReserved AS ANY) AS WORD

DECLARE SUB UpdateWindow LIB "USER" (BYVAL hWnd AS WORD)
DECLARE FUNCTION SetActiveWindow LIB "USER" (BYVAL hWnd AS WORD) AS WORD

DECLARE FUNCTION BeginPaint LIB "USER" (BYVAL hWnd AS WORD, lpPaint AS PAINTSTRUCT) AS WORD
DECLARE SUB EndPaint LIB "USER" (BYVAL hWnd AS WORD, lpPaint AS PAINTSTRUCT)
DECLARE FUNCTION GetUpdateRect LIB "USER" (BYVAL hWnd AS WORD, lpRect AS RECT, BYVAL bErase AS WORD) AS WORD
DECLARE FUNCTION GetUpdateRgn LIB "USER" (BYVAL hWnd AS WORD, BYVAL hRgn AS WORD, BYVAL fErase AS WORD) AS WORD

DECLARE FUNCTION ExcludeUpdateRgn LIB "USER" (BYVAL hDC AS WORD, BYVAL hWnd AS WORD) AS WORD

DECLARE SUB InvalidateRect LIB "USER" (BYVAL hWnd AS WORD, lpRect AS RECT, BYVAL bErase AS WORD)
DECLARE SUB ValidateRect LIB "USER" (BYVAL hWnd AS WORD, lpRect AS RECT)

DECLARE SUB InvalidateRgn LIB "USER" (BYVAL hWnd AS WORD, BYVAL hRgn AS WORD, BYVAL bErase AS WORD)
DECLARE SUB ValidateRgn LIB "USER" (BYVAL hWnd AS WORD, BYVAL hRgn AS WORD)

DECLARE SUB ScrollWindow LIB "USER" (BYVAL hWnd AS WORD, BYVAL XAmount AS WORD, BYVAL YAmount AS WORD, lpRect AS RECT, lpClipRect AS RECT)
DECLARE FUNCTION ScrollDC LIB "USER" (BYVAL hDC AS WORD, BYVAL dx AS WORD, BYVAL dy AS WORD, lprcScroll AS RECT, lprcClip AS RECT, BYVAL hRgnUpdate AS WORD, lprcUpdate AS RECT) AS WORD

DECLARE FUNCTION SetScrollPos LIB "USER" (BYVAL hWnd AS WORD, BYVAL nBar AS WORD, BYVAL nPos AS WORD, BYVAL bRedraw AS WORD) AS WORD
DECLARE FUNCTION GetScrollPos LIB "USER" (BYVAL hWnd AS WORD, BYVAL nBar AS WORD) AS WORD
DECLARE SUB SetScrollRange LIB "USER" (BYVAL hWnd AS WORD, BYVAL nBar AS WORD, BYVAL nMinPos AS WORD, BYVAL nMaxPos AS WORD, BYVAL bRedraw AS WORD)
DECLARE SUB GetScrollRange LIB "USER" (BYVAL hWnd AS WORD, BYVAL nBar AS WORD, lpMinPos AS WORD, lpMaxPos AS WORD)
DECLARE SUB ShowScrollBar LIB "USER" (BYVAL hWnd AS WORD, BYVAL wBar AS WORD, BYVAL bShow AS WORD)

DECLARE FUNCTION SetProp LIB "USER" (BYVAL hWnd AS WORD, lpString AS ASCIIZ, BYVAL hData AS WORD) AS WORD
DECLARE FUNCTION GetProp LIB "USER" (BYVAL hWnd AS WORD, lpString AS ASCIIZ) AS WORD
DECLARE FUNCTION RemoveProp LIB "USER" (BYVAL hWnd AS WORD, lpString AS ASCIIZ) AS WORD
DECLARE SUB SetWindowText LIB "USER" (BYVAL hWnd AS WORD, lpString AS ASCIIZ)
DECLARE FUNCTION GetWindowText LIB "USER" (BYVAL hWnd AS WORD, lpString AS ASCIIZ, BYVAL aint AS WORD) AS WORD
DECLARE FUNCTION GetWindowTextLength LIB "USER" (BYVAL hWnd AS WORD) AS WORD

DECLARE SUB GetClientRect LIB "USER" (BYVAL hWnd AS WORD, lpRect AS RECT)
DECLARE SUB GetWindowRect LIB "USER" (BYVAL hWnd AS WORD, lpRect AS RECT)
DECLARE SUB AdjustWindowRect LIB "USER" (lpRect AS RECT, BYVAL dwStyle AS DWORD, BYVAL bMenu AS WORD)
DECLARE SUB AdjustWindowRectEx LIB "USER" (lpRect AS RECT, BYVAL dsStyle AS DWORD, BYVAL bMenu AS WORD, BYVAL dwEsStyle AS DWORD)

DECLARE FUNCTION MessageBox LIB "USER" (BYVAL hWnd AS WORD, lpText AS ASCIIZ, lpCaption AS ASCIIZ, BYVAL wType AS WORD) AS WORD
DECLARE SUB MessageBeep LIB "USER" (BYVAL wType AS WORD)

DECLARE FUNCTION ShowCursor LIB "USER" (BYVAL bShow AS WORD) AS WORD
DECLARE SUB SetCursorPos LIB "USER" (BYVAL X AS WORD, BYVAL Y AS WORD)
DECLARE FUNCTION SetCursor LIB "USER" (BYVAL hCursor AS WORD) AS WORD
DECLARE SUB GetCursorPos LIB "USER" (lpPoint AS POINTAPI)
DECLARE SUB ClipCursor LIB "USER" (lpRect AS ANY)

DECLARE SUB CreateCaret LIB "USER" (BYVAL hWnd AS WORD, BYVAL hBitmap AS WORD, BYVAL nWidth AS WORD, BYVAL nHeight AS WORD)
DECLARE FUNCTION GetCaretBlinkTime LIB "USER" () AS WORD
DECLARE SUB SetCaretBlinkTime LIB "USER" (BYVAL wMSeconds AS WORD)
DECLARE SUB DestroyCaret LIB "USER" ()
DECLARE SUB HideCaret LIB "USER" (BYVAL hWnd AS WORD)
DECLARE SUB ShowCaret LIB "USER" (BYVAL hWnd AS WORD)
DECLARE SUB SetCaretPos LIB "USER" (BYVAL X AS WORD, BYVAL Y AS WORD)
DECLARE SUB GetCaretPos LIB "USER" (lpPoint AS POINTAPI)

DECLARE SUB ClientToScreen LIB "USER" (BYVAL hWnd AS WORD, lpPoint AS POINTAPI)
DECLARE SUB ScreenToClient LIB "USER" (BYVAL hWnd AS WORD, lpPoint AS POINTAPI)

DECLARE FUNCTION WindowFromPoint LIB "USER" (ptScreen AS ANY) AS WORD
DECLARE FUNCTION ChildWindowFromPoint LIB "USER" (BYVAL hWnd AS WORD, ptScreen AS ANY) AS WORD

DECLARE FUNCTION GetSysColor LIB "USER" (BYVAL nIndex AS WORD) AS DWORD
DECLARE SUB SetSysColors LIB "USER" (BYVAL nChanges AS WORD, lpSysColor AS WORD, lpColorValues AS DWORD)

DECLARE FUNCTION FillRgn LIB "GDI" (BYVAL hDC AS WORD, BYVAL hRgn AS WORD, BYVAL hBrush AS WORD) AS WORD
DECLARE FUNCTION FrameRgn LIB "GDI" (BYVAL hDC AS WORD, BYVAL hRgn AS WORD, BYVAL hBrush AS WORD, BYVAL nWidth AS WORD, BYVAL nHeight AS WORD) AS WORD
DECLARE FUNCTION InvertRgn LIB "GDI" (BYVAL hDC AS WORD, BYVAL hRgn AS WORD) AS WORD
DECLARE FUNCTION PaintRgn LIB "GDI" (BYVAL hDC AS WORD, BYVAL hRgn AS WORD) AS WORD
DECLARE FUNCTION PtInRegion LIB "GDI" (BYVAL hRgn AS WORD, BYVAL X AS WORD, BYVAL Y AS WORD) AS WORD

DECLARE FUNCTION CopyRect LIB "USER" (lpDestRect AS RECT, lpSourceRect AS RECT) AS WORD
DECLARE FUNCTION EqualRect LIB "USER" (lpRect1 AS RECT, lpRect2 AS RECT) AS WORD
DECLARE FUNCTION FillRect LIB "USER" (BYVAL hDC AS WORD, lpRect AS RECT, BYVAL hBrush AS WORD) AS WORD
DECLARE FUNCTION FrameRect LIB "USER" (BYVAL hDC AS WORD, lpRect AS RECT, BYVAL hBrush AS WORD) AS WORD
DECLARE FUNCTION IntersectRect LIB "USER" (lpDestRect AS RECT, lpSrc1Rect AS RECT, lpSrc2Rect AS RECT) AS WORD
DECLARE FUNCTION IsRectEmpty LIB "USER" (lpRect AS RECT) AS WORD
DECLARE FUNCTION PtInRect LIB "USER" (lpRect AS RECT, ptRect AS ANY) AS WORD
DECLARE FUNCTION RectInRegion LIB "USER" (BYVAL hRgn AS WORD, lpRect AS RECT) AS WORD
DECLARE FUNCTION RectVisible LIB "USER" (BYVAL hDC AS WORD, lpRect AS RECT) AS WORD
DECLARE FUNCTION UnionRect LIB "USER" (lpDestRect AS RECT, lpSrc1Rect AS RECT, lpSrc2Rect AS RECT) AS WORD
DECLARE SUB DrawFocusRect LIB "USER" (BYVAL hDC AS WORD, lpRect AS RECT)
DECLARE SUB InflateRect LIB "USER" (lpRect AS RECT, BYVAL X AS WORD, BYVAL Y AS WORD)
DECLARE SUB InvertRect LIB "USER" (BYVAL hDC AS WORD, lpRect AS RECT)
DECLARE SUB OffsetRect LIB "USER" (lpRect AS RECT, BYVAL X AS WORD, BYVAL Y AS WORD)
DECLARE SUB SetRect LIB "USER" (lpRect AS RECT, BYVAL X1 AS WORD, BYVAL Y1 AS WORD, BYVAL X2 AS WORD, BYVAL Y2 AS WORD)
DECLARE SUB SetRectEmpty LIB "USER" (lpRect AS RECT)

DECLARE FUNCTION GetCurrentTime LIB "USER" () AS DWORD
DECLARE FUNCTION GetTickCount LIB "USER" () AS DWORD

DECLARE FUNCTION GetClassLong LIB "USER" (BYVAL hWnd AS WORD, BYVAL nIndex AS WORD) AS DWORD
DECLARE FUNCTION GetClassWord LIB "USER" (BYVAL hWnd AS WORD, BYVAL nIndex AS WORD) AS WORD
DECLARE FUNCTION GetDesktopHwnd LIB "USER" () AS WORD
DECLARE FUNCTION GetDesktopWindow LIB "USER" () AS WORD
DECLARE FUNCTION GetWindowLong LIB "USER" (BYVAL hWnd AS WORD, BYVAL nIndex AS WORD) AS DWORD
DECLARE FUNCTION GetWindowWord LIB "USER" (BYVAL hWnd AS WORD, BYVAL nIndex AS WORD) AS WORD
DECLARE FUNCTION SetClassLong LIB "USER" (BYVAL hWnd AS WORD, BYVAL nIndex AS WORD, BYVAL dwNewDWORD AS DWORD) AS DWORD
DECLARE FUNCTION SetClassWord LIB "USER" (BYVAL hWnd AS WORD, BYVAL nIndex AS WORD, BYVAL wNewWord AS WORD) AS WORD
DECLARE FUNCTION SetWindowLong LIB "USER" (BYVAL hWnd AS WORD, BYVAL nIndex AS WORD, BYVAL dwNewDWORD AS DWORD) AS DWORD
DECLARE FUNCTION SetWindowWord LIB "USER" (BYVAL hWnd AS WORD, BYVAL nIndex AS WORD, BYVAL wNewWord AS WORD) AS WORD

DECLARE FUNCTION FindWindow LIB "USER" (lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ) AS WORD
DECLARE FUNCTION GetClassName LIB "USER" (BYVAL hWnd AS WORD, lpClassName AS ASCIIZ, BYVAL nMaxCount AS WORD) AS WORD
DECLARE FUNCTION GetLastActivePopup LIB "USER" (BYVAL hWndOwnder AS WORD) AS WORD
DECLARE FUNCTION GetNextWindow LIB "USER" (BYVAL hWnd AS WORD, BYVAL wFlag AS WORD) AS WORD
DECLARE FUNCTION GetParent LIB "USER" (BYVAL hWnd AS WORD) AS WORD
DECLARE FUNCTION GetTopWindow LIB "USER" (BYVAL hWnd AS WORD) AS WORD
DECLARE FUNCTION GetWindowTask LIB "USER" (BYVAL hWnd AS WORD) AS WORD
DECLARE FUNCTION SetParent LIB "USER" (BYVAL hWndChild AS WORD, BYVAL hWndNewParent AS WORD) AS WORD

DECLARE FUNCTION GetWindow LIB "USER" (BYVAL hWnd AS WORD, BYVAL wCmd AS WORD) AS WORD

' Resource Loading Routines
DECLARE FUNCTION LoadBitmap LIB "USER" (BYVAL hInstance AS WORD, lpBitmapName AS ASCIIZ) AS WORD
DECLARE FUNCTION LoadCursor LIB "USER" (BYVAL hInstance AS WORD, lpCursorName AS ASCIIZ) AS WORD
DECLARE FUNCTION CreateCursor LIB "USER" (BYVAL hInstance AS WORD, BYVAL nXhotspot AS WORD, BYVAL nYhotspot AS WORD, BYVAL nWidth AS WORD, BYVAL nHeight AS WORD, lpAndbitPlane AS ANY, lpXorbitPlane AS ANY) AS WORD
DECLARE FUNCTION DestroyCursor LIB "USER" (BYVAL hCursor AS WORD) AS WORD

DECLARE FUNCTION LoadIcon LIB "USER" (BYVAL hInstance AS WORD, lpIconName AS ASCIIZ) AS WORD
DECLARE FUNCTION CreateIcon LIB "USER" (BYVAL hInstance AS WORD, BYVAL nWidth AS WORD, BYVAL nHeight AS WORD, BYVAL nPlanes AS WORD, BYVAL nBitsPixel AS WORD, lpAndbits AS ANY, lpXorbits AS ANY) AS WORD
DECLARE FUNCTION DestroyIcon LIB "USER" (BYVAL hIcon AS WORD) AS WORD

DECLARE FUNCTION LoadString LIB "USER" (BYVAL hInstance AS WORD, BYVAL wID AS WORD, lpBuffer AS ASCIIZ, BYVAL nBufferMax AS WORD) AS WORD

DECLARE FUNCTION AddFontResource LIB "GDI" (lpFilename AS ASCIIZ) AS WORD
DECLARE FUNCTION RemoveFontResource LIB "GDI" (lpFilename AS ASCIIZ) AS WORD

' Dialog Manager Routines
DECLARE FUNCTION IsDialogMessage LIB "USER" (BYVAL hDlg AS WORD, lpMsg AS MsgStruc) AS WORD

DECLARE SUB MapDialogRect LIB "USER" (BYVAL hDlg AS WORD, lpRect AS RECT)

DECLARE FUNCTION DlgDirList LIB "USER" (BYVAL hDlg AS WORD, lpPathSpec AS ASCIIZ, BYVAL nIDListBox AS WORD, BYVAL nIDStaticPath AS WORD, BYVAL wFileType AS WORD) AS WORD
DECLARE FUNCTION DlgDirSelect LIB "USER" (BYVAL hDlg AS WORD, lpString AS ASCIIZ, BYVAL nIDListBox AS WORD) AS WORD
DECLARE FUNCTION DlgDirListComboBox LIB "USER" (BYVAL hDlg AS WORD, lpPathSpec AS ASCIIZ, BYVAL nIDComboBox AS WORD, BYVAL nIDStaticPath AS WORD, BYVAL wFileType AS WORD) AS WORD
DECLARE FUNCTION DlgDirSelectComboBox LIB "USER" (BYVAL hDlg AS WORD, lpString AS ASCIIZ, BYVAL nIDComboBox AS WORD) AS WORD

DECLARE FUNCTION BuildCommDCB LIB "USER" (lpDef AS ASCIIZ, lpDCB AS DCB) AS WORD
DECLARE FUNCTION ClearCommBreak LIB "USER" (BYVAL nCid AS WORD) AS WORD
DECLARE FUNCTION CloseComm LIB "USER" (BYVAL nCid AS WORD) AS WORD
DECLARE FUNCTION EscapeCommFUNCTION LIB "USER" (BYVAL nCid AS WORD, BYVAL nFunc AS WORD) AS WORD
DECLARE FUNCTION FlushComm LIB "USER" (BYVAL nCid AS WORD, BYVAL nQueue AS WORD) AS WORD
DECLARE FUNCTION GetCommEventMask LIB "USER" (BYVAL nCid AS WORD, BYVAL nEvtMask AS WORD) AS WORD
DECLARE FUNCTION GetCommState LIB "USER" (BYVAL nCid AS WORD, lpDCB AS DCB) AS WORD
DECLARE FUNCTION OpenComm LIB "USER" (lpComName AS ASCIIZ, BYVAL wInQueue AS WORD, BYVAL wOutQueue AS WORD) AS WORD
DECLARE FUNCTION ReadComm LIB "USER" (BYVAL nCid AS WORD, lpBuf AS ASCIIZ, BYVAL nSize AS WORD) AS WORD
DECLARE FUNCTION SetCommBreak LIB "USER" (BYVAL nCid AS WORD) AS WORD
DECLARE FUNCTION SetCommEventMask LIB "USER" (BYVAL nCid AS WORD, nEvtMask AS WORD) AS DWORD
DECLARE FUNCTION SetCommState LIB "USER" (lpDCB AS DCB) AS WORD
DECLARE FUNCTION TransmitCommChar LIB "USER" (BYVAL nCid AS WORD, BYVAL cChar AS WORD) AS WORD
DECLARE FUNCTION UngetCommChar LIB "USER" (BYVAL nCid AS WORD, BYVAL cChar AS WORD) AS WORD
DECLARE FUNCTION WriteComm LIB "USER" (BYVAL nCid AS WORD, lpBuf AS ASCIIZ, BYVAL nSize AS WORD) AS WORD

DECLARE FUNCTION DefFrameProc LIB "USER" (BYVAL hWnd AS WORD, BYVAL hWndMDIClient AS WORD, BYVAL wMsg AS WORD, BYVAL wParam AS WORD, BYVAL lParam AS DWORD) AS DWORD
DECLARE FUNCTION DefMDIChildProc LIB "USER" (BYVAL hWnd AS WORD, BYVAL wMsg AS WORD, BYVAL wParam AS WORD, BYVAL lParam AS DWORD) AS DWORD

DECLARE FUNCTION TranslateMDISysAccel LIB "USER" (BYVAL hWndClient AS WORD, lpMsg AS MsgStruc) AS WORD

DECLARE FUNCTION ArrangeIconicWindows LIB "USER" (BYVAL hWnd AS WORD) AS WORD

DECLARE FUNCTION WinHelp LIB "USER" (BYVAL hWnd AS WORD, lpHelpFile AS ASCIIZ, BYVAL wCommand AS WORD, BYVAL dwData AS DWORD) AS WORD

' function declarations for profiler routines contained in Windows libraries
DECLARE FUNCTION ProfInsChk LIB "USER" () AS WORD
DECLARE SUB ProfSetup LIB "USER" (BYVAL nBufferSize AS WORD, BYVAL nSamples AS WORD)
DECLARE SUB ProfSampRate LIB "USER" (BYVAL nRate286 AS WORD, BYVAL nRate386 AS WORD)
DECLARE SUB ProfStart LIB "USER" ()
DECLARE SUB ProfStop LIB "USER" ()
DECLARE SUB ProfClear LIB "USER" ()
DECLARE SUB ProfFlush LIB "USER" ()
DECLARE SUB ProfFinish LIB "USER" ()

DECLARE FUNCTION GetFreeSystemResources LIB "USER" (BYVAL fuSysResource AS WORD) AS WORD

DECLARE SUB LogError LIB "KERNEL" (BYVAL uErr AS WORD, lpvInfo AS ANY)

DECLARE FUNCTION GetWinDebugInfo LIB "KERNEL" (lpwdi AS WINDEBUGINFO, BYVAL flags AS WORD) AS WORD
DECLARE FUNCTION SetWinDebugInfo LIB "KERNEL" (lpwdi AS WINDEBUGINFO) AS WORD
DECLARE SUB DebugOutput LIB "KERNEL" (flags AS WORD, lpszFmt AS ASCIIZ)

DECLARE FUNCTION ExitWindowsExec LIB "USER" (lpszExe AS ASCIIZ, lpszParams AS ASCIIZ) AS WORD
DECLARE FUNCTION IsBadReadPtr LIB "KERNEL" (BYVAL lp AS DWORD, BYVAL cb AS WORD) AS WORD
DECLARE FUNCTION IsBadWritePtr LIB "KERNEL" (BYVAL lp AS DWORD, BYVAL cb AS WORD) AS WORD
DECLARE FUNCTION IsBadStringPtr LIB "KERNEL" (lpsz AS ASCIIZ, BYVAL cchMax AS WORD) AS WORD
DECLARE FUNCTION IsTask LIB "KERNEL" (BYVAL htask AS WORD) AS WORD

DECLARE FUNCTION lstrcpyn LIB "KERNEL" (lpszString1 AS ASCIIZ, lpszString2 AS ASCIIZ, BYVAL cChars AS WORD) AS DWORD
DECLARE FUNCTION IsDBCSLeadByte LIB "KERNEL" (BYVAL bTestChar AS WORD) AS WORD

' Drawing bounds accumulation APIs
DECLARE FUNCTION SetBoundsRect LIB "GDI" (BYVAL hdc AS WORD, lprcBounds AS RECT, BYVAL flags AS WORD) AS WORD
DECLARE FUNCTION GetBoundsRect LIB "GDI" (BYVAL hdc AS WORD, lprcBounds AS RECT, BYVAL flags AS WORD) AS WORD

DECLARE FUNCTION SetWindowOrgEx LIB "GDI" (BYVAL hdc AS WORD, BYVAL nX AS WORD, BYVAL nY AS WORD, lpPoint AS POINTAPI) AS WORD
DECLARE FUNCTION GetWindowOrgEx LIB "GDI" (BYVAL hdc AS WORD, lpPoint AS POINTAPI) AS WORD
DECLARE FUNCTION SetWindowExtEx LIB "GDI" (BYVAL hdc AS WORD, BYVAL nX AS WORD, BYVAL nY AS WORD, lpSize AS SIZE) AS WORD
DECLARE FUNCTION GetWindowExtEx LIB "GDI" (BYVAL hdc AS WORD, lpSize AS SIZE) AS WORD
DECLARE FUNCTION OffsetWindowOrgEx LIB "GDI" (BYVAL hdc AS WORD, BYVAL nX AS WORD, BYVAL nY AS WORD, lpPoint AS POINTAPI) AS WORD
DECLARE FUNCTION ScaleWindowExtEx LIB "GDI" (BYVAL hdc AS WORD, BYVAL nXnum AS WORD, BYVAL nXdenom AS WORD, BYVAL nYnum AS WORD, BYVAL nYdenom AS WORD, lpSize AS SIZE) AS WORD
DECLARE FUNCTION SetViewportExtEx LIB "GDI" (BYVAL hdc AS WORD, BYVAL nX AS WORD, BYVAL nY AS WORD, lpSize AS SIZE) AS WORD
DECLARE FUNCTION GetViewportExtEx LIB "GDI" (BYVAL hdc AS WORD, lpSize AS SIZE) AS WORD
DECLARE FUNCTION SetViewportOrgEx LIB "GDI" (BYVAL hdc AS WORD, BYVAL nX AS WORD, BYVAL nY AS WORD, lpPoint AS POINTAPI) AS WORD
DECLARE FUNCTION GetViewportOrgEx LIB "GDI" (BYVAL hdc AS WORD, lpPoint AS POINTAPI) AS WORD
DECLARE FUNCTION OffsetViewportOrgEx LIB "GDI" (BYVAL hdc AS WORD, BYVAL nX AS WORD, BYVAL nY AS WORD, lpPoint AS POINTAPI) AS WORD
DECLARE FUNCTION ScaleViewportExtEx LIB "GDI" (BYVAL hdc AS WORD, BYVAL nXnum AS WORD, BYVAL nXdenom AS WORD, BYVAL nYnum AS WORD, BYVAL nYdenom AS WORD, lpSize AS SIZE) AS WORD

DECLARE FUNCTION GetBrushOrgEx LIB "GDI" (BYVAL hdc AS WORD, lpPoint AS POINTAPI) AS WORD
DECLARE FUNCTION MoveToEx LIB "GDI" (BYVAL hdc AS WORD, BYVAL x AS WORD, BYVAL y AS WORD, lpPoint AS POINTAPI) AS WORD
DECLARE FUNCTION GetCurrentPositionEx LIB "GDI" (BYVAL hdc AS WORD, lpPoint AS POINTAPI) AS WORD
DECLARE FUNCTION GetTextExtentPoint LIB "GDI" (BYVAL hdc AS WORD, lpszString AS ASCIIZ, BYVAL cbString AS WORD, lpSize AS SIZE) AS WORD

DECLARE FUNCTION GetAspectRatioFilterEx LIB "GDI" (BYVAL hdc AS WORD, lpAspectRatio AS SIZE) AS WORD

DECLARE FUNCTION GetOutlineTextMetrics LIB "GDI" (BYVAL hdc AS WORD, BYVAL cbData AS WORD, lpotm AS OUTLINETEXTMETRIC) AS WORD

DECLARE FUNCTION GetFontData LIB "GDI" (BYVAL hdc AS WORD, BYVAL dwTable AS DWORD, BYVAL dwOffset AS DWORD, lpvBuffer AS ASCIIZ, BYVAL cbData AS DWORD) AS DWORD
DECLARE FUNCTION CreateScalableFontResource LIB "GDI" (BYVAL fHidden AS WORD, lpszResourceFile AS ASCIIZ, lpszFontFile AS ASCIIZ, lpszCurrentPath AS ASCIIZ) AS WORD

DECLARE FUNCTION GetGlyphOutline LIB "GDI" (BYVAL hdc AS WORD, BYVAL uChar AS WORD, BYVAL fuFormat AS WORD, lpgm AS GLYPHMETRICS, BYVAL cbBuffer AS DWORD, lpBuffer AS ASCIIZ, lpmat2 AS MAT2) AS DWORD

DECLARE FUNCTION GetCharABCWidths LIB "GDI" (BYVAL hdc AS WORD, BYVAL uFirstChar AS WORD, BYVAL uLastChar AS WORD, lpabc AS ABC) AS WORD

DECLARE FUNCTION GetRasterizerCaps LIB "GDI" (lpraststat AS RASTERIZER_STATUS, BYVAL cb AS WORD) AS WORD
DECLARE FUNCTION SetBitmapDimensionEx LIB "GDI" (BYVAL hbm AS WORD, BYVAL nX AS WORD, BYVAL nY AS WORD, lpSize AS SIZE) AS WORD
DECLARE FUNCTION GetBitmapDimensionEx LIB "GDI" (BYVAL hBitmap AS WORD, lpDimension AS SIZE) AS WORD
DECLARE FUNCTION SetMetaFileBitsBetter LIB "GDI" (BYVAL hmt AS WORD) AS WORD

DECLARE FUNCTION StartDoc LIB "GDI" (BYVAL hdc AS WORD, lpdi AS DOCINFO) AS WORD
DECLARE FUNCTION StartPage LIB "GDI" (BYVAL hdc AS WORD) AS WORD
DECLARE FUNCTION EndPage LIB "GDI" (BYVAL hdc AS WORD) AS WORD
DECLARE FUNCTION EndDoc LIB "GDI" (BYVAL hdc AS WORD) AS WORD
DECLARE FUNCTION AbortDoc LIB "GDI" (BYVAL hdc AS WORD) AS WORD
DECLARE FUNCTION SpoolFile LIB "GDI" (lpszPrinter AS ASCIIZ, lpszPort AS ASCIIZ, lpszJob AS ASCIIZ, lpszFile AS ASCIIZ) AS WORD

DECLARE FUNCTION SystemParametersInfo LIB "USER" (BYVAL uAction AS WORD, BYVAL uParam AS WORD, lpvParam AS ANY, BYVAL fuWinIni AS WORD) AS WORD

DECLARE FUNCTION GetMessageExtraInfo LIB "USER" () AS DWORD
DECLARE FUNCTION GetQueueStatus LIB "USER" (BYVAL fuFlags AS WORD) AS DWORD

DECLARE FUNCTION GetWindowPlacement LIB "USER" (BYVAL hWnd AS WORD, lpwndpl AS WINDOWPLACEMENT) AS INTEGER
DECLARE FUNCTION SetWindowPlacement LIB "USER" (BYVAL hWnd AS WORD, lpwndpl AS WINDOWPLACEMENT) AS INTEGER

DECLARE SUB MapWindowPoints LIB "USER" (BYVAL hWndFrom AS WORD, BYVAL hWndTo AS WORD, lppt AS POINTAPI, BYVAL cPoints AS WORD)
DECLARE FUNCTION GetDCEx LIB "USER" (BYVAL hWnd AS WORD, BYVAL hrgnclip AS WORD, BYVAL fdwOptions AS DWORD) AS WORD

DECLARE FUNCTION LockWindowUpdate LIB "USER" (BYVAL hWndLock AS WORD) AS WORD
DECLARE FUNCTION RedrawWindow LIB "USER" (BYVAL hWnd AS WORD, lprcUpdate AS RECT, BYVAL hrgnUpdate AS WORD, BYVAL fuRedraw AS WORD) AS WORD

DECLARE FUNCTION ScrollWindowEx LIB "USER" (BYVAL hWnd AS WORD, BYVAL dx AS WORD, BYVAL dy AS WORD, lprcScroll AS RECT, lprcClip AS RECT, BYVAL hrgnUpdate AS WORD, lprcUpdate AS RECT, BYVAL fuScroll AS WORD) AS WORD

DECLARE FUNCTION IsMenu LIB "USER" (BYVAL hmenu AS WORD) AS WORD

DECLARE FUNCTION GetOpenClipboardWindow LIB "USER" () AS WORD
DECLARE FUNCTION CopyCursor LIB "USER" (BYVAL hinst AS WORD, BYVAL hcur AS WORD) AS WORD
DECLARE FUNCTION GetCursor LIB "USER" () AS WORD
DECLARE SUB GetClipCursor LIB "USER" (lprc AS RECT)
DECLARE FUNCTION CopyIcon LIB "USER" (BYVAL hinst AS WORD, BYVAL hicon AS WORD) AS WORD

DECLARE FUNCTION UnhookWindowsHookEx LIB "USER" (BYVAL hHook AS WORD) AS WORD
DECLARE FUNCTION CallNextHookEx LIB "USER" (BYVAL hHook AS WORD, BYVAL ncode AS WORD, BYVAL wParam AS WORD, lParam AS ANY) AS DWORD

DECLARE FUNCTION QuerySendMessage LIB "USER" (BYVAL hreserved1 AS WORD, BYVAL hreserved2 AS WORD, BYVAL hreserved3 AS WORD, lpMessage AS ASCIIZ) AS WORD
DECLARE FUNCTION LockInput LIB "USER" (BYVAL hReserved AS WORD, BYVAL hWndInput AS WORD, BYVAL fLock AS WORD) AS WORD
DECLARE FUNCTION GetSystemDebugState LIB "USER" () AS DWORD
DECLARE FUNCTION EnableCommNotification LIB "USER" (BYVAL idComDev AS WORD, BYVAL hWnd AS WORD, BYVAL cbWriteNotify AS WORD, BYVAL OutQueue AS WORD) AS WORD

' Windows driver support
DECLARE FUNCTION DefDriverProc LIB "USER" (BYVAL dwDriverIdentifier AS DWORD, BYVAL hdrvr AS WORD, BYVAL umsg AS WORD, lParam1 AS ANY, lParam2 AS ANY) AS DWORD
DECLARE FUNCTION OpenDriver LIB "USER" (lpDriverName AS ASCIIZ, lpSectionName AS ASCIIZ, lParam AS ANY) AS WORD
DECLARE FUNCTION CloseDriver LIB "USER" (BYVAL hdrvr AS WORD, lParam1 AS ANY, lParam2 AS ANY) AS DWORD
DECLARE FUNCTION SendDriverMessage LIB "USER" (BYVAL hdrvr AS WORD, BYVAL nMsg AS WORD, lParam1 AS ANY, lParam2 AS ANY) AS DWORD
DECLARE FUNCTION GetDriverModuleHandle LIB "USER" (BYVAL hdrvr AS WORD) AS WORD
DECLARE FUNCTION GetNextDriver LIB "USER" (BYVAL hdrvr AS WORD, BYVAL fdwFlag AS DWORD) AS WORD
DECLARE FUNCTION GetDriverInfo LIB "USER" (BYVAL hdrvr AS WORD, lpdis AS DRIVERINFOSTRUCT) AS WORD

' Windows network support
DECLARE FUNCTION WNetAddConnection LIB "USER" (lpszNetPath AS ASCIIZ, lpszPassword AS ASCIIZ, lpszLocalName AS ASCIIZ) AS WORD
DECLARE FUNCTION WNetCancelConnection LIB "USER" (lpszName AS ASCIIZ, BYVAL bForce AS WORD) AS WORD
DECLARE FUNCTION WNetGetConnection LIB "USER" (lpszLocalName AS ASCIIZ, lpszRemoteName AS ASCIIZ, cbRemoteName AS WORD) AS WORD

' Shell Support
DECLARE FUNCTION ShellExecute LIB "SHELL" (BYVAL hWnd AS WORD, szOp AS ASCIIZ, szFile AS ASCIIZ, szParams AS ASCIIZ, szDir AS ASCIIZ, BYVAL fsShowCmd AS WORD) AS WORD
DECLARE FUNCTION ExtractIcon LIB "SHELL" (BYVAL hInst AS WORD, lpszExeFileName AS ASCIIZ, BYVAL nIconIndex AS WORD) AS WORD
DECLARE FUNCTION FindExecutable LIB "SHELL" (lpFile AS ASCIIZ, lpDirectory AS ASCIIZ, lpResult AS ASCIIZ) AS DWORD

' Registry Support
DECLARE FUNCTION RegOpenKey LIB "SHELL" (BYVAL hKey AS DWORD, szSubKey AS ASCIIZ, lphkResult AS DWORD) AS DWORD
DECLARE FUNCTION RegCreateKey LIB "SHELL" (BYVAL hKey AS DWORD, szSubKey AS ASCIIZ, lphkResult AS DWORD) AS DWORD
DECLARE FUNCTION RegCloseKey LIB "SHELL" (BYVAL hKey AS DWORD) AS DWORD
DECLARE FUNCTION RegDeleteKey LIB "SHELL" (BYVAL hKey AS DWORD, szSubKey AS ASCIIZ) AS DWORD
DECLARE FUNCTION RegSetValue LIB "SHELL" (BYVAL hKey AS DWORD, szSubKey AS ASCIIZ, BYVAL fdwType AS DWORD, szValue AS ASCIIZ, BYVAL cb AS DWORD) AS DWORD
DECLARE FUNCTION RegQueryValue LIB "SHELL" (BYVAL hKey AS DWORD, szSubKey AS ASCIIZ, Value AS ASCIIZ, cb AS LONG) AS DWORD
DECLARE FUNCTION RegEnumKey LIB "SHELL" (BYVAL hKey AS DWORD, BYVAL iSubKey AS DWORD, szBuffer AS ASCIIZ, BYVAL cb AS DWORD) AS DWORD

' Drag and Drop Support
DECLARE FUNCTION DragQueryFile LIB "SHELL" (BYVAL hDrop AS WORD, BYVAL iFile AS WORD, szFile AS ASCIIZ, BYVAL cb AS WORD) AS WORD
DECLARE FUNCTION DragQueryPoint LIB "SHELL" (BYVAL hDrop AS WORD, Pt AS POINTAPI) AS INTEGER
DECLARE SUB DragFinish LIB "SHELL" (BYVAL hDrop AS WORD)
DECLARE SUB DragAcceptFiles LIB "SHELL" (BYVAL hWnd AS WORD, BYVAL bool AS INTEGER)
